function varargout = CellCultureChip(varargin)
% CELLCULTURECHIP M-file for CellCultureChip.fig
%      CELLCULTURECHIP, by itself, creates a new CELLCULTURECHIP or raises the existing
%      singleton*.
%
%      H = CELLCULTURECHIP returns the handle to a new CELLCULTURECHIP or the handle to
%      the existing singleton*.
%
%      CELLCULTURECHIP('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CELLCULTURECHIP.M with the given input arguments.
%
%      CELLCULTURECHIP('Property','Value',...) creates a new CELLCULTURECHIP or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before CellCultureChip_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to CellCultureChip_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text1 to modify the response to help CellCultureChip

% Last Modified by GUIDE v2.5 18-Dec-2012 20:13:07

% Global variables with all handles and application data
% CCChs = handles to GUI objects
% CCCdata = Application data
global CCChs CCCdata;

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @CellCultureChip_OpeningFcn, ...
    'gui_OutputFcn',  @CellCultureChip_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes just before CellCultureChip is made visible.
function CellCultureChip_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to CellCultureChip (see VARARGIN)

% Global variables with all handles and application data
% CCChs = handles to GUI objects
% CCCdata = Application data
global CCChs CCCdata;
CCChs = handles;

% Choose default command line output for CellCultureChip
handles.output = hObject;

% Create array with input manifold valve handles
for ii = 1:16
    CCChs.in(ii) = handles.(['i' num2str(ii)]);
end

% Create array with mux bit handles
tmp = {'0a', '0b', '0c', '1a', '1b', '1c', '2a', '2b', '3a', '3b', '4a', '4b', '5a', '5b'};
nn = length(tmp);
for ii = 1:nn
    CCChs.MuxBits(ii) = handles.(['Mux' tmp{ii}]);
end

% Initialize number of chambers
CCCdata.NumChambers = 96;

% Draw chambers
draw_chambers;
% Draw piping cartoon
draw_piping;

% Read and set valve numbers and startup values
CCCdata.Valves.VcConfigFName = 'ValveControllers.txt';
CCCdata.Valves.VnumFName = 'ValveNumbers.txt';
ValvesInit;

% Initialize script execution
ScriptInit;

% Update handles structure
guidata(hObject, handles);

warning off

% UIWAIT makes CellCultureChip wait for user response (see UIRESUME)
uiwait(handles.CellCultureChip);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Outputs from this function are returned to the command line.
function varargout = CellCultureChip_OutputFcn(hObject, eventdata, handles)

global CCChs CCCdata;

% Close scripting system
ScriptClose;
% Close valve control system
ValvesClose;

% Stop & delete fluo time update timer

varargout{1} = handles.output; % 0;

clear global CCCdata;
clear global CCChs;

cd(pwd);

% Close GUI
delete(handles.CellCultureChip);


% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % --- Executes when user attempts to close CellCultureChip.
function CellCultureChip_CloseRequestFcn(hObject, eventdata, handles)

global CCChs CCCdata;

%Quit_Callback(hObject, eventdata, handles);

if isequal(get(CCChs.CellCultureChip, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, use UIRESUME
    uiresume(CCChs.CellCultureChip);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Logs an error message to text a file
function log_error(fcn_name, msg)

global CCChs CCCdata;

try
    tt = now;
    log_file = [pwd '\CellCultureChip_ERRORS.txt']; %[datestr(tt, 'mmddYY-HH.MM.SS') '_ERROR.txt'];
    % Open file and log error info
    logfid = fopen(log_file, 'at');
    fprintf(logfid, '%s\n\tFunction: %s\n', datestr(tt), fcn_name);
    fprintf(logfid, '\tError message: %s\n', msg);
    fclose(logfid);
catch
    beep;
    set(CCChs.Msg, 'String', ['ERROR!  log_error' 10 13 lasterr]);
end

clear CCChs CCCdata;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Reads location names and positions from a file
function [num, names, pos, dims, calib1, calib2] = read_chip_loc(fname)
% File has a list of location names, positions, and dimensions
% LocationName <TAB> Xpos <TAB> Ypos <TAB> width <TAB> height
% i.e. 5 <TAB> 3.4 <TAB> 7.9 <TAB> 300 <TAB> 100
%      ChipCenter <TAB> 2.9 <TAB> 24 <TAB> 0 <TAB> 0
% Special location names are calib1 and calib2, which specify two positions
% for calibration. These locations should be located at the end of the list
% of locations, and in the right order (calib1 before calib2):
%    calib1 <TAB> Loc#1 <TAB> 0 <TAB> 0 <TAB> 0
%    calib2 <TAB> Loc#2 <TAB> 0 <TAB> 0 <TAB> 0
% Loc#1 and Loc#2 refer to the numbers of the locations to use for
% calibration. Locations are numbered from 1, starting with the first one
% on the list.

global CCChs CCCdata;

try
    names = {};
    pos = [];
    dims = [];
    calib1 = [];
    calib2 = [];
    if ~exist(fname, 'file')
        infodlg('Title', 'Chip locations file', 'String', ['Chip locations file ' 10 13 '"' fname '"' 10 13 'does not exist!']);
    else
        [names, pos(:, 1), pos(:, 2), dims(:, 1), dims(:, 2)] = textread(fname, '%s\t%f\t%f\t%f\t%f\n', ...
            'whitespace', '\r\n\t', 'commentstyle', 'matlab');
        num = length(names);
        if ~num
            infodlg('Title', 'Chip locations file', 'String', 'Chip locations file is empty!');
        else
            % Extract calibration points
            if strcmp(lower(names(num-1)), 'calib1') && strcmp(lower(names(num)), 'calib2')
                calib1 = pos(num-1, 1);
                calib2 = pos(num, 1);
                names = names(1:end-2);
                pos = pos(1:end-2, :);
                dims = dims(1:end-2, :);
                num = num - 2;
            else
                % RK % infodlg('Title', 'Chip locations file', 'String', 'Calibration points are absent or incorrectly defined');
            end
        end
    end
catch
    beep;
    msg = lasterr;
    set(CCChs.Msg, 'String', ['ERROR!  read_chip_loc' 10 13 msg]);
    log_error('read_chip_loc', msg);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Draw chambers
function draw_chambers

global CCChs CCCdata;

set(CCChs.ChipImage, 'NextPlot', 'add');
set(CCChs.ChipImage, 'XTick', []);
set(CCChs.ChipImage, 'YTick', []);


CCCdata.XY.LocFName = 'ChipLocations.txt';
% Read chip locations from file
[CCCdata.XY.NumLocations CCCdata.XY.Names, CCCdata.XY.Pos, ...
    CCCdata.XY.Dims, CCCdata.XY.Calib1, CCCdata.XY.Calib2] = read_chip_loc(CCCdata.XY.LocFName);


xmin = min(CCCdata.XY.Pos(:, 1));
xmax = max(CCCdata.XY.Pos(:, 1));
ymin = min(CCCdata.XY.Pos(:, 2));
ymax = max(CCCdata.XY.Pos(:, 2));
CCChs.ChamberPlot.MarkerSize = 5;
for ii = 1:CCCdata.XY.NumLocations
    x = CCCdata.XY.Pos(ii, 1);
    y = CCCdata.XY.Pos(ii, 2);
    if ii <= CCCdata.NumChambers
        str = 'ks';
    else
        str = 'k+';
    end
    CCChs.ChamberPlot.h(ii) = plot(CCChs.ChipImage, x, y, str);
    set(CCChs.ChamberPlot.h(ii), 'MarkerSize', CCChs.ChamberPlot.MarkerSize);
    set(CCChs.ChamberPlot.h(ii), 'MarkerFaceColor', [1 1 1]);
end;
dx = abs(xmax - xmin);
set(CCChs.ChipImage, 'XLim', [xmin - 0.02*dx, xmax + 0.02*dx]);
dy = abs(ymax - ymin);
set(CCChs.ChipImage, 'YLim', [ymin - 0.1*dy, ymax + 0.1*dy]);
% Lock the axes so that drawing is not damaged by external plotting
% commands
set(CCChs.ChipImage, 'HandleVisibility', 'off');

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Draw piping cartoon
function draw_piping

global CCChs CCCdata;

set(CCChs.PipingDiagram, 'NextPlot', 'add');
set(CCChs.PipingDiagram, 'XTick', []);
set(CCChs.PipingDiagram, 'YTick', []);
ph = plot(CCChs.PipingDiagram, [0 1], [0 1], '.');
set(ph, 'MarkerEdgeColor', [212 208 200]/255);
% FlushWaste
line([0.49, 0.49], [0.1, 0.8], 'LineWidth', 2, 'color', 'black', 'Parent', CCChs.PipingDiagram);
line([0, 0.49], [0.1, 0.1], 'LineWidth', 2, 'color', 'black', 'Parent', CCChs.PipingDiagram);
% BeadsIn
line([0.31, 0.31], [0.25, 0.8], 'LineWidth', 2, 'color', 'black', 'Parent', CCChs.PipingDiagram);
line([0, 0.31], [0.25, 0.25], 'LineWidth', 2, 'color', 'black', 'Parent', CCChs.PipingDiagram);
% MixerOut to CellsIn
line([0, 1], [0.80, 0.80], 'LineWidth', 2, 'color', 'black', 'Parent', CCChs.PipingDiagram);
% To chambers
line([0.73, 0.73], [0, 1], 'LineWidth', 3, 'color', 'black', 'Parent', CCChs.PipingDiagram);
% Pump
line([0.6, 0.6], [0.7, 1], 'LineWidth', 4, 'color', 'black', 'Parent', CCChs.PipingDiagram);
line([0.63, 0.63], [0.7, 1], 'LineWidth', 4, 'color', 'black', 'Parent', CCChs.PipingDiagram);
line([0.66, 0.66], [0.7, 1], 'LineWidth', 4, 'color', 'black', 'Parent', CCChs.PipingDiagram);
% Lock the axes so that drawing is not damaged by external plotting
% commands
set(CCChs.PipingDiagram, 'HandleVisibility', 'off');

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get default path for saving all data
function Path_CreateFcn(hObject, eventdata)

global CCChs CCCdata;

CCCdata.DataPath = get(hObject, 'String');

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Path value has been updated manually
function Path_Callback(hObject, eventdata)

global CCChs CCCdata;

str = get(hObject, 'String');
if ~isempty(str) &&  (str(end) ~= '\')
    str = [str '\'];
    set(hObject, 'String', str);
end
CCCdata.DataPath = str;

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get new path for saving all data
function DataFolder_Callback(hObject, eventdata)

global CCChs CCCdata;

folder = uigetdir(CCCdata.DataPath, 'Please select a folder for data storage');
if folder
    if folder(end) ~= '\'
        folder = [folder '\'];
    end
    CCCdata.DataPath = folder;
    set(CCChs.Path, 'String', folder);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Update the Valve Controller info display
function VcUpdate_Callback(hObject, eventdata)

global CCChs CCCdata;

VcUpdate;

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Reset the valve controllers.
% It re-reads the valve configuration file
function VcReset_Callback(hObject, eventdata)

global CCChs CCCdata;

% Close valve system
ValvesClose;
% Initialize the valves
ValvesInit;

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update the Valve Controller info display.
function VcUpdate

global CCChs CCCdata;

num = get(CCChs.VcNumber, 'Value');
if num > CCCdata.vc.num
    set(CCChs.VcNumber, 'Value', CCCdata.vc.num);
    num = CCCdata.vc.num;
end
set(CCChs.VcHandle, 'String', ['  ' num2str(CCCdata.vc.info(num).handle)]);
set(CCChs.VcSerialNum, 'String', ['  ' CCCdata.vc.info(num).sn]);
pol = [67 67 67].*CCCdata.vc.info(num).polarity([1 9 17]) + [79 79 79].*(~CCCdata.vc.info(num).polarity([1 9 17]));
set(CCChs.VcPolarity, 'String', ['  ' char(pol)]);
status = CCCdata.vc.info(num).status;
set(CCChs.VcStatus, 'String', num2str(status));
if status
    set(CCChs.VcStatus, 'BackgroundColor', 'red');
else
    set(CCChs.VcStatus, 'BackgroundColor', 'white');
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Create VC number popup
function VcNumber_CreateFcn(hObject, eventdata)

global CCChs CCCdata;

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

set(hObject, 'Value', 11);

clear CCChs CCCdata;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Close all the valves on the chip
function close_all_valves()

global CCChs CCCdata;

close_inputs;
set_mux(99, 1, 1, 1, 1, 1);
for ii = 18:CCCdata.Valves.Num
    set_valve(CCCdata.Valves.Names{ii}, 1);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Open all the valves on the chip
function open_all_valves()

global CCChs CCCdata;

open_inputs([1:16]);
set_mux(101, 1, 1, 0, 0, 0);
for ii = 18:CCCdata.Valves.Num
    set_valve(CCCdata.Valves.Names{ii}, 0);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Close all the valves on the chip
function CloseAll_Callback(hObject, eventdata)

global CCChs CCCdata;

% Close all valves
close_all_valves();

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Open all the chip
function OpenAll_Callback(hObject, eventdata)

global CCChs CCCdata;

opt = YesNoQuestion('Title', 'Open All Valves', 'String', ...
    'Are you sure you want to open all the valves?');
switch lower(opt)
    case 'yes'
        % Open all valves
        open_all_valves();
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on menu select in About.
function About_Callback(hObject, eventdata)

str = {'Cell Culture Chip Control System'; 'Ver. 2, June 2006'; ...
    'For Cell Culture Chip 2.2 only!'; ...
    'Rafael Gmez-Sjberg'; 'Quake Lab'; 'Stanford University'};
img = imread('about_pic3.bmp');
aboutdlg('Title', 'Cell Culture Chip v.2', 'String', str, 'Image', img);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on menu select in Quit.
function Quit_Callback(hObject, eventdata, handles)

global CCChs CCCdata;

opt = YesNoQuestion('Title', 'Quit', 'String', ...
    'Are you sure you want to quit?');
switch lower(opt)
    case 'yes'
        %{
        % Close scripting system
        ScriptClose;
        % Close valve control system
        ValvesClose;
        % Close XY controller
        XYClose;
        % Close video system
        VideoClose;
        % Close scope handling system
        ScopeClose;
        % Stop & delete fluo time update timer
        stop(CCCdata.Fluo.Timer);
        delete(CCCdata.Fluo.Timer);

        clear global CCCdata;
        clear global CCChs;

        cd(pwd);

        % Close GUI
        delete(gcf);
        %}
        % Close GUI
        uiresume(CCChs.CellCultureChip);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Creation function for all valve buttons
function valve_CreateFcn(hObject, eventdata)

global CCChs CCCdata;

set(hObject, 'BackgroundColor', [0 0.2 0]);
set(hObject, 'Value', 0);
set(hObject, 'UserData', 0);

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for all non-input manifold valve buttons
function valve_Callback(hObject, eventdata)

global CCChs CCCdata;

v = get(hObject, 'Value');
n = get(hObject, 'UserData');
CCCdata.vc = vc_set_bits(CCCdata.vc, n, v);
% Read value back to verify
[CCCdata.vc, v] = vc_get_bits(CCCdata.vc, n);
set(hObject, 'Value', v);
if v
    % Valve is closed
    set(hObject, 'BackgroundColor', [0 1 0]);
else
    % Valve is open
    set(hObject, 'BackgroundColor', [0 0.2 0]);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Creation function for all valve numbers
function valveNum_CreateFcn(hObject, eventdata)

global CCChs CCCdata;

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
set(hObject, 'String', 'x');

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for all valve numbers
function valveNum_Callback(hObject, eventdata)

global CCChs CCCdata;

tag = get(hObject, 'Tag');
name = tag(1:end-3);
v = str2double(get(hObject, 'String'));
if (v >= 0) && ((v/24) < CCCdata.vc.num)
    set(CCChs.(name), 'UserData', v);
else
    v = get(CCChs.(name), 'UserData');
    set(hObject, 'String', num2str(v));
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for all input manifold valve buttons
function ix_Callback(hObject, eventdata)

global CCChs CCCdata;

v = get(hObject, 'Value');
if v
    % Valve is closed
    set(hObject, 'BackgroundColor', [1 0 0]);
else
    % Valve is open
    set(hObject, 'BackgroundColor', [0.5 0 0]);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Input Manifold Switch
function SwitchIn_Callback(hObject, eventdata)

global CCChs CCCdata;

numbers = cell2mat(get(CCChs.in, 'UserData'))'
values = cell2mat(get(CCChs.in, 'Value'))'
%CCCdata.vc = vc_set_bits(CCCdata.vc, numbers(1:8), values(1:8))
%CCCdata.vc = vc_set_bits(CCCdata.vc, numbers(9:16), values(9:16))

nv = length(CCChs.in);
for ii = 1:nv
    CCCdata.vc = vc_set_1bit(CCCdata.vc,numbers(ii),values(ii));
    if values(ii)
        set(CCChs.in(ii), 'BackgroundColor', [0 1 0])
    else
        set(CCChs.in(ii), 'BackgroundColor', [0 0.2 0])
    end
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Input Manifold Switch
function CloseIn_Callback(hObject, eventdata)

global CCChs CCCdata;

close_inputs;

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Creation function for Mux bits
function MuxBit_CreateFcn(hObject, eventdata)

global CCChs CCCdata;

% Deactivate the bit control
set(hObject, 'Enable', 'inactive');

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Creation function for Mux chamber number
function MuxChamber_CreateFcn(hObject, eventdata)
% chamber = 97 --> "All Chambers". All flush open or all chambers open,
%                  depending on value of flush
% chamber = 98 --> "All Closed + flush". All valves closed. Flush can be actuated.
% chamber = 99 --> "All Closed". All valves closed, including flush
% chamber = 100 --> "All Open + flush". All valves open. Flush can be actuated.
% chamber = 101 --> "All Open". All valves open, including flush
% chamber = 102 --> "Manual"

global CCChs CCCdata;

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
chambers = '';
for ii = 1:96
    chambers = strvcat(chambers, num2str(ii));
end
chambers = strvcat(chambers, 'All Chambers', 'All Closed + Flush', 'All Closed', 'All Open + Flush', 'All Open', 'Manual', ' ');
set(hObject, 'String', chambers);
% Start with all closed
set(hObject, 'Value', 98);

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Creation function for Mux group size
function MuxGroupSize_CreateFcn(hObject, eventdata)

global CCChs CCCdata;

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
groups = {'1'; '2'; '4'; '6'; '8'; '12'; '16'; '24'; '32'; '48'};
set(hObject, 'String', groups);
% Start with individual chambers
set(hObject, 'Value', 1);

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Creation function for Mux group level
function MuxGroupLevel_CreateFcn(hObject, eventdata)

global CCChs CCCdata;

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
set(hObject, 'String', '1');

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Mux Bit manual controls
function MuxBit_Callback(hObject, eventdata)

global CCChs CCCdata;

CCCdata.Mux.RawBits = cell2mat(get(CCChs.MuxBits, 'Value'))';
nb = length(CCCdata.Mux.RawBits);
numbers = CCCdata.Mux.First:(CCCdata.Mux.First + nb - 1);
% Re-order bits for chip v. 2.0
CCCdata.vc = vc_set_bits(CCCdata.vc, numbers, CCCdata.Mux.RawBits(CCCdata.Mux.BitOrder));
set(CCChs.MuxBitsStr, 'String', num2str(CCCdata.Mux.RawBits));
update_chamber_plot;
CCCdata.Mux.Bits = CCCdata.Mux.RawBits;

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get numeric value of popup selection
function value = get_popup_num(h)

global CCChs CCCdata;

values = get(h, 'String');
idx = get(h, 'Value');
if iscell(values)
    value = str2double(values{idx});
else
    value = str2double(values);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update list of mux grouping levels available
function update_MuxGroupLevels

global CCChs CCCdata;

old_level = get_popup_num(CCChs.MuxGroupLevel);
if CCCdata.Mux.GrpSize == 1
    CCCdata.Mux.GrpLevels = {'1'};
    CCCdata.Mux.GrpLevel = 1;
else
    fname = [pwd '\MuxGrouping_' num2str(CCCdata.Mux.GrpSize) '.mat'];
    if ~exist(fname, 'file')
        infodlg('Title', 'Mux Grouping Levels', 'String', 'Grouping levels file not found!');
        CCCdata.Mux.GrpLevels = '1';
        CCCdata.Mux.GrpLevel = 1;
        CCCdata.Mux.GrpValves = {};
        CCCdata.Mux.GrpSize = 1;
        set(CCChs.MuxGroupSize, 'String', '1');
        set(CCChs.MuxGroupSize, 'Value', 1);
    else
        d = load(fname, 'levels', 'valves');
        CCCdata.Mux.GrpLevels = d.levels;
        CCCdata.Mux.GrpValves = d.valves;
        nl = length(d.levels);
        if old_level > nl
            CCCdata.Mux.GrpLevel = nl;
        else
            CCCdata.Mux.GrpLevel = old_level;
        end
    end
end
set(CCChs.MuxGroupLevel, 'String', CCCdata.Mux.GrpLevels);
set(CCChs.MuxGroupLevel, 'Value', CCCdata.Mux.GrpLevel);
drawnow;

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Mux Group Size popup
function MuxGroupSize_Callback(hObject, eventdata)

global CCChs CCCdata;

CCCdata.Mux.GrpSize = get_popup_num(CCChs.MuxGroupSize);
update_MuxGroupLevels;
Mux_Callback(hObject, eventdata);

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Find which chambers are open based on the MUX bits
function chambers = demux(bits)

% Assume all chambers are open
% 1 = open chamber, 0 = closed chamber
ch = ones(1, 96);

% Chamber numbers corresponding to each valve
v4 = [1 2 7 8 13 14 19 20 25 26 31 32 37 38 43 44 49 50 55 56 61 62 67 68 73 74 79 80 85 86 91 92];
v7 = [1:6 13:18 25:30 37:42 49:54 61:66 73:78 85:90];
v9 = [1:12 25:36 49:60 73:84];
v11 = [1:24 49:72];
v13 = [1:48];
ch_num = {[1:2:95];
    [];
    [2:2:96];
    v4 + 2;
    v4;
    v4 + 4;
    v7;
    v7 + 6;
    v9;
    v9 + 12;
    v11;
    v11 + 24;
    v13;
    v13 + 48};

% Eliminate sets of chambers controlled by each valve
for ii = [14:-1:3 1]
    if bits(ii)
        ch(ch_num{ii}) = 0;
    end
    if ~sum(ch)
        break
    end
end

% Get indexes of open chambers
chambers = find(ch);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Change chamber plot to indicate which chambers are open
function update_chamber_plot

global CCChs CCCdata;

% Reset old chambers
set(CCChs.ChamberPlot.h(CCCdata.Mux.OpenChambers), 'MarkerFaceColor', ...
    [1 1 1]);
%set(CCChs.ChamberPlot(old_chambers), 'MarkerEdgeColor', [1 0 0]);
%GlobalChIn = get(CCChs.ChIn, 'Value');
if (CCCdata.Mux.Flush && ~CCCdata.Mux.FlushOnly) ...
        || CCCdata.Mux.InClosed || CCCdata.Mux.ChInClosed
    clr = [0 0 1];
else
    clr = [0 0.9 1];
end
if (CCCdata.Mux.GrpSize == 1) && (CCCdata.Mux.Chamber <= 96) && ...
        (CCCdata.Mux.Chamber >= 1)
    % Set new chamber
    set(CCChs.ChamberPlot.h(CCCdata.Mux.Chamber), 'MarkerFaceColor', clr);
    % Save chamber status
    CCCdata.Mux.OpenChambers = CCCdata.Mux.Chamber;
else
    % Compute current chamber status
    new_chambers = demux(CCCdata.Mux.RawBits);
    % Set new chambers
    set(CCChs.ChamberPlot.h(new_chambers), 'MarkerFaceColor', clr);
    % Save chamber status
    CCCdata.Mux.OpenChambers = new_chambers;
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update MUX display
function MuxUpdate

global CCChs CCCdata;

set(CCChs.MuxChamber, 'Value', CCCdata.Mux.Chamber);
set(CCChs.MuxGroupSize, 'Value', CCCdata.Mux.GrpSizePvtTbl(CCCdata.Mux.GrpSize));
set(CCChs.MuxGroupLevel, 'Value', CCCdata.Mux.GrpLevel);
set(CCChs.MuxFlush, 'Value', CCCdata.Mux.Flush);
set(CCChs.MuxInClosed, 'Value', CCCdata.Mux.InClosed);
set(CCChs.MuxChInClosed, 'Value', CCCdata.Mux.ChInClosed);
set(CCChs.MuxBitsStr, 'String', num2str(CCCdata.Mux.Bits));
nb = length(CCCdata.Mux.Bits);
for ii = 1:nb
    set(CCChs.MuxBits(ii), 'Value', CCCdata.Mux.Bits(ii));
end
update_chamber_plot;

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Mux
function Mux_Callback(hObject, eventdata)
% chamber = 97 --> "All Chambers". All flush open or all chambers open,
%                  depending on value of flush
% chamber = 98 --> "All Closed + flush". All valves closed. Flush can be actuated.
% chamber = 99 --> "All Closed". All valves closed, including flush
% chamber = 100 --> "All Open + flush". All valves open. Flush can be actuated.
% chamber = 101 --> "All Open". All valves open, including flush
% chamber = 102 --> "Manual"

global CCChs CCCdata;

GroupSize = get_popup_num(CCChs.MuxGroupSize);
GroupLevel = get(CCChs.MuxGroupLevel, 'Value');
Chamber = get(CCChs.MuxChamber, 'Value');
write = 1;
if Chamber == 102
    % Manual control
    % Activate the bit controls
    set(CCChs.MuxBits, 'Enable', 'on');
    % Deactivate controls
    set(CCChs.MuxGroupSize, 'Enable', 'off');
    set(CCChs.MuxGroupLevel, 'Enable', 'off');
    set(CCChs.MuxFlush, 'Enable', 'off');
    set(CCChs.MuxInClosed, 'Enable', 'off');
    set(CCChs.MuxChInClosed, 'Enable', 'off');
    % Do not write any values to the Mux
    write = 0;
else
    Flush = get(CCChs.MuxFlush, 'Value');
    InClosed = get(CCChs.MuxInClosed, 'Value');
    ChInClosed = get(CCChs.MuxChInClosed, 'Value');
end
if write
    % Deactivate the bit controls
    set(CCChs.MuxBits, 'Enable', 'inactive');
    % Activate controls
    set(CCChs.MuxGroupSize, 'Enable', 'on');
    set(CCChs.MuxGroupLevel, 'Enable', 'on');
    set(CCChs.MuxFlush, 'Enable', 'on');
    set(CCChs.MuxInClosed, 'Enable', 'on');
    set(CCChs.MuxChInClosed, 'Enable', 'on');
    set_mux(Chamber, GroupSize, GroupLevel, Flush, InClosed, ChInClosed);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for 1st bit of Mux
function Mux1st_Callback(hObject, eventdata)

global CCChs CCCdata;

first = str2double(get(hObject, 'String'));
last = first + 13;
cn1 = floor(first/24) + 1;
cn2 = floor(last/24) + 1;
% Check to see is mux bits are in a valid controller and if all
% bits are on the same controller
if (first > 0) && ((first/24) < CCCdata.vc.num) && ((last/24) < CCCdata.vc.num) ...
        && (cn1 == cn2)
    CCCdata.Mux.First = first;
    % Store good value as backup
    set(hObject, 'UserData', first);
else
    % Restore old value
    old_first = get(hObject, 'UserData');
    set(hObject, 'String', num2str(old_first));
end

clear CCChs CCCdata;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Close valve control system
function ValvesClose

global CCChs CCCdata;

try
    set(CCChs.Msg, 'String', 'Closing valve control system');
    % Stop pumping timer
    stop(CCCdata.Pump.Timer);
    pause(1);
    delete(CCCdata.Pump.Timer);
    % Close valve controllers and unload library
    CCCdata.vc = vc_close(CCCdata.vc, 1);
catch
    beep;
    msg = lasterr;
    set(CCChs.Msg, 'String', ['ERROR!  ValvesClose' 10 13 msg]);
    log_error('ValvesClos', msg);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initialize valve values and numbers as read from file
function ValvesInit

global CCChs CCCdata;

set(CCChs.Msg, 'String', 'Initializing Valves');

% List of valve names
CCCdata.Valves.Names = {'i1', 'i2', 'i3', 'i4', 'i5', 'i6', 'i7', 'i8', ...
    'i9', 'i10', 'i11', 'i12', 'i13', 'i14', 'i15', 'i16', 'InPurge', ...
    'SvOut', 'SvIn', 'ChOut', 'ChIn', 'MixerOut', 'Waste1Up', ...
    'Waste2Up', 'Waste1Dn', 'Waste2Dn', 'Flush', 'BeadsIn', ...
    'CellsIn', 'Pmp1', 'Pmp2', 'Pmp3'};
CCCdata.Valves.Num = length(CCCdata.Valves.Names);

% Initialize Mux data
CCCdata.Mux.Chamber = 0;
CCCdata.Mux.GrpValves = {};
CCCdata.Mux.GrpSizePvtTbl = [1 2 1 3 1 4 1 5 1 1 1 6 1 1 1 7 ones(1, 7) 8 ones(1, 7) 9 ones(1, 15) 10];
CCCdata.Mux.OpenChambers = [];
CCCdata.Mux.Bits = zeros(1, 14);
CCCdata.Mux.RawBits = zeros(1, 14);
% Order for chip v. 2.0
CCCdata.Mux.BitOrder = [13 14  12  11  10   9   8   7   6    5   4   3   1   2];

% Initialize Pump data
CCCdata.Pump.Running = 0;
CCCdata.Pump.Timer = timer('Period', CCCdata.Pump.Period, ...
    'TasksToExecute', 400, 'TimerFcn', @PumpingFcn, ...
    'StopFcn', @PumpStopFcn, ...
    'BusyMode', 'queue', 'ExecutionMode', 'fixedSpacing');
set(CCCdata.Pump.Timer, 'Name', 'PumpTimer');
CCCdata.Pump.FrwdSequence = {[0 0 1]; [1 0 1]; [1 0 0]; [1 1 0]; [1 1 1]};
CCCdata.Pump.BkwdSequence = {[1 0 0]; [1 0 1]; [0 0 1]; [0 1 1]; [1 1 1]};
CCCdata.Pump.SeqIndex = 1;
CCCdata.Pump.ValveNumbers = [];
CCCdata.Pump.Counter = 400;
CCCdata.Pump.StopFlag = 0;
pump_direction('forward');

% Read valve configuration file
CCCdata.Valves.VcConfigFName;
CCCdata.vc = vc_read_config(CCCdata.Valves.VcConfigFName);
% Open valve controllers
CCCdata.vc = vc_open_setup(CCCdata.vc);
pause(0.5);
% Update VC display
VcUpdate;
% Read valve numbers and values
read_valves(CCCdata.Valves.VnumFName);

set(CCChs.Msg, 'String', 'Valves Initialized');

clear CCChs CCCdata;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Read valve values and numbers from file
function read_valves(fname)

global CCChs CCCdata;

if ~exist(fname, 'file')
    error(['Valve number file "' fname '" does not exist!']);
else
    [names nums vals] = textread(fname, '%s\t%u\t%u\n', ...
        'whitespace', '\r\n\t', 'commentstyle', 'matlab');
    nn = length(names);
    if ~nn
        error('Valve numer file is empty!');
    elseif nn < 21
        error('Invalid number of valves in the file!');
    else
        for ii = 1:nn
            value = vals(ii);
            number = nums(ii);
            name = names{ii};
            switch lower(name)
                case 'mux'
                    % Set MUX
                    set_mux(value, 1, 1, 0, 0, 0, number);
                case 'xxxx'
                    if (value == 1) || (value == 0)
                        CCCdata.vc = vc_set_bits(CCCdata.vc, number, value);
                    end
                otherwise
                    init_valve(name, number, value);
            end
        end
    end
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Creation function for Pump period text box
function PumpPeriod_CreateFcn(hObject, eventdata)

global CCChs CCCdata;

CCCdata.Pump.Period = 0.1;
set(hObject, 'String', num2str(CCCdata.Pump.Period));
set(hObject, 'UserData', CCCdata.Pump.Period);

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Pump Period text-box
function PumpPeriod_Callback(hObject, eventdata)

global CCChs CCCdata;

per = str2double(get(hObject, 'String'));
if ~CCCdata.Pump.Running && (per > 0.002)
    CCCdata.Pump.Period = per;
    set(hObject, 'UserData', per);
else
    per = get(hObject, 'UserData');
    set(hObject, 'String', num2str(per, '%4.2f'));
    set(hObject, 'UserData', per);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Creation function for Pump cycles text box
function PumpCycles_CreateFcn(hObject, eventdata)

global CCChs CCCdata;

CCCdata.Pump.Cycles = 100;
set(hObject, 'String', num2str(CCCdata.Pump.Cycles));
set(hObject, 'UserData', CCCdata.Pump.Cycles);

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Pump cycles text-box
function PumpCycles_Callback(hObject, eventdata)

global CCChs CCCdata;

cycles = str2double(get(hObject, 'String'));
if ~CCCdata.Pump.Running && (cycles > 0)
    CCCdata.Pump.Cycles = fix(cycles);
    set(hObject, 'UserData', fix(cycles));
else
    cycles = get(hObject, 'UserData');
    set(hObject, 'String', num2str(cycles, '%4.2e'));
    set(hObject, 'UserData', cycles);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Pump direction button
function PumpDir_Callback(hObject, eventdata)

global CCChs CCCdata;

if CCCdata.Pump.Frwd
    pump_direction('backward');
else
    pump_direction('forward');
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set value of all valves in the pump
function set_pump(values)

global CCChs CCCdata;

set_valve('Pmp1', values(1));
set_valve('Pmp2', values(2));
set_valve('Pmp3', values(3));

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Close all valves in the pump
function PumpClose_Callback(hObject, eventdata)

set_pump([1 1 1]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Open all valves in the pump
function PumpOpen_Callback(hObject, eventdata)

set_pump([0 0 0]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Pump Stop button
function PumpStop_Callback(hObject, eventdata)

global CCChs CCCdata;

if CCCdata.Pump.Running
    if CCCdata.Pump.TimerFlag
        % We are using the pump timer, so stop it
        stop(CCCdata.Pump.Timer);
    else
        % We are not using the pump timer
        CCCdata.Pump.StopFlag = 1;
    end
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Pump Run button
function PumpRun_Callback(hObject, eventdata)

global CCChs CCCdata;

if ~CCCdata.Pump.Running
    % Get pump valve numbers
    vnum(1) = str2double(get(CCChs.Pmp1Num, 'String'));
    vnum(2) = str2double(get(CCChs.Pmp2Num, 'String'));
    vnum(3) = str2double(get(CCChs.Pmp3Num, 'String'));
    CCCdata.Pump.ValveNumbers = vnum;
    % Get current pump valve states
    CCCdata.Pump.State(1) = get(CCChs.Pmp1, 'Value');
    CCCdata.Pump.State(2) = get(CCChs.Pmp2, 'Value');
    CCCdata.Pump.State(3) = get(CCChs.Pmp3, 'Value');
    
    set(CCChs.Pmp1, 'Enable', 'off');
    set(CCChs.Pmp2, 'Enable', 'off');
    set(CCChs.Pmp3, 'Enable', 'off');
    set(CCChs.Pmp1Num, 'Enable', 'off');
    set(CCChs.Pmp2Num, 'Enable', 'off');
    set(CCChs.Pmp3Num, 'Enable', 'off');
    set(CCChs.PumpOpen, 'Enable', 'off');
    set(CCChs.PumpClose, 'Enable', 'off');
    set(CCChs.PumpRun, 'BackgroundColor', 'red');
    set(CCChs.PumpRun, 'String', 'Stop');
    
    set(CCChs.PumpRun, 'Callback', 'CellCultureChip(''PumpStop_Callback'', gcbo, [])');
    CCCdata.Pump.Running = 1;
    if 0 %rk CCCdata.Pump.Period >= 0.1
        % Pump using timer
        CCCdata.Pump.TimerFlag = 1;
        % Set timer period and number of cycles
        set(CCCdata.Pump.Timer, 'Period', CCCdata.Pump.Period, ...
            'TasksToExecute', CCCdata.Pump.Cycles * CCCdata.Pump.SeqLength);
        % Set pump to start of sequence
        CCCdata.Pump.SeqIndex = 1;
        CCCdata.Pump.Counter = CCCdata.Pump.Cycles;
        % Start the pump
        start(CCCdata.Pump.Timer);
    else
        % Pump with a loop
        CCCdata.Pump.TimerFlag = 0;
        CCCdata.Pump.StopFlag = 0;
        per = abs(CCCdata.Pump.Period - 0.002);
        for ii = CCCdata.Pump.Cycles:-1:1
            set(CCChs.PumpCycles, 'String', ii);
            for jj = 1:CCCdata.Pump.SeqLength
                pattern = CCCdata.Pump.Sequence{jj};
                CCCdata.vc = vc_set_bits(CCCdata.vc, vnum, pattern);
                pause(per);
            end
            if CCCdata.Pump.StopFlag
                break;
            end
        end
        PumpStopFcn([], []);
    end
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Cleanup after the pump stops
function PumpStopFcn(hObject, eventdata)

global CCChs CCCdata;

CCCdata.Pump.Running = 0;
CCCdata.Pump.StopFlag = 0;
% Restore original pump state
CCCdata.vc = vc_set_bits(CCCdata.vc, CCCdata.Pump.ValveNumbers, ...
    CCCdata.Pump.State);
% Restore Run button and cycles display
set(CCChs.PumpCycles, 'String', CCCdata.Pump.Cycles);
set(CCChs.PumpRun, 'BackgroundColor', [212 208 200]/255);
set(CCChs.PumpRun, 'String', 'Run');
set(CCChs.PumpRun, 'Callback', 'CellCultureChip(''PumpRun_Callback'',gcbo,[])');
% Enable pump valve control
set(CCChs.Pmp1, 'Enable', 'on');
set(CCChs.Pmp2, 'Enable', 'on');
set(CCChs.Pmp3, 'Enable', 'on');
set(CCChs.Pmp1Num, 'Enable', 'on');
set(CCChs.Pmp2Num, 'Enable', 'on');
set(CCChs.Pmp3Num, 'Enable', 'on');
set(CCChs.PumpOpen, 'Enable', 'on');
set(CCChs.PumpClose, 'Enable', 'on');

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Run the pump with the timer
function PumpingFcn(hObject, eventdata)

global CCChs CCCdata;

try
    % Pump with repeated firings of the timer
    pattern = CCCdata.Pump.Sequence{CCCdata.Pump.SeqIndex};
    CCCdata.vc = vc_set_bits(CCCdata.vc, CCCdata.Pump.ValveNumbers, pattern);
    if CCCdata.Pump.SeqIndex == CCCdata.Pump.SeqLength
        CCCdata.Pump.SeqIndex = 1;
        CCCdata.Pump.Counter = CCCdata.Pump.Counter - 1;
        set(CCChs.PumpCycles, 'String', CCCdata.Pump.Counter);
    else
        CCCdata.Pump.SeqIndex = CCCdata.Pump.SeqIndex + 1;
    end
catch
    beep;
    msg = lasterr;
    set(CCChs.Msg, 'String', ['ERROR!  PumpingFcn' 10 13 msg]);
    log_error('PumpingFcn', msg);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set values of Mux control panel and actuate Mux
function set_mux(Chamber, GroupSize, GroupLevel, Flush, InClosed, ChInClosed, First)
% FIRST is an optional parameter
% chamber = 97 --> "All Chambers". All flush open or all chambers open,
%                  depending on value of flush
% chamber = 98 --> "All Closed + flush". All valves closed. Flush can be actuated.
% chamber = 99 --> "All Closed". All valves closed, including flush
% chamber = 100 --> "All Open + flush". All valves open. Flush can be actuated.
% chamber = 101 --> "All Open". All valves open, including flush
% chamber = 102 --> "Manual"

global CCChs CCCdata;

try
    CCCdata.Mux.GrpSize = GroupSize;
    CCCdata.Mux.GrpLevel = GroupLevel;
    update_MuxGroupLevels;
    if nargin == 7
        set(CCChs.Mux1st, 'String', First);
        set(CCChs.Mux1st, 'UserData', First);
        CCCdata.Mux.First = First;
    end
    if (CCCdata.Mux.Chamber ~= 99) && ((CCCdata.Mux.Chamber ~= Chamber) || (CCCdata.Mux.Flush ~= Flush))
        % First close all mux before selecting a new chamber
        % if it wasn't already closed
        % "Break before make'
        CCCdata.Mux.Chamber = 99;
        [CCCdata.vc, CCCdata.Mux] = mux_control(CCCdata.vc, CCCdata.Mux);
        set(CCChs.MuxBitsStr, 'String', num2str(CCCdata.Mux.Bits));
        pause(0.5);
    end
    if Chamber ~= 99
        % Then set the new configuration
        CCCdata.Mux.Chamber = Chamber;
        CCCdata.Mux.Flush = Flush;
        CCCdata.Mux.InClosed = InClosed;
        CCCdata.Mux.ChInClosed = ChInClosed;
        [CCCdata.vc, CCCdata.Mux] = mux_control(CCCdata.vc, CCCdata.Mux);
    end
    MuxUpdate;
    update_chamber_plot;
    drawnow;
catch
    beep;
    msg = lasterr;
    set(CCChs.Msg, 'String', ['ERROR!  set_mux' 10 13 msg]);
    log_error('set_mux', msg);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Compute MUX bit values based on the chamber number
function bits = mux_bits(Mux)
% Creates bits in straight order (as on chip 1.1)
% Bits:    0a  0b  0c  1a  1b  1c  2a  2b  3a  3b  4a  4b  5a  5b
% Numbers: 1   2   3   4   5   6   7   8   9   10  11  12  13  14

if Mux.Chamber <= 48
    Mux.Chamber = 49 - Mux.Chamber;
end
Mux.Chamber = Mux.Chamber - 1;
div = 48;
bits = zeros(1, 14);
for ii = 14:-2:8
    v = (Mux.Chamber <= (div - 1));
    bits(ii) = v;
    bits(ii - 1) = ~v;
    Mux.Chamber = mod(Mux.Chamber, div);
    div = div/2;
end
switch Mux.Chamber
    case {0, 1}
        bits(4:6) = [1 0 1];
    case {2, 3}
        bits(4:6) = [0 1 1];
    case {4, 5}
        bits(4:6) = [1 1 0];
    otherwise
        bits(4:6) = [1 1 1];
end
Mux.Chamber = mod(Mux.Chamber, 2);
switch Mux.Chamber
    case 0
        bits([1:3]) = [0 0 1];
    case 1
        bits([1:3]) = [1 0 0];
    otherwise
        bits([1:3]) = [1 0 1];
end
if Mux.GrpSize > 1
    bits(Mux.GrpValves(Mux.GrpLevel, :)) = 0;
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Control MUX
function [vc, Mux] = mux_control(vc, Mux)
% chamber = 97 --> "All Chambers". All flush open or all chambers open,
%                  depending on value of flush
% chamber = 98 --> "All Closed + flush". All valves closed. Flush can be actuated.
% chamber = 99 --> "All Closed". All valves closed, including flush
% chamber = 100 --> "All Open + flush". All valves open. Flush can be actuated.
% chamber = 101 --> "All Open". All valves open, including flush

Mux.FlushOnly = 0;
if (Mux.Chamber > 0) &&  (Mux.Chamber <=96)
    Mux.Bits = mux_bits(Mux);
else
    switch Mux.Chamber
        case 97
            % All Chambers
            Mux.Bits = zeros(1, 14);
        case 98
            % All Closed + flush
            Mux.Bits = ones(1, 14);
        case 99
            % All closed
            Mux.Bits = ones(1, 14);
            Mux.InClosed = 1;
            Mux.ChInClosed = 1;
            Mux.Flush = 0;
        case 100
            % All Open + flush
            Mux.Bits = zeros(1, 14);
            Mux.FlushOnly = 1;
        case 101
            % All Open
            Mux.Bits = zeros(1, 14);
            Mux.FlushOnly = 1;
            Mux.Flush = 1;
            Mux.InClosed = 0;
            Mux.ChInClosed = 0;
        otherwise
            str = ['Error!' 10 13 'Invalid chamber number! (' num2str(chamber) ')'];
            infodlg('Title', 'Set MUX', 'String', str);
            Mux.Bits = ones(1, 14);
    end
end
if Mux.Flush
    if Mux.FlushOnly
        Mux.Bits(1:3) = [0 0 0];
    else
        Mux.Bits(1:3) = [1 0 1];
    end
else
    Mux.Bits(2) = 1;
end
if Mux.ChInClosed
    Mux.Bits([1 3]) = [1 1];
end
if Mux.InClosed
    Mux.Bits(13:14) = [1 1];
end
Mux.RawBits = Mux.Bits;
numbers = Mux.First:(Mux.First + 13);
% Switch bit order to match chip v.2.0 when writing to valve controller
% Bit order needed for chip 2.0:
% Bits:    5a  5b  4b  4a  3b  3a  2b  2a  1c  1a  1b  0c  0a  0b
% Numbers: 1   2   3   4   5   6   7   8   9   10  11  12  13  14
vc = vc_set_bits(vc, numbers, Mux.Bits(Mux.BitOrder));


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initialize number and value of one button-controlled valve
function init_valve(name, number, value)

global CCChs CCCdata;

switch name
    case CCCdata.Valves.Names
        set(CCChs.(name), 'UserData', number);
        set(CCChs.([name 'Num']), 'String', num2str(number));
        if (value == 1) || (value == 0)
            set_valve(name, value);
        end
    otherwise
        str = ['Error!' 10 13 'Invalid valve name: ' name];
        infodlg('Title', 'Init Valve', 'String', str);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set value of one button-controlled valve
% Reads value back from controller and uses it to update button display
function set_valve(name, value)

global CCChs CCCdata;

try
    switch name
        case CCCdata.Valves.Names
            number = get(CCChs.(name), 'UserData');
            CCCdata.vc = vc_set_1bit(CCCdata.vc, number, value);
            [CCCdata.vc, rd_value] = vc_get_1bit(CCCdata.vc, number);
            set(CCChs.(name), 'Value', rd_value);
            if value
                % Valve is closed
                set(CCChs.(name), 'BackgroundColor', [0 1 0]);
            else
                % Valve is open
                set(CCChs.(name), 'BackgroundColor', [0 0.2 0]);
            end
            drawnow;
        otherwise
            str = ['Error!' 10 13 'Invalid valve name: ' name];
            infodlg('Title', 'Set Valve', 'String', str);
    end
catch
    beep;
    msg = lasterr;
    set(CCChs.Msg, 'String', ['ERROR!  set_valve' 10 13 msg]);
    log_error('set_valve', msg);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get value of one button-controlled valve
% Reads actual value from the valve controller, not from the interface
% It also updates valve button on the interface
function value = get_valve(name)

global CCChs CCCdata;

try
    switch name
        case CCCdata.Valves.Names
            number = get(CCChs.(name), 'UserData');
            [CCCdata.vc, value] = vc_get_1bit(CCCdata.vc, number);
            set(CCChs.(name), 'Value', value);
            if value
                % Valve is closed
                set(CCChs.(name), 'BackgroundColor', [0 1 0]);
            else
                % Valve is open
                set(CCChs.(name), 'BackgroundColor', [0 0.2 0]);
            end
            drawnow;
        otherwise
            str = ['Error!' 10 13 'Invalid valve name: ' name];
            infodlg('Title', 'Get Valve', 'String', str);
    end
catch
    beep;
    msg = lasterr;
    set(CCChs.Msg, 'String', ['ERROR!  get_valve' 10 13 msg]);
    log_error('get_valve', msg);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set values of all input manifold valves
% plus Purge (purge is optional and can be omitted)
function set_input(values, purge)

global CCChs CCCdata;

try
    % Get input manifold valve numbers
    numbers = cell2mat(get(CCChs.in, 'UserData'))';
    nn = length(numbers);
    %CCCdata.vc = vc_set_bits(CCCdata.vc, numbers(1:8), values(1:8));
    %CCCdata.vc = vc_set_bits(CCCdata.vc, numbers(9:16), values(9:16));
    for ii = 1:nn
        v = values(ii);
        CCCdata.vc = vc_set_1bit(CCCdata.vc,numbers(ii),values(ii));
        set(CCChs.in(ii), 'Value', v);
        if v
            set(CCChs.in(ii), 'BackgroundColor', [0 1 0]);
        else
            set(CCChs.in(ii), 'BackgroundColor', [0 0.2 0]);
        end
    end
    drawnow;
    if nargin == 2
        set_valve('InPurge', purge);
    end
catch
    beep;
    msg = lasterr;
    set(CCChs.Msg, 'String', ['ERROR!  set_input' 10 13 lasterr]);
    log_error('set_input', msg);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get values of all input manifold valves
function [values, purge] = get_input()

global CCChs CCCdata;

try
    % Get input manifold valve numbers
    numbers = cell2mat(get(CCChs.in, 'UserData'))';
    [CCCdata.vc, values] = vc_get_bits(CCCdata.vc, numbers);
    nn = length(values);
    for ii = 1:nn
        v = values(ii);
        set(CCChs.in(ii), 'Value', v);
        if v
            set(CCChs.in(ii), 'BackgroundColor', [0 1 0]);
        else
            set(CCChs.in(ii), 'BackgroundColor', [0 0.2 0]);
        end
    end
    purge = get_valve('InPurge');
    drawnow;
catch
    beep;
    msg = lasterr;
    set(CCChs.Msg, 'String', ['ERROR!  get_valve' 10 13 msg]);
    log_error('get_valve', msg);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Get new scripts folder
function ScriptFolderButton_Callback(hObject, eventdata)

global CCChs CCCdata;

folder = uigetdir(CCCdata.Scr.Folder, 'Please the select a folder where scripts are stored');
if folder
    if folder(end) ~= '\'
        folder = [folder '\'];
    end
    CCCdata.Scr.Folder = folder;
    set(CCChs.ScriptFolder, 'String', folder);
    set(CCChs.ScriptFolder, 'UserData', folder);
    ScriptUpdate_Callback(CCChs.ScriptUpdate, []);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Script Folder box
function ScriptFolder_Callback(hObject, eventdata)

global CCChs CCCdata;

if CCCdata.Scr.Running
    str = ['Cannot change the script folder' 10 13 'while a script is running!'];
    infodlg('Title', 'Script Folder', 'String', str);
    % Restore previous value
    str = get(hObject, 'UserData');
    set(hObject, 'String', str);
else
    str = get(hObject, 'String');
    if exist(str, 'dir')
        if ~isempty(str) &&  (str(end) ~= '\')
            str = [str '\'];
            set(hObject, 'String', str);
        end
        CCCdata.Scr.Folder = str;
        set(hObject, 'UserData', str);
        ScriptUpdate_Callback(CCChs.ScriptUpdate, []);
    else
        msg = ['The folder' 10 13 str 10 13 'does not exist!'];
        infodlg('Title', 'Script Folder Does Not Exist', 'String', msg);
        % Restore previous value
        str = get(hObject, 'UserData');
        set(hObject, 'String', str);
    end
end
clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Script Name box
function ScriptFName_Callback(hObject, eventdata)

global CCChs CCCdata;

if CCCdata.Scr.Running
    str = ['Cannot change the script' 10 13 'while a script is running!'];
    infodlg('Title', 'Script', 'String', str);
    % Restore previous value
    v = get(hObject, 'UserData');
    set(hObject, 'Value', v);
else
    v = get(hObject, 'Value');
    str = get(hObject, 'String');
    set(hObject, 'UserData', v);
    CCCdata.Scr.FName = str{v};
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Script Update button
function ScriptUpdate_Callback(hObject, eventdata)

global CCChs CCCdata;

list = dir(CCCdata.Scr.Folder);
scripts = {};
nn = length(list);
cc = 1;
cv = 1;
for ii = 1:nn
    if ~list(ii).isdir
        if strcmp(list(ii).name(end-1:end), '.m')
            scripts{cc} = list(ii).name(1:end-2);
            if strcmp(list(ii).name(1:end-2), CCCdata.Scr.FName)
                cv = cc;
            end
            cc = cc + 1;
        end
    end
end
if isempty(scripts)
    scripts = {' '};
end
set(CCChs.ScriptFName, 'String', scripts);
set(CCChs.ScriptFName, 'Value', cv);
CCCdata.Scr.FName = scripts{cv};

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Close Script running system
function ScriptClose

global CCChs CCCdata;

try
    set(CCChs.Msg, 'String', 'Closing scripting system');
    stop(CCCdata.Scr.Timer1);
    stop(CCCdata.Scr.Timer2);
    stop(CCCdata.Scr.Timer3);
    stop(CCCdata.Scr.Timer4);
    stop(CCCdata.Scr.Timer5);
    pause(3);
    delete(CCCdata.Scr.Timer1);
    delete(CCCdata.Scr.Timer2);
    delete(CCCdata.Scr.Timer3);
    delete(CCCdata.Scr.Timer4);
    delete(CCCdata.Scr.Timer5);
catch
    beep;
    msg = lasterr;
    set(CCChs.Msg, 'String', ['ERROR!  ScriptClose' 10 13 msg]);
    log_error('ScriptClose', msg);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initialize Script running system
function ScriptInit

global CCChs CCCdata;

% Init flags and display
CCCdata.Scr.Folder = get(CCChs.ScriptFolder, 'String');
set(CCChs.ScriptFolder, 'UserData', CCCdata.Scr.Folder);
CCCdata.Scr.FName = '';
set(CCChs.ScriptFName, 'String', ' ');
set(CCChs.ScriptFName, 'Value', 1);
set(CCChs.ScriptFName, 'UserData', 1);
CCCdata.Scr.Running = 0;
set(CCChs.ScriptStop, 'UserData', 0);
set(CCChs.ScriptRun, 'BackgroundColor', [212 208 200]/255);
set(CCChs.ScriptRun, 'String', 'RUN');
CCCdata.Scr.PauseLength = 0.5; %hrs

% Setup timers
% These timers are for running scripts
CCCdata.Scr.Timer1 = timer('TimerFcn', @ScriptTimerFcn1, 'BusyMode', 'drop', 'ExecutionMode', 'fixedSpacing', 'Name', 'ScriptTimer1');
CCCdata.Scr.Timer2 = timer('TimerFcn', @ScriptTimerFcn2, 'BusyMode', 'drop', 'ExecutionMode', 'fixedSpacing', 'Name', 'ScriptTimer2');
CCCdata.Scr.Timer3 = timer('TimerFcn', @ScriptTimerFcn3, 'BusyMode', 'drop', 'ExecutionMode', 'fixedSpacing', 'Name', 'ScriptTimer3');
CCCdata.Scr.Timer4 = timer('TimerFcn', @ScriptTimerFcn4, 'BusyMode', 'drop', 'ExecutionMode', 'fixedSpacing', 'Name', 'ScriptTimer4');
CCCdata.Scr.Timer5 = timer('TimerFcn', @ScriptTimerFcn5, 'BusyMode', 'drop', 'ExecutionMode', 'fixedSpacing', 'Name', 'ScriptTimer5');
CCCdata.Scr.TimedScript1 = '';
CCCdata.Scr.TimedScript2 = '';
CCCdata.Scr.TimedScript3 = '';
CCCdata.Scr.TimedScript4 = '';
CCCdata.Scr.TimedScript5 = '';

% Update list of scripts
ScriptUpdate_Callback(CCChs.ScriptUpdate, [])

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function for script timer 1
function ScriptTimerFcn1(hObject, eventdata)

global CCChs CCCdata;

scr_fname = CCCdata.Scr.TimedScript1;
if ~exist(scr_fname, 'file')
    scr_str = ['Error!' 10 13 'Cannot find the script ' scr_fname ' !'];
    infodlg('Title', 'Script Timer Function 1', 'String', scr_str);
else
    try
        clear(scr_fname);
        eval(scr_fname);
    catch
        beep;
        msg = [CCCdata.Scr.TimedScript1 10 13 lasterr];
        set(CCChs.Msg, 'String', ['ERROR!  ScriptTimerFcn1' 10 13 msg]);
        log_error('ScriptTimerFcn1', msg);
    end
    clear(scr_fname);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function for script timer 2
function ScriptTimerFcn2(hObject, eventdata)

global CCChs CCCdata;

scr_fname = CCCdata.Scr.TimedScript2;
if ~exist(scr_fname, 'file')
    scr_str = ['Error!' 10 13 'Cannot find the script ' scr_fname ' !'];
    infodlg('Title', 'Script Timer Function 2', 'String', scr_str);
else
    try
        clear(scr_fname);
        eval(scr_fname);
    catch
        beep;
        msg = [CCCdata.Scr.TimedScript2 10 13 lasterr];
        set(CCChs.Msg, 'String', ['ERROR!  ScriptTimerFcn2' 10 13 msg]);
        log_error('ScriptTimerFcn2', msg);
    end
    clear(scr_fname);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function for script timer 3
function ScriptTimerFcn3(hObject, eventdata)

global CCChs CCCdata;

scr_fname = CCCdata.Scr.TimedScript3;
if ~exist(scr_fname, 'file')
    scr_str = ['Error!' 10 13 'Cannot find the script ' scr_fname ' !'];
    infodlg('Title', 'Script Timer Function 3', 'String', scr_str);
else
    try
        clear(scr_fname);
        eval(scr_fname);
    catch
        beep;
        msg = [CCCdata.Scr.TimedScript3 10 13 lasterr];
        set(CCChs.Msg, 'String', ['ERROR!  ScriptTimerFcn3' 10 13 msg]);
        log_error('ScriptTimerFcn3', msg);
    end
    clear(scr_fname);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function for script timer 4
function ScriptTimerFcn4(hObject, eventdata)

global CCChs CCCdata;

scr_fname = CCCdata.Scr.TimedScript4;
if ~exist(scr_fname, 'file')
    scr_str = ['Error!' 10 13 'Cannot find the script ' scr_fname ' !'];
    infodlg('Title', 'Script Timer Function 4', 'String', scr_str);
else
    try
        clear(scr_fname);
        eval(scr_fname);
    catch
        beep;
        msg = [CCCdata.Scr.TimedScript4 10 13 lasterr];
        set(CCChs.Msg, 'String', ['ERROR!  ScriptTimerFcn4' 10 13 msg]);
        log_error('ScriptTimerFcn4', msg);
    end
    clear(scr_fname);
end

clear CCChs CCCdata;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function for script timer 5
function ScriptTimerFcn5(hObject, eventdata)

global CCChs CCCdata;

scr_fname = CCCdata.Scr.TimedScript5;
if ~exist(scr_fname, 'file')
    scr_str = ['Error!' 10 13 'Cannot find the script ' scr_fname ' !'];
    infodlg('Title', 'Script Timer Function 5', 'String', scr_str);
else
    try
        clear(scr_fname);
        eval(scr_fname);
    catch
        beep;
        msg = [CCCdata.Scr.TimedScript5 10 13 lasterr];
        set(CCChs.Msg, 'String', ['ERROR!  ScriptTimerFcn5' 10 13 msg]);
        log_error('ScriptTimerFcn5', msg);
    end
    clear(scr_fname);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Edit Script button
function ScriptEdit_Callback(hObject, eventdata)

global CCChs CCCdata;

fname = [CCCdata.Scr.Folder CCCdata.Scr.FName];
if ~isempty(CCCdata.Scr.FName) &&  ~isempty(CCCdata.Scr.Folder) ...
        && exist(fname, 'file')
    % RK % dos(['meditor ' fname '.m']);
    open(fname);
else
    dos('meditor');
    %infodlg('Title', 'Script', 'String', 'Cannot find the script!');
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Stop Script button
function ScriptStop_Callback(hObject, eventdata)

global CCChs CCCdata;

if CCCdata.Scr.Running
    CCCdata.Scr.Stop = 1;
else
    infodlg('Title', 'Script', 'String', 'No script running!');
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Callback function for Run Script button
function ScriptRun_Callback(hObject, eventdata)

global CCChs CCCdata;

path(CCCdata.Scr.Folder, path);
scr_fname = CCCdata.Scr.FName;
if CCCdata.Scr.Running
    if CCCdata.Scr.Pause
        CCCdata.Scr.Pause = 0;
        CCCdata.Scr.PauseStart = 0;
        set(CCChs.ScriptRun, 'BackgroundColor', 'green');
        set(CCChs.ScriptRun, 'String', 'Pause');
    else
        CCCdata.Scr.Pause = 1;
        CCCdata.Scr.PauseStart = now;
        set(CCChs.ScriptRun, 'BackgroundColor', 'yellow');
        set(CCChs.ScriptRun, 'String', 'Resume');
    end
elseif ~exist(scr_fname, 'file')
    infodlg('Title', 'Script', 'String', 'Cannot find the script!');
else
    try
        CCCdata.Scr.Running = 1;
        CCCdata.Scr.Stop = 0;
        CCCdata.Scr.Pause = 0;
        CCCdata.Scr.PauseStart = 0;
        set(CCChs.ScriptRun, 'BackgroundColor', 'green');
        set(CCChs.ScriptRun, 'String', 'Pause');
        set(CCChs.ScriptStop, 'BackgroundColor', 'red');
        set(CCChs.Msg, 'String', ['Script ' CCCdata.Scr.FName ' started']);
        drawnow;
        clear(scr_fname);
        eval(scr_fname);
        if CCCdata.Scr.Stop
            scr_str = ['Script ' CCCdata.Scr.FName ' stopped'];
        else
            scr_str = ['Script ' CCCdata.Scr.FName ' ended'];
        end
        set(CCChs.Msg, 'String', scr_str);
    catch
        scr_str = ['Error while running script: ' CCCdata.Scr.FName 10 13 lasterr];
        infodlg('Title', 'Script', 'String', scr_str);
        set(CCChs.Msg, 'String', ['Script ' CCCdata.Scr.FName ' aborted']);
    end
    rmpath(CCCdata.Scr.Folder);
    CCCdata.Scr.Running = 0;
    CCCdata.Scr.Stop = 0;
    CCCdata.Scr.Pause = 0;
    CCCdata.Scr.PauseStart = 0;
    clear(CCCdata.Scr.FName);
    set(CCChs.ScriptRun, 'BackgroundColor', [212 208 200]/255);
    set(CCChs.ScriptRun, 'String', 'RUN');
    set(CCChs.ScriptStop, 'BackgroundColor', [212 208 200]/255);
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [done, tremain] = CCCtimer(tstart, tlength)
% [done, tremain] = CCCtimer(tstart, tlength)
% Determines time between now and tstart, and
% whether the elapsed time is longer than tlength
%
% tstart = Date number for when the timer started
% tlength = Length of the period being timed, in hours
%
% done = 1 if time is up (elapsed time > tlength), 0 otherwise
% tremain = Time remaining [hrs, min, sec]
%
% R. Gomez-Sjoberg 5/31/06

time = 24*(now - tstart); %hrs
dt = tlength - time; %hrs
hrs = fix(dt);
min = fix(dt * 60);
sec = fix((dt*60 - min)*60);
if (time >= tlength)
    done = 1;
else
    done = 0;
end
tremain = [hrs, min, sec];


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Function that times the pause when a script is paused
% After the defined time length the pause is released
function ScriptPause(msg)

global CCChs CCCdata;

done = 0;
while ~CCCdata.Scr.Stop && CCCdata.Scr.Pause  && ~done
    pause(0.98);
    % pause might have been released during the 0.98sec wait
    if CCCdata.Scr.Pause
        [done, tremain] = CCCtimer(CCCdata.Scr.PauseStart, CCCdata.Scr.PauseLength);
        str = [msg 10 13 'Paused - ' num2str_pad(tremain(2), 2) ':' num2str_pad(tremain(3), 2)];
        set(CCChs.Msg, 'String', str);
        if ~done && ((tremain*[3600; 60; 1]) <= 10)
            % Beep on the last 10 seconds of the pause
            beep;
        end
        if CCCdata.Scr.Pause && done
            % Release pause
            ScriptRun_Callback(CCChs.ScriptRun, []);
        end
    end
end

clear CCChs CCCdata;






%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set the data path
function set_path(pth)

global CCChs CCCdata;

set(CCChs.Path, 'String', pth);
drawnow;
Path_Callback(CCChs.Path, []);

clear CCChs CCCdata;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Start the preview window
function start_preview

global CCChs CCCdata;

if ~CCCdata.Vid.PreviewOn
    VidPreview_Callback(CCChs.VidPreview, []);
    drawnow;
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Stop the preview window
function was_on = stop_preview

global CCChs CCCdata;

if CCCdata.Vid.PreviewOn
    was_on = 1;
    VidPreview_Callback(CCChs.VidPreview, []);
    drawnow;
else
    was_on = 0;
end

clear CCChs CCCdata;




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Wait for the specified number of minutes & seconds
function scr_wait(min, sec, msg)

global CCChs CCCdata;

if nargin == 2
    msg = '';
end
tstart = now;
wait_t = min/60 + sec/3600; %converted to hrs
done = 0;
while ~CCCdata.Scr.Stop  && ~done
    if CCCdata.Scr.Pause
        ScriptPause(msg);
        %         pause(0.98);
        %         [done, tremain] = ccc_timer(CCCdata.Scr.PauseStart, CCCdata.Scr.PauseLength);
        %         str = [msg 10 13 'Paused - ' num2str(tremain(2)) ':' num2str(tremain(3))];
        %         set(CCChs.Msg, 'String', str);
        %         if (tremain*[3600; 60; 1]) <= 10
        %             % Beep on the last 10 seconds of the pause
        %             beep;
        %         end
        %         if done
        %             % Release pause
        %             ScriptRun_Callback(CCChs.ScriptRun, []);
        %         end
    else
        pause(0.98);
        [done, tremain] = CCCtimer(tstart, wait_t);
        str = [msg 10 13 'Waiting - ' num2str_pad(tremain(2), 2) ':' num2str_pad(tremain(3), 2)];
        set(CCChs.Msg, 'String', str);
    end
end

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Display message on message window
function scr_message(msg)

global CCChs CCCdata;

set(CCChs.Msg, 'String', msg);
drawnow;

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set pumping direction
function pump_direction(dir_str)
% dir_str = 'forward' or 'backward'

global CCChs CCCdata;

switch lower(dir_str)
    case 'forward'
        CCCdata.Pump.Sequence = CCCdata.Pump.FrwdSequence;
        CCCdata.Pump.Frwd = 1;
        set(CCChs.PumpDir, 'String', 'Forw');
        set(CCChs.PumpDir, 'BackgroundColor', [212 208 200]/255);
    case 'backward'
        CCCdata.Pump.Sequence = CCCdata.Pump.BkwdSequence;
        CCCdata.Pump.Frwd = 0;
        set(CCChs.PumpDir, 'String', 'Back');
        set(CCChs.PumpDir, 'BackgroundColor', 'red');
    otherwise
        infodlg('Title', 'Pump Direction', 'string', ['Error!' 10 13 ...
            'Invalid direction string ' dir_str 10 13 ...
            'Valid values are ''forward'' and ''backward''']);
end
CCCdata.Pump.SeqLength = length(CCCdata.Pump.Sequence);
drawnow;

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Switch pumping direction
function switch_pump_direction

global CCChs CCCdata;

PumpDir_Callback(CCChs.PumpDir, []);

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Run the pump
function pump(cycles, period, wait)
% if period and/or cycles are not specified, the values
% set on the interface are used
% if wait==1, the function waits until the pump ends running

global CCChs CCCdata;

if exist('cycles', 'var')
    set(CCChs.PumpCycles, 'String', cycles);
    PumpCycles_Callback(CCChs.PumpCycles, []);
end
if exist('period', 'var');
    set(CCChs.PumpPeriod, 'String', period);
    PumpPeriod_Callback(CCChs.PumpPeriod, []);
end
if ~exist('wait', 'var')
    wait = 0;
end
drawnow;
PumpRun_Callback(CCChs.PumpRun, []);
if CCCdata.Pump.TimerFlag
    % Wait for pump to start
    cnt = 0;
    while ~CCCdata.Pump.Running && (cnt < 60)
        pause(1);
        %disp(['Waiting for pump to start. CCCdata.Pump.Running = ' num2str(CCCdata.Pump.Running)]);
        cnt = cnt + 1;
    end %while ~CCCdata.Pump.Running...
    if cnt >= 60
        beep;
        msg = 'Timed out waiting for pump to start!';
        set(CCChs.Msg, 'String', ['ERROR!  pump' 10 13 msg]);
        log_error('pump', msg);
    else
        %Wait for pump to stop before returning
        cnt = 0;
        ptime = CCCdata.Pump.Period*(CCCdata.Pump.SeqLength + 1)*2.5;
        while wait && CCCdata.Pump.Running && (cnt < (CCCdata.Pump.Cycles/2))
            pause(ptime);
            %disp(['Waiting for pump to stop. CCCdata.Pump.Running = ' num2str(CCCdata.Pump.Running)]);
            cnt = cnt + 1;
        end %while wait && ...
        if cnt >= (CCCdata.Pump.Cycles/2)
            beep;
            msg = 'Timed out waiting for pump to finish!';
            set(CCChs.Msg, 'String', ['ERROR!  pump' 10 13 msg]);
            log_error('pump', msg);
        end %if cnt >= (CCCdata.Pump.Cycles/2)
    end %if cnt >= 60
end %if CCCdata.Pump.TimerFlag
clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Close all valves in the pump
function close_pump()

global CCChs CCCdata;

set_valve('Pmp1', 1);
set_valve('Pmp2', 1);
set_valve('Pmp3', 1);

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Open all valves in the pump
function open_pump()

global CCChs CCCdata;

set_valve('Pmp1', 0);
set_valve('Pmp2', 0);
set_valve('Pmp3', 0);

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function flush_mixer(in_num, t)
% flush_mixer(in_num, t)
% Flush mixer with inputs in_num for t seconds
% R. Gomez-Sjoberg, 9/9/05

global CCChs CCCdata;

close_pump;
set_valve('BeadsIn', 1);
open_inputs(in_num);
%set_mux(99, 1, 1, 1, 1, 0);
set_valve('MixerOut', 0);
set_valve('Flush', 0);
set(CCChs.Msg, 'String', ['Flushing mixer with input(s) ' num2str(in_num) ' for ' num2str(t) 'sec']);
pause(t);
set_valve('MixerOut', 1);
set_valve('Flush', 1);
close_inputs;

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function flush2ch(ch_num, t)
% flush2ch(ch_num, t)
% Flush chamber ch_num from mixer flush line for t seconds
% R. Gomez-Sjoberg, 9/9/05

global CCChs CCCdata;

set_valve('BeadsIn', 1);
set_valve('MixerOut', 1);
set_valve('Flush', 0);
open_pump;
set_valve('ChIn', 0);
set_valve('ChOut', 0);
set_mux(ch_num, 1, 1, 0, 0, 0);
set(CCChs.Msg, 'String', ['Flushing ch ' num2str(ch_num) ' from mixer flush line for ' num2str(t) 'sec']);
pause(t);
close_pump;
set_valve('Flush', 1);
set_valve('ChIn', 1);
set_valve('ChOut', 1);
set_mux(99, 1, 1, 1, 1, 0);

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function flush2muxflush(ch_num, t)
% flush2muxflush(ch_num, t)
% Flush mux line for chamber ch_num from mixer flush line for t seconds
% R. Gomez-Sjoberg, 9/9/05

global CCChs CCCdata;

set_valve('BeadsIn', 1);
set_valve('MixerOut', 1);
set_valve('Flush', 0);
open_pump;
set_mux(ch_num, 1, 1, 1, 0, 0);
set(CCChs.Msg, 'String', ['Flushing ch line ' num2str(ch_num) ' from mixer flush line for ' num2str(t) 'sec']);
pause(t);
close_pump;
set_valve('Flush', 1);
set_mux(99, 1, 1, 1, 1, 0);

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function in2ch(ch_num, in_num, t)
% in2ch(ch_num, in_num, t)
% Flush chamber ch_num with inputs in_num for t seconds
% R. Gomez-Sjoberg, 9/9/05

global CCChs CCCdata;

set_valve('BeadsIn', 1);
set_valve('Flush', 1);
open_inputs(in_num);
set_valve('MixerOut', 0);
open_pump;
set_valve('ChIn', 0);
set_valve('ChOut', 0);
set_mux(ch_num, 1, 1, 0, 0, 0);
set(CCChs.Msg, 'String', ['Flushing ch ' num2str(ch_num) ' with input(s) ' num2str(in_num) ' for ' num2str(t) 'sec']);
pause(t);
close_pump;
set_valve('MixerOut', 1);
set_valve('ChIn', 1);
set_valve('ChOut', 1);
set_mux(99, 1, 1, 1, 1, 0);
close_inputs;

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function in2muxflush(ch_num, in_num, t)
% in2muxflush(ch_num, in_num, t)
% Flush mux line for chamber ch_num with inputs in_num for t seconds
% R. Gomez-Sjoberg, 9/9/05

global CCChs CCCdata;

set_valve('BeadsIn', 1);
set_valve('Flush', 1);
open_inputs(in_num);
open_pump;
set_valve('MixerOut', 0);
set_mux(ch_num, 1, 1, 1, 0, 0);
set(CCChs.Msg, 'String', ['Flushing ch line ' num2str(ch_num) ' with input(s) ' num2str(in_num) ' for ' num2str(t) 'sec']);
pause(t);
set_valve('MixerOut', 1);
set_mux(99, 1, 1, 1, 1, 0);
close_inputs;

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function purge_inputs(t)
% purge_inputs(t)
% Purge input manifold for t seconds
% R. Gomez-Sjoberg, 11/15/05

global CCChs CCCdata;

close_inputs;
close_pump;
set_valve('BeadsIn', 1);
set_valve('MixerOut', 0);
set_valve('Flush', 0);
set_valve('InPurge', 0);
set(CCChs.Msg, 'String', ['Purging inputs for ' num2str(t) 'sec']);
pause(t);
set_valve('InPurge', 1);
set_valve('Flush', 1);
set_valve('MixerOut', 1);

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function purge2muxflush(ch_num, t)
% purge2muxflush(ch_num, t)
% Flush mux line for chamber ch_num from input purge line
% R. Gomez-Sjoberg, 3/21/05

global CCChs CCCdata;

close_inputs;
set_valve('BeadsIn', 1);
set_valve('Flush', 1);
open_pump;
set_valve('InPurge', 0);
set_valve('MixerOut', 0);
set_mux(ch_num, 1, 1, 1, 0, 0);
set(CCChs.Msg, 'String', ['Flushing ch line ' num2str(ch_num) ' from InPurge for ' num2str(t) 'sec']);
pause(t);
set_valve('InPurge', 1);
set_valve('MixerOut', 1);
close_pump;
set_mux(99, 1, 1, 1, 1, 0);

clear CCChs CCCdata;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function open_inputs(in_num)
% open_inputs(in_num)
% Open input numbers specified in vector in_num
% InPurge corresponds to input number 0
% R. Gomez-Sjoberg, 7/26/05

idx = find(in_num == 0);
if ~isempty(idx)
    in_num = [in_num(1:(idx-1)) in_num((idx+1):end)];
    set_valve('InPurge', 0);
else
    set_valve('InPurge', 1);
end
bits = ones(1, 16);
bits(in_num) = zeros(1, length(in_num));
set_input(bits);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function close_inputs
% close_inputs
% Close all inputs
% R. Gomez-Sjoberg, 10/18/05

bits = ones(1, 16);
set_input(bits);
set_valve('InPurge', 1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function open_valve(name)
% Open valve specified by name

set_valve(name, 0);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function close_valve(name)
% Close valve specified by name

set_valve(name, 1);




