% Plot Media Schedule
% R. Gomez-Sjoberg 4/14/07

% load([CCCdata.DataPath ScheduleFile '.mat']);

szMediaSchedule = size(Matrix);

hf = figure(10);
clf;
cmap = jet(szMediaSchedule(1));
symb = {'o', '^', '+', 'v', 's', '*', '>', 'd', '<'};
nsymb = length(symb);
hpv = [];
for ii = 1:szMediaSchedule(1)
%    scr_check4stop;
    sch = Matrix{ii};
    nn = length(sch);
    xx = (1:nn) * schedule_time_base;
    flags = (sch >= 100);
    idxflags = find(flags);
    sch(idxflags) = sch(idxflags) - 100;
    schdiff = [0, diff(sch)];
    repl = xor((schdiff ~= 0), flags);
    idxrepl = find(repl);
    hp = stairs(xx, sch + (ii-1)*szMediaSchedule(1)/20, '-');
    hpv = [hpv, hp];
    set(hp, 'Color', cmap(ii, :));
    set(hp, 'Displayname', SchNames{ii});
    set(hp, 'LineWidth', 1.5);
    hold on;
    hp2 = plot(xx(idxrepl), sch(idxrepl) + (ii-1)*szMediaSchedule(1)/20, symb{rem(ii-1, nsymb)+1});
    set(hp2, 'MarkerEdgeColor', cmap(ii, :));
    set(hp2, 'MarkerSize', 8);
    set(hp2, 'Displayname', [SchNames{ii} ' Replace']);
end
ht = title({[ScheduleFile '.mat']; 'Symbols indicate full medium replacement'});
set(ht, 'Interpreter', 'none');
ylabel('Medium');
xlabel('Time (hours)');
ax = axis;
ax(3) = 0;
ax(4) = length(MediaNames) + 1;
axis(ax);
nm = length(MediaNames);
ha = gca;
set(ha, 'YTickMode', 'manual');
set(ha, 'YTick', 0:(nm+1));
set(ha, 'YTickLabel', [' ', MediaNames, ' ']);
set(ha, 'YGrid', 'on');
legend(hpv, SchNames);

opt = YesNoQuestion('Title', 'Save Schedule Plot', 'String', 'Do you want to save the schedule plot?');
switch lower(opt)
    case 'yes'
        saveas(hf, [log_file '.pdf'], 'pdf');
end

