function [MatrixRow, ttime] = ScheduleExpand(Schedule, MatrixRow, MediaNames, NumPer, ttime)
% Recursively expand a row in the media schedule

sz = size(Schedule);
for jj = 1:sz(1)
    fprintf('    %i --> ', jj);
    Entry = Schedule{jj, 1};
    if ischar(Entry)
        MediumName = Entry;
        if isempty(MediumName)
            MediumIdx = 0;
            goAhead = 1;
        else
            MediumIdx = strmatch(MediumName, MediaNames, 'exact');
            if isempty(MediumIdx) || (MediumIdx == 0)
                error(['Unknown medium name: ' MediumName]);
                goAhead = 0;
            else
                goAhead = 1;
            end %if isempty(MediumIdx)
        end %if isempty(MediumName)
        if goAhead
            Duration = Schedule{jj, 2};
            if Duration < 0
                ReplaceFlag = 1;
                Duration = abs(Duration);
            else
                ReplaceFlag = 0;
            end %if Duration < 0
            CycleSpec = Duration - fix(Duration);
            Duration = fix(Duration);
            fprintf('%s (%i): dur = %i, ttime = %i\n', MediumName, MediumIdx, Duration, ttime);
            MatrixRow = [MatrixRow, MediumIdx*ones(1, Duration) + CycleSpec + ReplaceFlag*100];
            ttime = ttime + Duration;
        end %if goAhead
    elseif iscell(Entry)
        fprintf('Expanding\n');
        NumRep = Schedule{jj, 2};
        Sch = {};
        for kk = 1:NumRep
            Sch = [Sch; Entry];
        end
        [MatrixRow, ttime] = ScheduleExpand(Sch, MatrixRow, MediaNames, NumPer, ttime);
    end %if ischar(Entry)
end %for jj
