function varargout = goto_dlg(varargin)
% GOTO_DLG M-file for goto_dlg.fig
%      GOTO_DLG by itself, creates a new GOTO_DLG or raises the
%      existing singleton*.
%
%      H = GOTO_DLG returns the handle to a new GOTO_DLG or the handle to
%      the existing singleton*.
%
%      GOTO_DLG('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GOTO_DLG.M with the given input arguments.
%
%      GOTO_DLG('Property','Value',...) creates a new GOTO_DLG or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before goto_dlg_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to goto_dlg_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help goto_dlg

% Last Modified by GUIDE v2.5 22-Aug-2006 16:34:28

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @goto_dlg_OpeningFcn, ...
                   'gui_OutputFcn',  @goto_dlg_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before goto_dlg is made visible.
function goto_dlg_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to goto_dlg (see VARARGIN)

% Choose default command line output for goto_dlg
handles.output = 'Cancel';

% Update handles structure
guidata(hObject, handles);

% Insert custom Title and Text if specified by the user
% Hint: when choosing keywords, be sure they are not easily confused 
% with existing figure properties.  See the output of set(figure) for
% a list of figure properties.
handles.XY = [];
handles.Scope = [];
if(nargin > 3)
    for index = 1:2:(nargin-3),
        if nargin-3==index, break, end
        switch lower(varargin{index})
            case 'title'
                title = varargin{index+1};
                set(hObject, 'Name', title);
            case 'string'
                set(handles.Message, 'String', varargin{index+1});
            case 'scopedata'
                handles.Scope = varargin{index+1};
            case 'xydata'
                handles.XY = varargin{index+1};
        end
    end
end
if isempty(handles.XY)
    str = ['Error!' 10 13 'XY Stage data was not provided'];
    infodlg('Title', title, 'String', str);
end
if isempty(handles.Scope)
    if handles.XY.ZLeica
        str = ['Error!' 10 13 'Data for Leica Scope was not provided'];
        infodlg('Title', title, 'String', str);
    end
    handles.XY.ZLeica = 0;
end

% Determine the position of the dialog - to the right edge of the callback figure
% if available, else, centered on the screen
FigPos=get(0,'DefaultFigurePosition');
OldUnits = get(hObject, 'Units');
set(hObject, 'Units', 'pixels');
OldPos = get(hObject,'Position');
FigWidth = OldPos(3);
FigHeight = OldPos(4);
if isempty(gcbf)
    ScreenUnits=get(0,'Units');
    set(0,'Units','pixels');
    ScreenSize=get(0,'ScreenSize');
    set(0,'Units',ScreenUnits);

    FigPos(1)=1/2*(ScreenSize(3)-FigWidth);
    FigPos(2)=2/3*(ScreenSize(4)-FigHeight);
else
    GCBFOldUnits = get(gcbf,'Units');
    set(gcbf,'Units','pixels');
    GCBFPos = get(gcbf,'Position');
    set(gcbf,'Units',GCBFOldUnits);
    FigPos(1:2) = [(GCBFPos(1) + GCBFPos(3)) - FigWidth, ...
                   (GCBFPos(2) + GCBFPos(4) / 2) - FigHeight / 2];
end
FigPos(3:4)=[FigWidth FigHeight];
set(hObject, 'Position', FigPos);
set(hObject, 'Units', OldUnits);


% Make the GUI modal
set(handles.goto_dlg,'WindowStyle','modal')

handles.t = timer('Period', 0.5, 'TasksToExecute', 1000, 'TimerFcn', {@update_XY,handles}, 'BusyMode', 'drop', 'ExecutionMode', 'fixedSpacing');
set(handles.t, 'UserData', handles.goto_dlg);
guidata(hObject, handles);
if ~isempty(handles.XY) && ~isempty(handles.Scope)
    start(handles.t);
end

% UIWAIT makes goto_dlg wait for user response (see UIRESUME)
uiwait(handles.goto_dlg);

% --- Outputs from this function are returned to the command line.
function varargout = goto_dlg_OutputFcn(hObject, eventdata, handles)

% Get default command line output from handles structure
varargout{1} = handles.output;


stop(handles.t);
delete(handles.t);

% The figure can be deleted now
delete(handles.goto_dlg);

% --- Executes on button press in OK.
function OK_Callback(hObject, eventdata, handles)

handles.output = get(hObject,'String');

% Update handles structure
guidata(hObject, handles);

% RK
%varargout{1} = handles.output;
%stop(handles.t);
%delete(handles.t);
%delete(handles.goto_dlg);
%

% Use UIRESUME instead of delete because the OutputFcn needs
% to get the updated handles structure.
uiresume(handles.goto_dlg);

% --- Executes on button press in Cancel.
function Cancel_Callback(hObject, eventdata, handles)

handles.output = get(hObject,'String');

% Update handles structure
guidata(hObject, handles);

% RK
%varargout{1} = handles.output;
%stop(handles.t);
%delete(handles.t);
%delete(handles.goto_dlg);
%


% Use UIRESUME instead of delete because the OutputFcn needs
% to get the updated handles structure.
uiresume(handles.goto_dlg);


% --- Executes when user attempts to close goto_dlg.
function goto_dlg_CloseRequestFcn(hObject, eventdata, handles)

% RK
varargout{1} = handles.output;
stop(handles.t);
delete(handles.t);
delete(handles.goto_dlg);
%

if isequal(get(handles.goto_dlg, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    uiresume(handles.goto_dlg);
end


% --- Executes on key press over goto_dlg with no controls selected.
function goto_dlg_KeyPressFcn(hObject, eventdata, handles)

% Check for "enter" or "escape"
if isequal(get(hObject,'CurrentKey'),'escape')
    % User said cancel by hitting escape
    handles.output = 'Cancel';
    % Update handles structure
    guidata(hObject, handles);
    
    uiresume(handles.goto_dlg);
end    
    
if isequal(get(hObject,'CurrentKey'),'return')
    % Pressing enter is equivalent to pressing OK
    handles.output = 'OK';
    % Update handles structure
    guidata(hObject, handles);
    
    uiresume(handles.goto_dlg);
end    

% Update the coordinates display
function update_XY(hObject, eventdata,handles)

global CCCdata CCChs

if CCCdata.XY.ZLeica
    % [status1, xy] = oasis_read_xy();
    [status2, x] = leica_get_x(CCCdata.Scope.Port);
    [status2, y] = leica_get_y(CCCdata.Scope.Port);
    [status2, z] = leica_get_z(CCCdata.Scope.Port);
    if CCCdata.XY.Calibrated
        zorig = goto_dlg.XY.Origin(3);
    else
        [status2, zorig] = leica_get_focus(CCCdata.Scope.Port);
    end
    z = (z - zorig) * CCCdata.Scope.Zfactor;
    y = y * CCCdata.Scope.Yfactor;
    x = x * CCCdata.Scope.Xfactor;
    units_xy = ' um ';
    units_z = ' um ';
    xyz = [x; y; z];
else
    %[status1, xyz] = oasis_read_xyz();
    status2 = 0;
    units_z = '  ';
end
if CCCdata.XY.Calibrated
    xyz(1:2) = inv(CCCdata.XY.TMatrix)*(xyz(1:2) - CCCData.XY.Origin(1:2));
%    units_xy = ' um ';
%else
%    units_xy = '  ';
end
set(handles.X, 'String', [num2str(xyz(1), '%6.2f') units_xy]);
set(handles.Y, 'String', [num2str(xyz(2), '%6.2f') units_xy]);
set(handles.Z, 'String', [num2str(xyz(3), '%6.2f') units_z]);

clear CCCdata CCChs
