function varargout = goto_dlg_rk(varargin)
% goto_dlg_rk M-file for goto_dlg_rk.fig
%      goto_dlg_rk by itself, creates a new goto_dlg_rk or raises the
%      existing singleton*.
%
%      H = goto_dlg_rk returns the handle to a new goto_dlg_rk or the handle to
%      the existing singleton*.
%
%      goto_dlg_rk('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in goto_dlg_rk.M with the given input arguments.
%
%      goto_dlg_rk('Property','Value',...) creates a new goto_dlg_rk or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before goto_dlg_rk_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to goto_dlg_rk_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help goto_dlg_rk

% Last Modified by GUIDE v2.5 03-Dec-2011 23:08:19

% Begin initialization code - DO NOT EDIT
gui_Singleton = 0;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @goto_dlg_rk_OpeningFcn, ...
                   'gui_OutputFcn',  @goto_dlg_rk_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before goto_dlg_rk is made visible.
function goto_dlg_rk_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to goto_dlg_rk (see VARARGIN)

% Choose default command line output for goto_dlg_rk
handles.output = 'Cancel';

% Update handles structure
guidata(hObject, handles);




% Insert custom Title and Text if specified by the user
% Hint: when choosing keywords, be sure they are not easily confused 
% with existing figure properties.  See the output of set(figure) for
% a list of figure properties.
handles.XY = [];
handles.Scope = [];
if(nargin > 3)
    for index = 1:2:(nargin-3),
        if nargin-3==index, break, end
        switch lower(varargin{index})
            case 'title'
                ttitle = varargin{index+1};
                set(hObject, 'Name', ttitle);
            case 'string'
                set(handles.Message, 'String', varargin{index+1});
            case 'scopedata'
                handles.Scope = varargin{index+1};
            case 'xydata'
                handles.XY = varargin{index+1};
        end
    end
end
if isempty(handles.XY)
    str = ['Error!' 10 13 'XY Stage data was not provided'];
    infodlg('Title', ttitle, 'String', str);
end
if isempty(handles.Scope)
    if handles.XY.ZLeica
        str = ['Error!' 10 13 'Data for Leica Scope was not provided'];
        infodlg('Title', ttitle, 'String', str);
    end
    handles.XY.ZLeica = 0;
end

% Determine the position of the dialog - to the right edge of the callback figure
% if available, else, centered on the screen
FigPos=get(0,'DefaultFigurePosition');
OldUnits = get(hObject, 'Units');
set(hObject, 'Units', 'pixels');
OldPos = get(hObject,'Position');
FigWidth = OldPos(3);
FigHeight = OldPos(4);
if isempty(gcbf)
    ScreenUnits=get(0,'Units');
    set(0,'Units','pixels');
    ScreenSize=get(0,'ScreenSize');
    set(0,'Units',ScreenUnits);

    FigPos(1)=1/2*(ScreenSize(3)-FigWidth);
    FigPos(2)=2/3*(ScreenSize(4)-FigHeight);
else
    GCBFOldUnits = get(gcbf,'Units');
    set(gcbf,'Units','pixels');
    GCBFPos = get(gcbf,'Position');
    set(gcbf,'Units',GCBFOldUnits);
    FigPos(1:2) = [(GCBFPos(1) + GCBFPos(3)) - FigWidth, ...
                   (GCBFPos(2) + GCBFPos(4) / 2) - FigHeight / 2];
end
FigPos(3:4)=[FigWidth FigHeight];
set(hObject, 'Position', FigPos);
set(hObject, 'Units', OldUnits);



global CCCdata

% Set up video (RK)
handles.video =  CCCdata.Vid.Camera{1}.Object;  %;

set(handles.video,'TimerPeriod', 0.05, ...
'TimerFcn',['if(~isempty(gco)),'...
'handles=guidata(gcf);'... % Update handles
'image(getsnapshot(handles.video));'... % Get picture using GETSNAPSHOT and put it into axes using IMAGE
'set(handles.cameraAxes,''ytick'',[],''xtick'',[]),'... % Remove tickmarks and labels that are inserted when using IMAGE
'else '...
'delete(imaqfind);'... % Clean up - delete any image acquisition objects
'end']);
triggerconfig(handles.video,'manual');
handles.video.FramesPerTrigger = Inf; % Capture frames until we manually stop it
start(handles.video)

clear CCCdata

handles.t = timer('Period', 0.5, 'TasksToExecute', 1000, 'TimerFcn', @update_XY, 'BusyMode', 'drop', 'ExecutionMode', 'fixedSpacing');
set(handles.t, 'UserData', handles.goto_dlg_rk);
guidata(hObject, handles);
if ~isempty(handles.XY) && ~isempty(handles.Scope)
    %start(handles.t);
end

disp('hello')

% Make the GUI modal
%set(handles.goto_dlg_rk,'WindowStyle','modal')



% UIWAIT makes goto_dlg_rk wait for user response (see UIRESUME)
uiwait(handles.goto_dlg_rk);

% --- Outputs from this function are returned to the command line.
function varargout = goto_dlg_rk_OutputFcn(hObject, eventdata, handles)

% Get default command line output from handles structure
varargout{1} = handles.output;

stop(handles.t);
delete(handles.t);

% The figure can be deleted now
delete(handles.goto_dlg_rk);

% --- Executes on button press in OK.
function OK_Callback(hObject, eventdata, handles)

handles.output = get(hObject,'String');

% Update handles structure
guidata(hObject, handles);

% Use UIRESUME instead of delete because the OutputFcn needs
% to get the updated handles structure.
uiresume(handles.goto_dlg_rk);

% --- Executes on button press in Cancel.
function Cancel_Callback(hObject, eventdata, handles)

handles.output = get(hObject,'String');

% Update handles structure
guidata(hObject, handles);

% Use UIRESUME instead of delete because the OutputFcn needs
% to get the updated handles structure.
uiresume(handles.goto_dlg_rk);


% --- Executes when user attempts to close goto_dlg_rk.
function goto_dlg_rk_CloseRequestFcn(hObject, eventdata, handles)

if isequal(get(handles.goto_dlg_rk, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    uiresume(handles.goto_dlg_rk);
end


% --- Executes on key press over goto_dlg_rk with no controls selected.
function goto_dlg_rk_KeyPressFcn(hObject, eventdata, handles)

% Check for "enter" or "escape"
if isequal(get(hObject,'CurrentKey'),'escape')
    % User said cancel by hitting escape
    handles.output = 'Cancel';
    % Update handles structure
    guidata(hObject, handles);
    
    uiresume(handles.goto_dlg_rk);
end    
    
if isequal(get(hObject,'CurrentKey'),'return')
    % Pressing enter is equivalent to pressing OK
    handles.output = 'OK';
    % Update handles structure
    guidata(hObject, handles);
    
    uiresume(handles.goto_dlg_rk);
end    

% Update the coordinates display
function update_XY(hObject, eventdata)

cbo = get(hObject, 'UserData');
handles = guidata(cbo);
if handles.XY.ZLeica
    % [status1, xy] = oasis_read_xy();
    [status2, x] = leica_get_x(handles.Scope.Port);
    [status2, y] = leica_get_y(handles.Scope.Port);
    [status2, z] = leica_get_z(handles.Scope.Port);
    if handles.XY.Calibrated
        zorig = handles.XY.Origin(3);
    else
        [status2, zorig] = leica_get_focus(handles.Scope.Port);
    end
    z = (z - zorig) * handles.Scope.Zfactor;
    units_z = ' um ';
    xyz = [x; y; z];
else
    %[status1, xyz] = oasis_read_xyz();
    status2 = 0;
    units_z = '  ';
end
if handles.XY.Calibrated
    xyz(1:2) = inv(handles.XY.TMatrix)*(xyz(1:2) - handles.XY.Origin(1:2));
    units_xy = ' um ';
else
    units_xy = '  ';
end
set(handles.X, 'String', [num2str(xyz(1), '%6.2f') units_xy]);
set(handles.Y, 'String', [num2str(xyz(2), '%6.2f') units_xy]);
set(handles.Z, 'String', [num2str(xyz(3), '%6.2f') units_z]);

