function varargout = qimaging_config(varargin)
% QIMAGING_CONFIG M-file for qimaging_config.fig
%      QIMAGING_CONFIG, by itself, creates a new QIMAGING_CONFIG or raises the existing
%      singleton*.
%
%      H = QIMAGING_CONFIG returns the handle to a new QIMAGING_CONFIG or the handle to
%      the existing singleton*.
%
%      QIMAGING_CONFIG('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in QIMAGING_CONFIG.M with the given input arguments.
%
%      QIMAGING_CONFIG('Property','Value',...) creates a new QIMAGING_CONFIG or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before qimaging_config_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to qimaging_config_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help qimaging_config

% Last Modified by GUIDE v2.5 21-Aug-2006 15:55:36

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @qimaging_config_OpeningFcn, ...
                   'gui_OutputFcn',  @qimaging_config_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes just before qimaging_config is made visible.
function qimaging_config_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to qimaging_config (see VARARGIN)

% Get all parameters from the camera and update controls
handles.Source = varargin{1};

% AbsoluteOffset
handles.OffsetProp = propinfo(handles.Source, 'AbsoluteOffset');
set(handles.OffsetTxt, 'String', handles.Source.AbsoluteOffset);
set(handles.OffsetSlider, 'Value', handles.Source.AbsoluteOffset);
minval = handles.OffsetProp.ConstraintValue(1);
maxval = handles.OffsetProp.ConstraintValue(2);
set(handles.OffsetSlider, 'min', minval);
set(handles.OffsetSlider, 'max', maxval);
set(handles.OffsetSlider, 'SliderStep', [10 100]/(maxval - minval));

% NormalizedGain
handles.GainProp = propinfo(handles.Source, 'NormalizedGain');
handles.GainProp.ConstraintValue(1) = 0.817;
set(handles.GainTxt, 'String', handles.Source.NormalizedGain);
set(handles.GainSlider, 'Value', handles.Source.NormalizedGain);
minval = handles.GainProp.ConstraintValue(1);
maxval = handles.GainProp.ConstraintValue(2);
set(handles.GainSlider, 'min', minval);
set(handles.GainSlider, 'max', maxval);
set(handles.GainSlider, 'SliderStep', [1 5]/(maxval - minval));

% Exposure
handles.ExposureProp = propinfo(handles.Source, 'Exposure');
set(handles.ExposureTxt, 'String', num2str(handles.Source.Exposure, '%1.2e'));
set(handles.ExposureSlider, 'Value', log(handles.Source.Exposure));
minval = handles.ExposureProp.ConstraintValue(1);
maxval = handles.ExposureProp.ConstraintValue(2);
set(handles.ExposureSlider, 'min', log(minval));
set(handles.ExposureSlider, 'max', log(maxval));
set(handles.ExposureSlider, 'SliderStep', [0.01 0.1]);

% CoolingChk
handles.CoolingProp = propinfo(handles.Source, 'Cooling');
set(handles.CoolingChk, 'Value', str2on(handles.Source.Cooling));

% BlackoutChk
handles.BlackoutProp = propinfo(handles.Source, 'Blackout');
set(handles.BlackoutChk, 'Value', str2on(handles.Source.Blackout));

% HighSensitivityChk
handles.HighSensitivityProp = propinfo(handles.Source, 'HighSensitivity');
set(handles.HighSensitivityChk, 'Value', str2on(handles.Source.HighSensitivity));

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes qimaging_config wait for user response (see UIRESUME)
uiwait(handles.qimaging_config);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Outputs from this function are returned to the command line.
function varargout = qimaging_config_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Return camera settings
settings.AbsoluteOffset = handles.Source.AbsoluteOffset;
settings.NormalizedGain = handles.Source.NormalizedGain;
settings.Exposure = handles.Source.Exposure;
settings.Cooling = handles.Source.Cooling;
settings.Blackout = handles.Source.Blackout;
settings.HighSensitivity = handles.Source.HighSensitivity;

varargout{1} = settings;

% close figure
delete(handles.qimaging_config);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on slider movement.
function Slider_Callback(hObject, eventdata, handles)

v = get(hObject, 'Value');
tag = get(hObject, 'Tag');
switch lower(tag)
    case 'offsetslider'
        v = round(v);
        hTxt = handles.OffsetTxt;
        minval = handles.OffsetProp.ConstraintValue(1);
        maxval = handles.OffsetProp.ConstraintValue(2);
        prop = 'AbsoluteOffset';
    case 'gainslider'
        v = round(v*1000)/1000;
        hTxt = handles.GainTxt;
        minval = handles.GainProp.ConstraintValue(1);
        maxval = handles.GainProp.ConstraintValue(2);
        prop = 'NormalizedGain';
    case 'exposureslider'
        hTxt = handles.ExposureTxt;
        minval = handles.ExposureProp.ConstraintValue(1);
        maxval = handles.ExposureProp.ConstraintValue(2);
        v = exp(v);
        prop = 'Exposure';
end
if ~isempty(prop)
    if (v < minval)
        v = minval;
    elseif (v > maxval)
        v = maxval;
    end
    set(handles.Source, prop, v);
    v = get(handles.Source, prop);
    switch prop
        case 'Exposure'
            set(hTxt, 'String', num2str(v, '%1.2e'));
            set(hObject, 'Value', log(v));
        otherwise
            set(hObject, 'Value', v);
            set(hTxt, 'String', v);
    end
end



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Txt_Callback(hObject, eventdata, handles)

v = str2double(get(hObject, 'String'));
if ~isempty(v)
    tag = get(hObject, 'Tag');
    prop = '';
    switch lower(tag)
        case 'offsettxt'
            v = round(v);
            hSlider = handles.OffsetSlider;
            minval = handles.OffsetProp.ConstraintValue(1);
            maxval = handles.OffsetProp.ConstraintValue(2);
            prop = 'AbsoluteOffset';
        case 'gaintxt'
             v = round(v*1000)/1000;
            hSlider = handles.GainSlider;
            minval = handles.GainProp.ConstraintValue(1);
            maxval = handles.GainProp.ConstraintValue(2);
            prop = 'NormalizedGain';
        case 'exposuretxt'
            hSlider = handles.ExposureSlider;
            minval = handles.ExposureProp.ConstraintValue(1);
            maxval = handles.ExposureProp.ConstraintValue(2);
            prop = 'Exposure';
    end
    if ~isempty(prop)
        if (v < minval)
            v = minval;
        elseif (v > maxval)
            v = maxval;
        end
        set(handles.Source, prop, v);
        v = get(handles.Source, prop);
        switch prop
            case 'Exposure'
                set(hSlider, 'Value', log(v));
                set(hObject, 'String', num2str(v, '%1.2e'));
            otherwise
                set(hSlider, 'Value', v);
                set(hObject, 'String', v);
        end
    end
else
    OldVal = get(hSlider, 'Value');
    switch prop
        case 'Exposure'
            set(hObject, 'Value', exp(OldVal));
        otherwise
            set(hObject, 'Value', OldVal);
    end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on check box change
function CheckBox_Callback(hObject, eventdata, handles)

on = get(hObject, 'Value');
tag = get(hObject, 'Tag');
switch lower(tag)
    case 'coolingchk'
        handles.Source.Cooling = on2str(on);
    case 'blackoutchk'
        handles.Source.Blackout = on2str(on);
    case 'highsensitivitychk'
        handles.Source.HighSensitivity = on2str(on);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in Close.
function Close_Callback(hObject, eventdata, handles)
% hObject    handle to Close (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

uiresume(handles.qimaging_config);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in Defaults.
function Defaults_Callback(hObject, eventdata, handles)

% AbsoluteOffset
v = handles.OffsetProp.DefaultValue;
handles.Source.AbsoluteOffset = v;
set(handles.OffsetTxt, 'String', v);
set(handles.OffsetSlider, 'Value', v);

% Normalized Gain
v = handles.GainProp.DefaultValue;
handles.Source.NormalizedGain = v;
set(handles.GainTxt, 'String', v);
set(handles.GainSlider, 'Value', v);

% Exposure
v = handles.ExposureProp.DefaultValue;
handles.Source.Exposure = v;
set(handles.ExposureTxt, 'String', num2str(v, '%1.2e'));
set(handles.ExposureSlider, 'Value', log(v));

% CoolingChk
v = handles.CoolingProp.DefaultValue;
handles.Source.Cooling = v;
set(handles.CoolingChk, 'Value', str2on(v));

% BlackoutChk
v = handles.BlackoutProp.DefaultValue;
handles.Source.Blackout = v;
set(handles.BlackoutChk, 'Value', str2on(v));

% HighSensitivityChk
v = handles.HighSensitivityProp.DefaultValue;
handles.Source.HighSensitivity = v;
set(handles.HighSensitivityChk, 'Value', str2on(v));


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in Save.
function Save_Callback(hObject, eventdata, handles)

cd(pwd);
[fname, fpath] = uiputfile('*_qimaging.mat', 'Save Settings As');
if ~isequal(fname, 0) && ~isequal(fpath, 0)
    settings.AbsoluteOffset = handles.Source.AbsoluteOffset;
    settings.NormalizedGain = handles.Source.NormalizedGain;
    settings.Exposure = handles.Source.Exposure;
    settings.Cooling = handles.Source.Cooling;
    settings.Blackout = handles.Source.Blackout;
    settings.HighSensitivity = handles.Source.HighSensitivity;

    try
        save([fpath fname], 'settings');
    catch
        infodlg('Title', 'Saving Settings', 'String', ['Error!' 10 13 'Cannot save the settings!']);
    end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in Load.
function Load_Callback(hObject, eventdata, handles)

cd(pwd);
[fname, fpath] = uigetfile('*_qimaging.mat', 'Load Settings From');
if ~isequal(fname, 0) && ~isequal(fpath, 0)
    try
        qimaging = load([fpath fname], 'settings');
    catch
        infodlg('Title', 'Loading Settings', 'String', ['Error!' 10 13 'Cannot load the settings!']);
    end
    if exist('qimaging', 'var') && ~isempty(qimaging) && ~isempty(qimaging.settings)
        handles.Source.AbsoluteOffset = qimaging.settings.AbsoluteOffset;
        set(handles.OffsetSlider, 'Value', qimaging.settings.AbsoluteOffset);
        set(handles.OffsetTxt, 'String', qimaging.settings.AbsoluteOffset);
        handles.Source.NormalizedGain = qimaging.settings.NormalizedGain;
        set(handles.GainSlider, 'Value', qimaging.settings.NormalizedGain);
        set(handles.GainTxt, 'String', qimaging.settings.NormalizedGain);
        handles.Source.Exposure = qimaging.settings.Exposure;
        set(handles.ExposureTxt, 'String', num2str(qimaging.settings.Exposure, '%1.2e'));
        set(handles.ExposureSlider, 'Value', log(qimaging.settings.Exposure));

        handles.Source.Cooling = qimaging.settings.Cooling;
        set(handles.CoolingChk, 'Value', str2on(qimaging.settings.Cooling));
        handles.Source.Blackout = qimaging.settings.Blackout;
        set(handles.BlackoutChk, 'Value', str2on(qimaging.settings.Blackout));
        handles.Source.HighSensitivity = qimaging.settings.HighSensitivity;
        set(handles.HighSensitivityChk, 'Value', str2on(qimaging.settings.HighSensitivity));
    else
        infodlg('Title', 'Loading Settings', 'String', ['Error!' 10 13 'File is not valid!']);
    end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function on = str2on(str)

switch lower(str)
    case 'off'
        on = 0;
    case 'on'
        on = 1;
    otherwise
        on = 0;
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function str = on2str(on)

if on
    str = 'on';
else
    str = 'off';
end



