% Saves the chamber grouping levels

groups0 = {[1 3]; []; [7 8]; [9 10]; [11 12]; [13 14]};

for groupsize = [2 4 6 8 12 16 24 32 48]
    prefix = [];
    grp_idx = [1 3 4 5 6];
    switch groupsize
        case 2
            ng = 1;
        case 4
            ng = 2;
        case 6
            ng = 1;
            grp_idx = 1;
            prefix = [4 5 6];
        case 8
            ng = 3;
        case 12
            ng = 2;
            prefix = [4 5 6];
        case 16
            ng = 4;
        case 24
            ng = 3;
            prefix = [4 5 6];
        case 32
            ng = 5;
        case 48
            ng = 4;
            prefix = [4 5 6];
    end

    lvl_idx = nchoosek(grp_idx, ng);
    sl = size(lvl_idx);
    nl = sl(1);
    valves = [];
    levels = {};
    for ii = 1:nl
        levels{ii} = num2str(ii);
        ll = prefix;
        for jj = 1:ng
            ll = [ll groups0{lvl_idx(ii, jj)}];
        end
        valves = [valves; ll];
    end    
    fname = ['MuxGrouping_' num2str(groupsize) '.mat'];
    save(fname, 'levels', 'valves');
end
