function send_email(email,subject,message)
% SEND_EMAILS sends email messages.
%    send_text_message(email,subject,message) sends an email to the
%    specified recipient.
%    EMAIL is the e-mail address of the recipient.
%    SUBJECT is the subject of the message
%    MESSAGE is the content of the message
% 
%    Example:
%      send_text_message('234-567-8910','Cingular', ...
%         'Calculation Done','Don't forget to retrieve your result file')
% R. Gomez-Sjoberg 2/21/07

% =========================================================================
myemail = 'CellCultureChipQuake@gmail.com'; %The chip's GMail email address
mypassword = 'microfluidics';               %The chip's GMail password
% =========================================================================

if nargin == 2
    message = subject;
    subject = '';
end

%% Set up Gmail SMTP service.
% Note: following code found from
% http://www.mathworks.com/support/solutions/data/1-3PRRDV.html
% If you have your own SMTP server, replace it with yours.
setpref('Internet','E_mail',myemail);
setpref('Internet','SMTP_Server','smtp.gmail.com');
setpref('Internet','SMTP_Username',myemail);
setpref('Internet','SMTP_Password',mypassword);
props = java.lang.System.getProperties;
props.setProperty('mail.smtp.auth','true');
props.setProperty('mail.smtp.socketFactory.class', 'javax.net.ssl.SSLSocketFactory');
props.setProperty('mail.smtp.socketFactory.port','465');

%% Send the email
sendmail(email,subject,message);

