function varargout = SCCC(varargin)

% startup


% SCCC MATLAB code for SCCC.fig
%      SCCC, by itself, creates a new SCCC or raises the existing
%      singleton*.
%
%      H = SCCC returns the handle to a new SCCC or the handle to
%      the existing singleton*.
%
%      SCCC('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SCCC.M with the given input arguments.
%
%      SCCC('Property','Value',...) creates a new SCCC or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before SCCC_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to SCCC_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help SCCC

% Last Modified by GUIDE v2.5 06-Nov-2014 14:57:29

% Begin initialization code - DO NOT EDIT

clc; %clear command window

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @SCCC_OpeningFcn, ...
                   'gui_OutputFcn',  @SCCC_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before SCCC is made visible.
function SCCC_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to SCCC (see VARARGIN)

% Choose default command line output for SCCC
handles.output = hObject;
%im = imread( 'TrappingChamber-01.png' );
%imshow(im)
global vc;
global chipdata;

%% Parameters for connecting to two controller boxes
% Number of boxes
vc.num = 2;

% Serial number of USB interface in box #1
vc.info(1).sn = 'ELUJJQBW'; % My System - valves 0-23
vc.info(1).handle = 0;
vc.info(1).status = 0;
vc.info(1).polarity = logical([ones(1, 24)]);

% Serial number of USB interface in box #2
vc.info(2).sn = 'ELV6N6GI'; % My system first valves 24-47
vc.info(2).handle = 0;
vc.info(2).status = 0;
vc.info(2).polarity = logical([1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]); % For 4th floor test system

%% Open connection to controller boxes
vc = vc_open_setup(vc);
% Check status of both connections
disp(['Status of box#1 = ' num2str(vc.info(1).status)]);
disp(['Status of box#2 = ' num2str(vc.info(2).status)]);

%%%%SPECIFY NEEDED PARAMETERS
chipdata.No_Valves = 48; % Specify the number of valves the chip has

chipdata.P01v01=33; %set pump valve #s here
chipdata.P01v02=15; %set pump valve #s here
chipdata.P01v03=16; %set pump valve #s here
chipdata.P01v04=17; %set pump valve #s here
chipdata.P01NoCyc = 100; %should match default values on .fig
chipdata.P01timing = 100/1000; %should match default values on .fig

chipdata.P02v01=6; %set pump valve #s here
chipdata.P02v02=7; %set pump valve #s here 
chipdata.P02v03=8; %set pump valve #s here 
chipdata.P02NoCyc = 100; %should match default values on .fig
chipdata.P02timing = 100/1000; %should match default values on .fig

chipdata.valve_close_color = [1 0 0];
chipdata.valve_open_color = [0 0.5 0];
chipdata.buttoncolor=[0.91,0.91,0.91];
chipdata.color.c = [1 0 0];
chipdata.color.o = [0 0.5 0];
chipdata.names={'V_00','V_01','V_02','V_03','V_04','V_05','V_06','V_07','V_08',...
    'V_09','V_10','V_11','V_12','V_13','V_14','V_15','V_16','V_17','V_18',...
    'V_19','V_20','V_21','V_22','V_23','V_24','V_25','V_26','V_27','V_28',...
    'V_29','V_30','V_31','V_32','V_33','V_34','V_35','V_36','V_37','V_38',...
    'V_39','V_40','V_41','V_42','V_43','V_44','V_45','V_46','V_47'}; %need to MANUALLY set to # of valves
    % MANUALLy specify here so that other commands will update button color
chipdata.All_valves = [00,01,02,03,04,05,06,07,08,09,10,11,12,13,14,15,16,17,...
    18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,...
    42,43,44,45,46,47];%need to MANUALLY set to # of valves


%% Chipdata for automatic program

chipdata.Ligands=zeros(1,16); % Gives if ligand is active or not 
chipdata.LigandNames={'Ligand1','Ligand2','Ligand3','Ligand4','Ligand5','Ligand6','Ligand7','Ligand8','Ligand9','Ligand10','Ligand11','Ligand12','Ligand13','Ligand14','Ligand15','Ligand16'};
chipdata.LigandValueMatrix=load('Ligand_Matrix');
chipdata.LigandValves=[0 1 2 3 4 5 6 7];

%% Valve Names

chipdata.QuickDamp=[32,16];
chipdata.Waste=[30,43];
chipdata.Pipelette=[15,31];
chipdata.Channel1In=[11 9 36 38];
chipdata.Channel2In=[10 8 37 39];
chipdata.Channel1Out=42;

%% Chamber 
chipdata.ChambersA=[0 0 0 0 0 0 0 0 0 0 0 0];
chipdata.ChambersB=[0 0 0 0 0 0 0 0 0 0 0 0];
chipdata.ChambersC=[0 0 0 0 0 0 0 0 0 0 0 0];
chipdata.ChambersD=[0 0 0 0 0 0 0 0 0 0 0 0];
chipdata.Chambers=zeros(4,12);
chipdata.Columns=[18 19 20 21 22 23 24 25 26 27 28 29];
chipdata.ChamberLigands=ones(4,12);
chipdata.ChamberCheck=zeros(4,12);
chipdata.SEED=13;
chipdata.SOURCE=[12,14];

chipdata.CultureStop=FALSE;
chipdata.CultureProgram='CULTURE_MODE';
chipdata.CultureWasteTime=0;
chipdata.CultureRefillCycles=0;
chipdata.CultureWaste=1;


%%%%END of SPECIFY NEEDED PARAMETERS

guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = SCCC_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in CLOSE_ALL.
function CLOSE_ALL_Callback(hObject, eventdata, handles)
global vc chipdata
numbers = 0:(chipdata.No_Valves-1);
values =  zeros(1, chipdata.No_Valves);
%c=size(chipdata.aux_names,2); % Returns number of valves being manipulated
vc = vc_set_bits_ac(vc, numbers, values);
for i=1:chipdata.No_Valves;
    set(handles.(chipdata.names{(i)}), 'BackgroundColor', chipdata.valve_close_color); % resets color of buttons
end
%for j=1:c;
%    set(handles.(chipdata.aux_names{(j)}), 'BackgroundColor', chipdata.valve_close_color); % resets color of buttons
%end
clear vc chipdata

% --- Executes on button press in CLOSE_control.
function CLOSE_control_Callback(hObject, eventdata, handles)
global vc;
opt = YesNoQuestion('Title', 'Close Controllers', 'String', ...
    'Are you sure you want to Close Valve Controllers?');
switch lower(opt)
    case 'yes'
        vc = vc_close(vc, 1);
        'contollers closed'
end
clear vc

% --- Executes on button press in Open_All.
function Open_All_Callback(hObject, eventdata, handles)
global vc chipdata
numbers = 0:(chipdata.No_Valves-1);
values =  ones(1, chipdata.No_Valves);
%c=size(chipdata.aux_names,2); % Returns number of valves being manipulated
vc = vc_set_bits_ac(vc, numbers, values);
for i=1:chipdata.No_Valves;
    set(handles.(chipdata.names{(i)}), 'BackgroundColor', chipdata.valve_open_color); % resets color of buttons
end
clear vc chipdata

% --- This is the basic function of switching the valves from open <-> closed which is called by the individual valves.
function V_XX_Callback(hObject, eventdata, handles)
global vc chipdata;
V_num = str2double(get(hObject,'String'));
  [vc, value] = vc_get_1bit(vc, V_num);
if value == 1
  vc = vc_set_1bit(vc, V_num, 0);
  [vc, value] = vc_get_1bit(vc, V_num);
set(hObject, 'BackgroundColor', chipdata.valve_close_color);
else
  vc = vc_set_1bit(vc, V_num, 1);
  [vc, value] = vc_get_1bit(vc, V_num);
set(hObject, 'BackgroundColor', chipdata.valve_open_color);
end
clear vc chipdata

% --- Executes on button press in V_00.
function V_00_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_01.
function V_01_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_02.
function V_02_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_03.
function V_03_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_04.
function V_04_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_05.
function V_05_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_06.
function V_06_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_07.
function V_07_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_08.
function V_08_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_09.
function V_09_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_10.
function V_10_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_11.
function V_11_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_12.
function V_12_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_19.
function V_13_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_14.
function V_14_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata

% --- Executes on button press in V_15.
function V_15_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_16.
function V_16_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_17.
function V_17_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_18.
function V_18_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_19.
function V_19_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_20.
function V_20_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_21.
function V_21_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_22.
function V_22_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_23.
function V_23_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_24.
function V_24_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_25.
function V_25_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_26.
function V_26_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_27.
function V_27_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_28.
function V_28_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_29.
function V_29_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_30.
function V_30_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_31.
function V_31_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_32.
function V_32_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_33.
function V_33_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_34.
function V_34_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_35.
function V_35_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_36.
function V_36_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_37.
function V_37_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_38.
function V_38_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
function V_39_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_40.
function V_40_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_41.
function V_41_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_42.
function V_42_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_43.
function V_43_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_44.
function V_44_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_45.
function V_45_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_46.
function V_46_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata
% --- Executes on button press in V_47.
function V_47_Callback(hObject, eventdata, handles)
global vc chipdata;
V_XX_Callback(hObject, eventdata, handles) %executes the called function
clear vc chipdata

% --- Executes on button press in Quit.
%function Quit_Callback(hObject, eventdata, handles)
%global vc;
%opt = YesNoQuestion('Title', 'Quit ???', 'String', ...
%    'Are you sure you want to quit?');
%switch lower(opt)
%    case 'yes'
%        vc = vc_close(vc, 1);
%        close all
%        clear vc
%end

% --- Executes on button press in close_pump01.
function close_pump01_Callback(hObject, eventdata, handles)
global vc chipdata;
numbers = [chipdata.P01v01, chipdata.P01v02, chipdata.P01v03, chipdata.P01v04];
values =  [0, 0, 0, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_close_color); %+1 to adust for valve V_00
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor', chipdata.valve_close_color);
clear vc chipdata
% --- Executes on button press in close_pump02.
function close_pump02_Callback(hObject, eventdata, handles)
global vc chipdata;
numbers = [chipdata.P02v01, chipdata.P02v02, chipdata.P02v03];
values =  [0, 0, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P02v01+1)}), 'BackgroundColor', chipdata.valve_close_color); %+1 to adust for valve V_00
set(handles.(chipdata.names{(chipdata.P02v02+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P02v03+1)}), 'BackgroundColor', chipdata.valve_close_color);
clear vc chipdata

% --- Executes on button press in open_pump01.
function open_pump01_Callback(hObject, eventdata, handles)
global vc chipdata;
numbers = [chipdata.P01v01, chipdata.P01v02, chipdata.P01v03, chipdata.P01v04];
values =  [1, 1, 1, 1];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_open_color); %+1 to adust for valve V_00
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor', chipdata.valve_open_color);
clear vc chipdata
% --- Executes on button press in open_pump02.
function open_pump02_Callback(hObject, eventdata, handles)
global vc chipdata;
numbers = [chipdata.P02v01, chipdata.P02v02, chipdata.P02v03];
values =  [1, 1, 1];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P02v01+1)}), 'BackgroundColor', chipdata.valve_open_color); %+1 to adust for valve V_00
set(handles.(chipdata.names{(chipdata.P02v02+1)}), 'BackgroundColor', chipdata.valve_open_color); %
set(handles.(chipdata.names{(chipdata.P02v03+1)}), 'BackgroundColor', chipdata.valve_open_color); %
clear vc chipdata

function P01NoCyc_Callback(hObject, eventdata, handles)
global chipdata
chipdata.P01NoCyc = str2double(get(hObject,'String'));
% disp(['#cycles = ' num2str(chipdata.P01NoCyc)]);
clear chipdata
function P02NoCyc_Callback(hObject, eventdata, handles)
global chipdata
chipdata.P02NoCyc = str2double(get(hObject,'String'));
% disp(['#cycles = ' num2str(chipdata.P01NoCyc)]);
clear chipdata

function P01NoCyc_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function P02NoCyc_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function P01_timing_Callback(hObject, eventdata, handles)
global chipdata
timing = str2double(get(hObject,'String'));
chipdata.P01timing = timing / 1000; % convert to milliseconds
% disp(['#cylde delay (sec) = ' num2str(chipdata.P01timing)]); 
clear chipdata
function P02_timing_Callback(hObject, eventdata, handles)
global chipdata
timing = str2double(get(hObject,'String'));
chipdata.P02timing = timing / 1000; % convert to milliseconds
clear chipdata

% --- Executes during object creation, after setting all properties.
function P01_timing_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% --- Executes during object creation, after setting all properties.
function P02_timing_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in Pump_01.
function Pump_01_Callback(hObject, eventdata, handles)
% Left to Right 0100	0110	0010	0011	0001	1001
global vc chipdata;
numbers = [chipdata.P01v01, chipdata.P01v02, chipdata.P01v03, chipdata.P01v04];
chipdata.stop01=false;
i=0;
    while i<chipdata.P01NoCyc && ~chipdata.stop01
        i=i+1;
values =  [0, 1, 0, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor', chipdata.valve_close_color);
pause(chipdata.P01timing);
% State 2
values =  [0, 1, 1, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor',chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor',chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor',chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor',chipdata.valve_close_color);
pause(chipdata.P01timing);
% State 3
values =  [0, 0, 1, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor',chipdata.valve_close_color);
pause(chipdata.P01timing);
% State 4
values =  [0, 0, 1, 1];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor',chipdata.valve_open_color);
pause(chipdata.P01timing);
% State 5
values =  [0, 0, 0, 1];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor',chipdata.valve_open_color);
pause(chipdata.P01timing);
% State 6
values =  [1, 0, 0, 1];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor',chipdata.valve_open_color);
pause(chipdata.P01timing);
% State 7
values =  [1, 0, 0, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor',chipdata.valve_close_color);
pause(chipdata.P01timing);
% State 8
values =  [1, 1, 0, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor',chipdata.valve_close_color);
pause(chipdata.P01timing);
    end
chipdata.stop01=true;
clear vc chipdata

% --- Executes on button press in Pump_02.
function Pump_02_Callback(hObject, eventdata, handles)
% Left to Right 010	011	001	101	100	110
global vc chipdata;
numbers = [chipdata.P02v01, chipdata.P02v02, chipdata.P02v03];
chipdata.stop02=false;
i=0;
    while i<chipdata.P02NoCyc && ~chipdata.stop02
        i=i+1;
values =  [0, 1, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P02v01+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P02v02+1)}), 'BackgroundColor', chipdata.valve_open_color); 
set(handles.(chipdata.names{(chipdata.P02v03+1)}), 'BackgroundColor', chipdata.valve_close_color); 
pause(chipdata.P02timing);
% State 2
values =  [0, 1, 1];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P02v01+1)}), 'BackgroundColor',chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P02v02+1)}), 'BackgroundColor',chipdata.valve_open_color); 
set(handles.(chipdata.names{(chipdata.P02v03+1)}), 'BackgroundColor',chipdata.valve_open_color); 
pause(chipdata.P02timing);
% State 3
values =  [0, 0, 1];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P02v01+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P02v02+1)}), 'BackgroundColor', chipdata.valve_close_color); 
set(handles.(chipdata.names{(chipdata.P02v03+1)}), 'BackgroundColor', chipdata.valve_open_color); 
pause(chipdata.P02timing);
% State 4
values =  [1, 0, 1];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P02v01+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P02v02+1)}), 'BackgroundColor', chipdata.valve_close_color); 
set(handles.(chipdata.names{(chipdata.P02v03+1)}), 'BackgroundColor', chipdata.valve_open_color); 
pause(chipdata.P02timing);
% State 5
values =  [1, 0, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P02v01+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P02v02+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P02v03+1)}), 'BackgroundColor', chipdata.valve_close_color);
pause(chipdata.P02timing);
% State 6
values =  [1, 1, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P02v01+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P02v02+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P02v03+1)}), 'BackgroundColor', chipdata.valve_close_color); 
pause(chipdata.P02timing);
    end
chipdata.stop02=true;
clear vc chipdata

% --- Executes on button press in Pump01_Reverse.
function Pump01_Reverse_Callback(hObject, eventdata, handles)
% Left to Right 0100	0110	0010	0011	0001	1001 1000 1100
% Right to Left 010	110	100	101	001	011
global vc chipdata;
numbers = [chipdata.P01v01, chipdata.P01v02, chipdata.P01v03, chipdata.P01v04];
chipdata.stop01=false;
i=0;
    while i<chipdata.P01NoCyc && ~chipdata.stop01
        i=i+1;
values =  [0, 1, 0, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor', chipdata.valve_close_color);
pause(chipdata.P01timing);
% State 2
values =  [1, 1, 0,0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor',chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor',chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor',chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor', chipdata.valve_close_color);
pause(chipdata.P01timing);
% State 3
values =  [1, 0, 0,0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor', chipdata.valve_close_color);
pause(chipdata.P01timing);
% State 4
values =  [1, 0,0, 1];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor', chipdata.valve_open_color);
pause(chipdata.P01timing);
% State 5
values =  [0, 0, 0,1];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor', chipdata.valve_open_color);
pause(chipdata.P01timing);
% State 6
values =  [0, 0, 1, 1];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor', chipdata.valve_open_color);
pause(chipdata.P01timing);
% State 7
values =  [0, 0, 1, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor', chipdata.valve_close_color);
pause(chipdata.P01timing);
% State 8
values =  [0, 1, 1, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P01v01+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P01v02+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v03+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P01v04+1)}), 'BackgroundColor', chipdata.valve_close_color);
pause(chipdata.P01timing);
    end
chipdata.stop01=true;
clear vc chipdata

% --- Executes on button press in Pump02B_Reverse.
function Pump02_Reverse_Callback(hObject, eventdata, handles)
% Left to Right 010	011	001	101	100	110
% Right to Left 010	110	100	101	001	011
global vc chipdata;
numbers = [chipdata.P02v01, chipdata.P02v02, chipdata.P02v03];
chipdata.stop02=false;
i=0;
    while i<chipdata.P02NoCyc && ~chipdata.stop02
        i=i+1;
values =  [0, 1, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P02v01+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P02v02+1)}), 'BackgroundColor', chipdata.valve_open_color); 
set(handles.(chipdata.names{(chipdata.P02v03+1)}), 'BackgroundColor', chipdata.valve_close_color); %
pause(chipdata.P02timing);
% State 2
values =  [1, 1, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P02v01+1)}), 'BackgroundColor',chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P02v02+1)}), 'BackgroundColor',chipdata.valve_open_color); 
set(handles.(chipdata.names{(chipdata.P02v03+1)}), 'BackgroundColor',chipdata.valve_close_color);
pause(chipdata.P02timing);
% State 3
values =  [1, 0, 0];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P02v01+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P02v02+1)}), 'BackgroundColor', chipdata.valve_close_color); 
set(handles.(chipdata.names{(chipdata.P02v03+1)}), 'BackgroundColor', chipdata.valve_close_color);
pause(chipdata.P02timing);
% State 4
values =  [1, 0, 1];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P02v01+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P02v02+1)}), 'BackgroundColor', chipdata.valve_close_color); 
set(handles.(chipdata.names{(chipdata.P02v03+1)}), 'BackgroundColor', chipdata.valve_open_color); 
pause(chipdata.P02timing);
% State 5
values =  [0, 0, 1];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P02v01+1)}), 'BackgroundColor', chipdata.valve_close_color);
set(handles.(chipdata.names{(chipdata.P02v02+1)}), 'BackgroundColor', chipdata.valve_close_color); 
set(handles.(chipdata.names{(chipdata.P02v03+1)}), 'BackgroundColor', chipdata.valve_open_color); 
pause(chipdata.P02timing);
% State 6
values =  [0, 1, 1];
vc = vc_set_bits_ac(vc, numbers, values);
set(handles.(chipdata.names{(chipdata.P02v01+1)}), 'BackgroundColor', chipdata.valve_open_color);
set(handles.(chipdata.names{(chipdata.P02v02+1)}), 'BackgroundColor', chipdata.valve_close_color); 
set(handles.(chipdata.names{(chipdata.P02v03+1)}), 'BackgroundColor', chipdata.valve_close_color); 
pause(chipdata.P02timing);
    end
chipdata.stop02=true;
clear vc chipdata

% --- Executes on button press in stop_P01.
function stop_P01_Callback(hObject, eventdata, handles)
global chipdata
chipdata.stop01=1;
clear chipdata
% --- Executes on button press in stop_P02.
function stop_P02_Callback(hObject, eventdata, handles)
global chipdata
chipdata.stop02=1;
clear chipdata

%% MULTIPLEXER FUNCTON

function LigandX_Callback(NUMBER,hObject, eventdata, handles)
global vc chipdata
if chipdata.Ligands(NUMBER)==0
    values =  chipdata.LigandValueMatrix(NUMBER,:);
    b=size(chipdata.multiplexer,2);
    vc = vc_set_bits_ac(vc, chipdata.LigandValves, values);
    for i=1:8
     set(handles.(chipdata.LigandNames{i}), 'BackgroundColor', chipdata.buttoncolor);   
    end
    set(handles.(chipdata.LigandNames{NUMBER}), 'BackgroundColor', chipdata.valve_open_color);
    for i=1:b;
        if values(i)==0;
                set(handles.(chipdata.names{(chipdata.LigandValves(i)+1)}), 'BackgroundColor', chipdata.valve_close_color);
        elseif values(i)==1;
                set(handles.(chipdata.names{(chipdata.LigandValves(i)+1)}), 'BackgroundColor', chipdata.valve_open_color);
        end
    chipdata.Ligands(:)=0;
    chipdata.Ligands(NUMBER)=1;
end
else 
    values= [0 0 0 0 0 0 0 0];
    b=size(chipdata.Ligands,2);
    vc = vc_set_bits_ac(vc, chipdata.Ligands, values);
    set(handles.(chipdata.LigandNames{NUMBER}), 'BackgroundColor', chipdata.buttoncolor);
        for i=1:b;
            if values(i)==0;
                set(handles.(chipdata.names{(chipdata.LigandValves(i)+1)}), 'BackgroundColor', chipdata.valve_close_color);
            else if values(i)==1;
        set(handles.(chipdata.names{(chipdata.LigandValves(i)+1)}), 'BackgroundColor', chipdata.valve_open_color);
        end
    end
    chipdata.Ligands(NUMBER)=0;
end
end
clear vc chipdata

% --- Executes on button press in Ligand1.
function Ligand1_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(1,hObject, eventdata, handles)
clear vc chipdata

% --- Executes on button press in Ligand2.
function Ligand2_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(2,hObject, eventdata, handles)
clear vc chipdata

% --- Executes on button press in Ligand3.
function Ligand3_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(3,hObject, eventdata, handles)
clear vc chipdata

% --- Executes on button press in Ligand4.
function Ligand4_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(4,hObject, eventdata, handles)
clear vc chipdata

% --- Executes on button press in Ligand5.
function Ligand5_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(5,hObject, eventdata, handles)
clear vc chipdata

% --- Executes on button press in Ligand6.
function Ligand6_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(6,hObject, eventdata, handles)
clear vc chipdata

% --- Executes on button press in Ligand7.
function Ligand7_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(7,hObject, eventdata, handles)
clear vc chipdata


% --- Executes on button press in Ligand8.
function Ligand8_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(8,hObject, eventdata, handles)
clear vc chipdata

%% PIPELET HANDLING

%% GENERAL FUNCTION 
function Pipelet_Callback(NUMBER,CollectionBinMatrix,hObject, eventdata, handles)
global vc chipdata

if chipdata.CollectionBin(NUMBER)==0    
    %         [L R 1 2 3 4 5 6 7 8 F E D C B A]
    values =CollectionBinMatrix;
    b=size(chipdata.pipelet,2);
    vc = vc_set_bits_ac(vc, chipdata.pipelet, values);
    for k=1:96
    set(handles.(chipdata.CollectionBinNames{k}),'BackgroundColor', chipdata.buttoncolor)
    end
    set(handles.(chipdata.CollectionBinNames{NUMBER}),'BackgroundColor', chipdata.valve_open_color);
    for i=1:b;
        if values(i)==0;
        set(handles.(chipdata.names{(chipdata.pipelet(i)+1)}), 'BackgroundColor', chipdata.valve_close_color);
        elseif values(i)==1;
        set(handles.(chipdata.names{(chipdata.pipelet(i)+1)}), 'BackgroundColor', chipdata.valve_open_color);
        end
    end
    chipdata.CollectionBin(:)=0;
    chipdata.CollectionBin(NUMBER)=1;
else
    %         [L R 1 2 3 4 5 6 7 8 F E D C B A]
    values =  [0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0];
    b=size(chipdata.pipelet,2);
    vc = vc_set_bits_ac(vc, chipdata.pipelet, values);
    set(handles.(chipdata.CollectionBinNames{NUMBER}),'BackgroundColor', chipdata.buttoncolor)
    for i=1:b;
        if values(i)==0;
        set(handles.(chipdata.names{(chipdata.pipelet(i)+1)}), 'BackgroundColor', chipdata.valve_close_color);
        elseif values(i)==1;
        set(handles.(chipdata.names{(chipdata.pipelet(i)+1)}), 'BackgroundColor', chipdata.valve_open_color);
        end
    end
    chipdata.CollectionBin(NUMBER)=0;
end
clear vc chipdata

% --- Executes on button press in display_values.
function display_values_Callback(hObject, eventdata, handles)
global vc chipdata
% numbers = 0:(chipdata.No_Valves-1);
% % values =  zeros(1, chipdata.No_Valves);
% % [vv,rr] = vc_get_bits(vc, numbers);
% % % vv
% % rr
% [CCCdata, v] = vc_get_bits(vc, numbers);
% display(v)
% display(CCCdata)
% % % j=0:(chipdata.No_Valves-1);
% for i=1:chipdata.No_Valves;
% [ww, yy(i)] = vc_get_1bit(vc, i); % doesnt work with index for some reason
% vv(i+1) = yy(i);
% end
%  vv

% % % % [ww, tt] = vc_get_1bit(vc, 3);
% % % % % ww
% % % % tt
% % % % % % [vc, value] = vc_get_1bit(vc, V_num);
[ww, state_values(1)] = vc_get_1bit(vc, 0);
[ww, state_values(2)] = vc_get_1bit(vc, 1);
[ww, state_values(3)] = vc_get_1bit(vc, 2);
[ww, state_values(4)] = vc_get_1bit(vc, 3);
[ww, state_values(5)] = vc_get_1bit(vc, 4);
[ww, state_values(6)] = vc_get_1bit(vc, 5);
[ww, state_values(7)] = vc_get_1bit(vc, 6);
[ww, state_values(8)] = vc_get_1bit(vc, 7);
[ww, state_values(9)] = vc_get_1bit(vc, 8);
[ww, state_values(10)] = vc_get_1bit(vc, 9);
[ww, state_values(11)] = vc_get_1bit(vc, 10);
[ww, state_values(12)] = vc_get_1bit(vc, 11);
[ww, state_values(13)] = vc_get_1bit(vc, 12);
[ww, state_values(14)] = vc_get_1bit(vc, 13);
[ww, state_values(15)] = vc_get_1bit(vc, 14);
[ww, state_values(16)] = vc_get_1bit(vc, 15);
[ww, state_values(17)] = vc_get_1bit(vc, 16);
[ww, state_values(18)] = vc_get_1bit(vc, 17);
[ww, state_values(19)] = vc_get_1bit(vc, 18);
[ww, state_values(20)] = vc_get_1bit(vc, 19);
[ww, state_values(21)] = vc_get_1bit(vc, 20);
[ww, state_values(22)] = vc_get_1bit(vc, 21);
[ww, state_values(23)] = vc_get_1bit(vc, 22);
[ww, state_values(24)] = vc_get_1bit(vc, 23);
[ww, state_values(25)] = vc_get_1bit(vc, 24);
[ww, state_values(26)] = vc_get_1bit(vc, 25);
[ww, state_values(27)] = vc_get_1bit(vc, 26);
[ww, state_values(28)] = vc_get_1bit(vc, 27);
[ww, state_values(29)] = vc_get_1bit(vc, 28);
[ww, state_values(30)] = vc_get_1bit(vc, 29);
[ww, state_values(31)] = vc_get_1bit(vc, 30);
[ww, state_values(32)] = vc_get_1bit(vc, 31);
[ww, state_values(33)] = vc_get_1bit(vc, 32);
[ww, state_values(34)] = vc_get_1bit(vc, 33);
[ww, state_values(35)] = vc_get_1bit(vc, 34);
[ww, state_values(36)] = vc_get_1bit(vc, 35);
[ww, state_values(37)] = vc_get_1bit(vc, 36);
[ww, state_values(38)] = vc_get_1bit(vc, 37);
[ww, state_values(39)] = vc_get_1bit(vc, 38);
[ww, state_values(40)] = vc_get_1bit(vc, 39);
[ww, state_values(41)] = vc_get_1bit(vc, 40);
[ww, state_values(42)] = vc_get_1bit(vc, 41);
[ww, state_values(43)] = vc_get_1bit(vc, 42);
[ww, state_values(44)] = vc_get_1bit(vc, 43);
[ww, state_values(45)] = vc_get_1bit(vc, 44);
[ww, state_values(46)] = vc_get_1bit(vc, 45);
[ww, state_values(47)] = vc_get_1bit(vc, 46);
[ww, state_values(48)] = vc_get_1bit(vc, 47);
state_values
clear vc chipdata


timer2min = timer('TimerFcn','disp(''end of 2 min timer'')', 'StartDelay',...
    chipdata.Timer_2min_DELAY, 'StopFcn',...
    {@Timer_2min_Stop_Callback,chipdata.timer_2min_stop});
start(timer2min)
clear chipdata




start(timer20min)
clear chipdata









% --- Executes on selection change in LigandHarvestChoice.
function LigandHarvestChoice_Callback(hObject, eventdata, handles)
global chipdata
choice = get(hObject,'Value');
if choice == 1 %'Ligand 1'
    value=1;
elseif choice == 2 %'Ligand 2'
    value=2;
elseif choice == 3 %'Ligand 3'
    value=3;
elseif choice == 4 %'Ligand 4'
    value=4;
elseif choice == 5 %'Ligand 5'
    value=5;
elseif choice == 6 %'Ligand 6'
    value=6;
elseif choice == 7 %'Ligand 7'
    value=7;
elseif choice == 8 %'Ligand 8'
    value=8;
else
    value=1;
end
chipdata.LigandHarvestChoice =value; % convert to milliseconds
clear chipdata

%% BASIC VALVE FUNCTION %%%%
%% BASIC VALVE FUNCTION %%%%
%% BASIC VALVE FUNCTION %%%%
%% BASIC VALVE FUNCTION %%%%
%% BASIC VALVE FUNCTION %%%%

function OPEN_VALVES(NUMBERS,hObject, eventdata, handles)% ***MANUALLY*** % ***MANUALLY*** % ***MANUALLY*** 
global vc chipdata
values =  ones(1,length(NUMBERS));
b=size(NUMBERS,2);
vc = vc_set_bits_ac(vc, NUMBERS, values);
for i=1:b;
    if values(i)==0;
      set(handles.(chipdata.names{NUMBERS(i)+1}), 'BackgroundColor', chipdata.valve_close_color);
    else if values(i)==1;
      set(handles.(chipdata.names{NUMBERS(i)+1}), 'BackgroundColor', chipdata.valve_open_color);
        end
    end
end
clear vc chipdata

function CLOSE_VALVES(NUMBERS,hObject, eventdata, handles)% ***MANUALLY*** % ***MANUALLY*** % ***MANUALLY*** 
global vc chipdata
values =  zeros(1,length(NUMBERS));
b=size(NUMBERS,2);
vc = vc_set_bits_ac(vc, NUMBERS, values);
for i=1:b;
    if values(i)==0;
      set(handles.(chipdata.names{NUMBERS(i)+1}), 'BackgroundColor', chipdata.valve_close_color);
    else if values(i)==1;
      set(handles.(chipdata.names{NUMBERS(i)+1}), 'BackgroundColor', chipdata.valve_open_color);
        end
    end
end
clear vc chipdata

%% BASIC VALVE FUNCTION %%%%
%% BASIC VALVE FUNCTION %%%%
%% BASIC VALVE FUNCTION %%%%
%% BASIC VALVE FUNCTION %%%%
%% BASIC VALVE FUNCTION %%%%



function Ligand9_name_Callback(hObject, eventdata, handles)
% hObject    handle to Ligand9_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ligand9_name as text
%        str2double(get(hObject,'String')) returns contents of Ligand9_name as a double


% --- Executes during object creation, after setting all properties.
function Ligand9_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ligand9_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Ligand9.
function Ligand9_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(9,hObject, eventdata, handles)
clear vc chipdata



function Ligand10_name_Callback(hObject, eventdata, handles)
% hObject    handle to Ligand10_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ligand10_name as text
%        str2double(get(hObject,'String')) returns contents of Ligand10_name as a double


% --- Executes during object creation, after setting all properties.
function Ligand10_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ligand10_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Ligand10.
function Ligand10_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(10,hObject, eventdata, handles)
clear vc chipdata


% --- Executes on button press in Ligand11.
function Ligand11_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(11,hObject, eventdata, handles)
clear vc chipdata



function Ligand11_name_Callback(hObject, eventdata, handles)
% hObject    handle to Ligand11_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ligand11_name as text
%        str2double(get(hObject,'String')) returns contents of Ligand11_name as a double


% --- Executes during object creation, after setting all properties.
function Ligand11_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ligand11_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Ligand12.
function Ligand12_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(12,hObject, eventdata, handles)
clear vc chipdata



function Ligand12_name_Callback(hObject, eventdata, handles)
% hObject    handle to Ligand12_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ligand12_name as text
%        str2double(get(hObject,'String')) returns contents of Ligand12_name as a double


% --- Executes during object creation, after setting all properties.
function Ligand12_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ligand12_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Ligand13.
function Ligand13_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(13,hObject, eventdata, handles)
clear vc chipdata



function Ligand13_Name_Callback(hObject, eventdata, handles)
% hObject    handle to Ligand13_Name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ligand13_Name as text
%        str2double(get(hObject,'String')) returns contents of Ligand13_Name as a double


% --- Executes during object creation, after setting all properties.
function Ligand13_Name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ligand13_Name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Ligand14.
function Ligand14_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(14,hObject, eventdata, handles)
clear vc chipdata



function Ligand14_name_Callback(hObject, eventdata, handles)
% hObject    handle to Ligand14_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ligand14_name as text
%        str2double(get(hObject,'String')) returns contents of Ligand14_name as a double


% --- Executes during object creation, after setting all properties.
function Ligand14_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ligand14_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Ligand15.
function Ligand15_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(15,hObject, eventdata, handles)
clear vc chipdata


function Ligand15_name_Callback(hObject, eventdata, handles)
% hObject    handle to Ligand15_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ligand15_name as text
%        str2double(get(hObject,'String')) returns contents of Ligand15_name as a double


% --- Executes during object creation, after setting all properties.
function Ligand15_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ligand15_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Ligand16.
function Ligand16_Callback(hObject, eventdata, handles)
global vc chipdata
LigandX_Callback(16,hObject, eventdata, handles)
clear vc chipdata



function Ligand16_Name_Callback(hObject, eventdata, handles)
% hObject    handle to Ligand16_Name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ligand16_Name as text
%        str2double(get(hObject,'String')) returns contents of Ligand16_Name as a double


% --- Executes during object creation, after setting all properties.
function Ligand16_Name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ligand16_Name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Chamber_A01.
function Chamber_A01_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersA(1)==0
    chipdata.ChambersA(1)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(1),hObject, eventdata, handles);
else
    chipdata.ChambersA(1)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(1),hObject, eventdata, handles);
end
clear chipdata
    


% --- Executes on button press in Chamber_A03.
function Chamber_A03_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersA(3)==0
    chipdata.ChambersA(3)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(3),hObject, eventdata, handles);
else
    chipdata.ChambersA(3)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(3),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in Chamber_A02.
function Chamber_A02_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersA(2)==0
    chipdata.ChambersA(2)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(2),hObject, eventdata, handles);
else
    chipdata.ChambersA(2)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(2),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in Chamber_A04.
function Chamber_A04_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersA(4)==0
    chipdata.ChambersA(4)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(4),hObject, eventdata, handles);
else
    chipdata.ChambersA(4)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(4),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_A05.
function chambers_A05_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersA(5)==0
    chipdata.ChambersA(5)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(5),hObject, eventdata, handles);
else
    chipdata.ChambersA(5)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(5),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in Chamber_A06.
function Chamber_A06_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersA(6)==0
    chipdata.ChambersA(6)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(6),hObject, eventdata, handles);
else
    chipdata.ChambersA(6)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(6),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in Chamber_A07.
function Chamber_A07_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersA(7)==0
    chipdata.ChambersA(7)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(7),hObject, eventdata, handles);
else
    chipdata.ChambersA(7)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(7),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in Chamber_A08.
function Chamber_A08_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersA(8)==0
    chipdata.ChambersA(8)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(8),hObject, eventdata, handles);
else
    chipdata.ChambersA(8)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(8),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in Chambers_A09.
function Chambers_A09_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersA(9)==0
    chipdata.ChambersA(9)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(9),hObject, eventdata, handles);
else
    chipdata.ChambersA(9)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(9),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_A10.
function chambers_A10_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersA(10)==0
    chipdata.ChambersA(10)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(1),hObject, eventdata, handles);
else
    chipdata.ChambersA(10)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(10),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_A11.
function chambers_A11_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersA(11)==0
    chipdata.ChambersA(11)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(11),hObject, eventdata, handles);
else
    chipdata.ChambersA(11)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(11),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_A12.
function chambers_A12_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersA(12)==0
    chipdata.ChambersA(12)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(12),hObject, eventdata, handles);
else
    chipdata.ChambersA(12)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(12),hObject, eventdata, handles);
end
clear chipdata



function Ligand1_name_Callback(hObject, eventdata, handles)
% hObject    handle to Ligand1_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ligand1_name as text
%        str2double(get(hObject,'String')) returns contents of Ligand1_name as a double


% --- Executes during object creation, after setting all properties.
function Ligand1_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ligand1_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Ligand2_name_Callback(hObject, eventdata, handles)
% hObject    handle to Ligand2_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ligand2_name as text
%        str2double(get(hObject,'String')) returns contents of Ligand2_name as a double


% --- Executes during object creation, after setting all properties.
function Ligand2_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ligand2_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Ligand3_name_Callback(hObject, eventdata, handles)
% hObject    handle to Ligand3_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ligand3_name as text
%        str2double(get(hObject,'String')) returns contents of Ligand3_name as a double


% --- Executes during object creation, after setting all properties.
function Ligand3_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ligand3_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Ligand4_name_Callback(hObject, eventdata, handles)
% hObject    handle to Ligand4_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ligand4_name as text
%        str2double(get(hObject,'String')) returns contents of Ligand4_name as a double


% --- Executes during object creation, after setting all properties.
function Ligand4_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ligand4_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Ligand5_name_Callback(hObject, eventdata, handles)
% hObject    handle to Ligand5_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ligand5_name as text
%        str2double(get(hObject,'String')) returns contents of Ligand5_name as a double


% --- Executes during object creation, after setting all properties.
function Ligand5_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ligand5_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Ligand6_name_Callback(hObject, eventdata, handles)
% hObject    handle to Ligand6_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ligand6_name as text
%        str2double(get(hObject,'String')) returns contents of Ligand6_name as a double


% --- Executes during object creation, after setting all properties.
function Ligand6_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ligand6_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Ligand7_name_Callback(hObject, eventdata, handles)
% hObject    handle to Ligand7_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Ligand7_name as text
%        str2double(get(hObject,'String')) returns contents of Ligand7_name as a double


% --- Executes during object creation, after setting all properties.
function Ligand7_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Ligand7_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Lignad8_name_Callback(hObject, eventdata, handles)
% hObject    handle to Lignad8_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Lignad8_name as text
%        str2double(get(hObject,'String')) returns contents of Lignad8_name as a double


% --- Executes during object creation, after setting all properties.
function Lignad8_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Lignad8_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in chambers_B01.
function chambers_B01_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersB(1)==0
    chipdata.ChambersB(1)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(1),hObject, eventdata, handles);
else
    chipdata.ChambersB(1)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(1),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_B02.
function chambers_B02_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersB(2)==0
    chipdata.ChambersB(2)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(2),hObject, eventdata, handles);
else
    chipdata.ChambersB(2)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(2),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_B03.
function chambers_B03_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersB(3)==0
    chipdata.ChambersB(3)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(3),hObject, eventdata, handles);
else
    chipdata.ChambersB(3)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(3),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_B04.
function chambers_B04_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersB(4)==0
    chipdata.ChambersB(4)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(4),hObject, eventdata, handles);
else
    chipdata.ChambersB(4)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(4),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambersB05.
function chambersB05_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersB(5)==0
    chipdata.ChambersB(5)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(5),hObject, eventdata, handles);
else
    chipdata.ChambersB(5)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(5),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chamber_B06.
function chamber_B06_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersB(6)==0
    chipdata.ChambersB(6)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(6),hObject, eventdata, handles);
else
    chipdata.ChambersB(6)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(6),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chamber_B07.
function chamber_B07_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersB(7)==0
    chipdata.ChambersB(7)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(7),hObject, eventdata, handles);
else
    chipdata.ChambersB(7)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(7),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chamber_B08.
function chamber_B08_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersB(8)==0
    chipdata.ChambersB(8)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(8),hObject, eventdata, handles);
else
    chipdata.ChambersB(8)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(8),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chamber_B09.
function chamber_B09_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersB(9)==0
    chipdata.ChambersB(9)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(9),hObject, eventdata, handles);
else
    chipdata.ChambersB(9)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(9),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chamber_B10.
function chamber_B10_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersB(10)==0
    chipdata.ChambersB(10)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(10),hObject, eventdata, handles);
else
    chipdata.ChambersB(10)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(10),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_B11.
function chambers_B11_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersB(11)==0
    chipdata.ChambersB(11)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(11),hObject, eventdata, handles);
else
    chipdata.ChambersB(11)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(11),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_B12.
function chambers_B12_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersB(12)==0
    chipdata.ChambersB(12)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(12),hObject, eventdata, handles);
else
    chipdata.ChambersB(12)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(12),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chamber_C01.
function chamber_C01_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersC(1)==0
    chipdata.ChambersC(1)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(1),hObject, eventdata, handles);
else
    chipdata.ChambersC(1)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(1),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_C02.
function chambers_C02_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersC(2)==0
    chipdata.ChambersC(2)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(2),hObject, eventdata, handles);
else
    chipdata.ChambersC(2)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(2),hObject, eventdata, handles);
end
clear chipdata

% --- Executes on button press in chambers_C03.
function chambers_C03_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersC(3)==0
    chipdata.ChambersC(3)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(3),hObject, eventdata, handles);
else
    chipdata.ChambersC(3)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(3),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_C04.
function chambers_C04_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersC(4)==0
    chipdata.ChambersC(4)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(4),hObject, eventdata, handles);
else
    chipdata.ChambersC(4)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(4),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_C05.
function chambers_C05_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersC(5)==0
    chipdata.ChambersC(5)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(5),hObject, eventdata, handles);
else
    chipdata.ChambersC(5)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(5),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_C06.
function chambers_C06_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersC(6)==0
    chipdata.ChambersC(6)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(6),hObject, eventdata, handles);
else
    chipdata.ChambersC(6)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(6),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_C07.
function chambers_C07_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersC(7)==0
    chipdata.ChambersC(7)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(7),hObject, eventdata, handles);
else
    chipdata.ChambersC(7)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(7),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_C08.
function chambers_C08_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersC(8)==0
    chipdata.ChambersC(8)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(8),hObject, eventdata, handles);
else
    chipdata.ChambersC(8)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(8),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_C09.
function chambers_C09_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersC(9)==0
    chipdata.ChambersC(9)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(9),hObject, eventdata, handles);
else
    chipdata.ChambersC(9)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(9),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_C10.
function chambers_C10_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersC(10)==0
    chipdata.ChambersC(10)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(10),hObject, eventdata, handles);
else
    chipdata.ChambersC(10)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(10),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_C11.
function chambers_C11_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersC(11)==0
    chipdata.ChambersC(11)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(11),hObject, eventdata, handles);
else
    chipdata.ChambersC(11)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(11),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_C12.
function chambers_C12_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersC(12)==0
    chipdata.ChambersC(12)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(12),hObject, eventdata, handles);
else
    chipdata.ChambersC(12)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(12),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_D01.
function chambers_D01_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersD(1)==0
    chipdata.ChambersD(1)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(1),hObject, eventdata, handles);
else
    chipdata.ChambersD(1)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(1),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_D02.
function chambers_D02_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersD(2)==0
    chipdata.ChambersD(2)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(2),hObject, eventdata, handles);
else
    chipdata.ChambersD(2)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(2),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_D03.
function chambers_D03_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersD(3)==0
    chipdata.ChambersD(3)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(3),hObject, eventdata, handles);
else
    chipdata.ChambersD(3)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(3),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_D04.
function chambers_D04_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersD(4)==0
    chipdata.ChambersD(4)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(4),hObject, eventdata, handles);
else
    chipdata.ChambersD(4)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(4),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_D05.
function chambers_D05_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersD(5)==0
    chipdata.ChambersD(5)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(5),hObject, eventdata, handles);
else
    chipdata.ChambersD(5)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(5),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_D06.
function chambers_D06_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersD(6)==0
    chipdata.ChambersD(6)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(6),hObject, eventdata, handles);
else
    chipdata.ChambersD(6)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(6),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_D07.
function chambers_D07_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersD(7)==0
    chipdata.ChambersD(7)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(7),hObject, eventdata, handles);
else
    chipdata.ChambersD(7)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(7),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_D08.
function chambers_D08_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersD(8)==0
    chipdata.ChambersD(8)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(8),hObject, eventdata, handles);
else
    chipdata.ChambersD(8)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(8),hObject, eventdata, handles);
end
clear chipdata

% --- Executes on button press in chambers_D09.
function chambers_D09_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersD(9)==0
    chipdata.ChambersD(9)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(9),hObject, eventdata, handles);
else
    chipdata.ChambersD(9)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(9),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_D10.
function chambers_D10_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersD(10)==0
    chipdata.ChambersD(10)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(10),hObject, eventdata, handles);
else
    chipdata.ChambersD(10)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(10),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_D11.
function chambers_D11_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersD(11)==0
    chipdata.ChambersD(11)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(11),hObject, eventdata, handles);
else
    chipdata.ChambersD(11)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(11),hObject, eventdata, handles);
end
clear chipdata


% --- Executes on button press in chambers_D12.
function chambers_D12_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChambersD(12)==0
    chipdata.ChambersD(12)=1;
    set(hObject,'BackgroundColor',chipdata.valve_open_color);
    OPEN_VALVES(chipdata.Column(12),hObject, eventdata, handles);
else
    chipdata.ChambersD(12)=0;
    set(hObject,'BackgroundColor',chipdata.buttoncolor);
    CLOSE_VALVES(chipdata.Column(12),hObject, eventdata, handles);
end
clear chipdata



function LigandA01_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(1,1)=Ligand;
else
    chipdata.ChamberLigands(1,1)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandA01_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandA01 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandA02_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(1,2)=Ligand;
else
    chipdata.ChamberLigands(1,2)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandA02_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandA02 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandA03_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(1,3)=Ligand;
else
    chipdata.ChamberLigands(1,3)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandA03_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandA03 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandA04_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(1,4)=Ligand;
else
    chipdata.ChamberLigands(1,4)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandA04_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandA04 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandA05_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(1,5)=Ligand;
else
    chipdata.ChamberLigands(1,5)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandA05_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandA05 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandA06_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(1,6)=Ligand;
else
    chipdata.ChamberLigands(1,6)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandA06_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandA06 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandA07_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(1,7)=Ligand;
else
    chipdata.ChamberLigands(1,7)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandA07_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandA07 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandA08_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(1,8)=Ligand;
else
    chipdata.ChamberLigands(1,8)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandA08_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandA08 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandA09_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(1,9)=Ligand;
else
    chipdata.ChamberLigands(1,9)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandA09_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandA09 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandA10_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(1,10)=Ligand;
else
    chipdata.ChamberLigands(1,10)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandA10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandA10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandA11_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(1,11)=Ligand;
else
    chipdata.ChamberLigands(1,11)=1;
end
clear chipdata

% --- Executes during object creation, after setting all properties.
function LigandA11_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandA11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandA12_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(1,12)=Ligand;
else
    chipdata.ChamberLigands(1,12)=1;
end
clear chipdata

% --- Executes during object creation, after setting all properties.
function LigandA12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandA12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LingandB01_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(2,1)=Ligand;
else
    chipdata.ChamberLigands(2,1)=1;
end
clear chipdata

% --- Executes during object creation, after setting all properties.
function LingandB01_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LingandB01 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandB02_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(2,2)=Ligand;
else
    chipdata.ChamberLigands(2,2)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandB02_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandB02 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandB03_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(2,3)=Ligand;
else
    chipdata.ChamberLigands(2,3)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandB03_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandB03 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandB04_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(2,4)=Ligand;
else
    chipdata.ChamberLigands(2,4)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandB04_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandB04 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandB05_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(2,5)=Ligand;
else
    chipdata.ChamberLigands(2,5)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandB05_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandB05 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandB06_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(2,6)=Ligand;
else
    chipdata.ChamberLigands(2,6)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandB06_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandB06 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandB07_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(2,7)=Ligand;
else
    chipdata.ChamberLigands(2,7)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandB07_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandB07 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandB08_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(2,8)=Ligand;
else
    chipdata.ChamberLigands(2,8)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandB08_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandB08 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandB09_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(2,9)=Ligand;
else
    chipdata.ChamberLigands(2,9)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandB09_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandB09 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandB10_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(2,10)=Ligand;
else
    chipdata.ChamberLigands(2,10)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandB10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandB10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandB11_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(2,11)=Ligand;
else
    chipdata.ChamberLigands(2,11)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandB11_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandB11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandB12_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(2,12)=Ligand;
else
    chipdata.ChamberLigands(2,12)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandB12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandB12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit110_Callback(hObject, eventdata, handles)
% hObject    handle to edit110 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit110 as text
%        str2double(get(hObject,'String')) returns contents of edit110 as a double


% --- Executes during object creation, after setting all properties.
function edit110_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit110 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandC01_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(3,1)=Ligand;
else
    chipdata.ChamberLigands(3,1)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandC01_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandC01 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandC02_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(3,2)=Ligand;
else
    chipdata.ChamberLigands(3,2)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandC02_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandC02 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandC03_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(3,3)=Ligand;
else
    chipdata.ChamberLigands(3,3)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandC03_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandC03 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandC04_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(3,4)=Ligand;
else
    chipdata.ChamberLigands(3,4)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandC04_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandC04 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(3,5)=Ligand;
else
    chipdata.ChamberLigands(3,5)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandC05_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandC05 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandC06_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(3,6)=Ligand;
else
    chipdata.ChamberLigands(3,6)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandC06_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandC06 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandC07_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(3,7)=Ligand;
else
    chipdata.ChamberLigands(3,7)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandC07_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandC07 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandC08_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(3,8)=Ligand;
else
    chipdata.ChamberLigands(3,8)=1;
end
clear chipdata

% --- Executes during object creation, after setting all properties.
function LigandC08_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandC08 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandC09_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(3,9)=Ligand;
else
    chipdata.ChamberLigands(3,9)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandC09_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandC09 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandC10_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(3,10)=Ligand;
else
    chipdata.ChamberLigands(3,10)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandC10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandC10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandC11_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(3,11)=Ligand;
else
    chipdata.ChamberLigands(3,11)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandC11_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandC11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandC12_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(3,12)=Ligand;
else
    chipdata.ChamberLigands(3,12)=1;
end
clear chipdata

% --- Executes during object creation, after setting all properties.
function LigandC12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandC12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandD01_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(4,1)=Ligand;
else
    chipdata.ChamberLigands(4,1)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandD01_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandD01 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandD02_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(4,2)=Ligand;
else
    chipdata.ChamberLigands(4,2)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandD02_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandD02 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandD03_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(4,3)=Ligand;
else
    chipdata.ChamberLigands(4,3)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandD03_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandD03 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandD04_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(4,4)=Ligand;
else
    chipdata.ChamberLigands(4,4)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandD04_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandD04 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandD05_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(4,5)=Ligand;
else
    chipdata.ChamberLigands(4,5)=1;
end
clear chipdata

% --- Executes during object creation, after setting all properties.
function LigandD05_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandD05 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandD06_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(4,6)=Ligand;
else
    chipdata.ChamberLigands(4,6)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandD06_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandD06 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandD07_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(4,7)=Ligand;
else
    chipdata.ChamberLigands(4,7)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandD07_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandD07 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandD08_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(4,8)=Ligand;
else
    chipdata.ChamberLigands(4,8)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandD08_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandD08 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandD09_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(4,9)=Ligand;
else
    chipdata.ChamberLigands(4,9)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandD09_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandD09 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandD10_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(4,10)=Ligand;
else
    chipdata.ChamberLigands(4,10)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandD10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandD10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandD11_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(4,11)=Ligand;
else
    chipdata.ChamberLigands(4,11)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandD11_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandD11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function LigandD12_Callback(hObject, eventdata, handles)
global chipdata
Ligand=string2double(get(hObject,'String'));
if CheckForLigandNumber(Ligand)
    chipdata.ChamberLigands(4,12)=Ligand;
else
    chipdata.ChamberLigands(4,12)=1;
end
clear chipdata


% --- Executes during object creation, after setting all properties.
function LigandD12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LigandD12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in CultureChamberA03.
function CultureChamberA03_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(1,3)==1
    chipdata.ChamberCheck(1,3)=0;
else
    chipdata.ChamberCheck(1,3)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberA02.
function CultureChamberA02_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(1,2)==1
    chipdata.ChamberCheck(1,2)=0;
else
    chipdata.ChamberCheck(1,2)=1;
end
clear chipdata


% --- Executes on button press in CultureChaberA04.
function CultureChaberA04_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(1,3)==1
    chipdata.ChamberCheck(1,3)=0;
else
    chipdata.ChamberCheck(1,3)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberA05.
function CultureChamberA05_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(1,5)==1
    chipdata.ChamberCheck(1,5)=0;
else
    chipdata.ChamberCheck(1,5)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberA06.
function CultureChamberA06_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(1,6)==1
    chipdata.ChamberCheck(1,6)=0;
else
    chipdata.ChamberCheck(1,6)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberA07.
function CultureChamberA07_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(1,7)==1
    chipdata.ChamberCheck(1,7)=0;
else
    chipdata.ChamberCheck(1,7)=1;
end
clear chipdata

% --- Executes on button press in CultureChamberA08.
function CultureChamberA08_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(1,8)==1
    chipdata.ChamberCheck(1,8)=0;
else
    chipdata.ChamberCheck(1,8)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberA09.
function CultureChamberA09_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(1,9)==1
    chipdata.ChamberCheck(1,9)=0;
else
    chipdata.ChamberCheck(1,9)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberA10.
function CultureChamberA10_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(1,10)==1
    chipdata.ChamberCheck(1,10)=0;
else
    chipdata.ChamberCheck(1,10)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberA11.
function CultureChamberA11_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(1,11)==1
    chipdata.ChamberCheck(1,11)=0;
else
    chipdata.ChamberCheck(1,11)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberA12.
function CultureChamberA12_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(1,12)==1
    chipdata.ChamberCheck(1,12)=0;
else
    chipdata.ChamberCheck(1,12)=1;
end
clear chipdata





% --- Executes on button press in CultureChamberA01.
function CultureChamberA01_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(1,1)==1
    chipdata.ChamberCheck(1,1)=0;
else
    chipdata.ChamberCheck(1,1)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberB01.
function CultureChamberB01_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(2,1)==1
    chipdata.ChamberCheck(2,1)=0;
else
    chipdata.ChamberCheck(2,1)=1;
end
clear chipdata

% --- Executes on button press in CultureChamberB02.
function CultureChamberB02_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(2,2)==1
    chipdata.ChamberCheck(2,2)=0;
else
    chipdata.ChamberCheck(2,2)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberB03.
function CultureChamberB03_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(2,3)==1
    chipdata.ChamberCheck(2,3)=0;
else
    chipdata.ChamberCheck(2,3)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberB04.
function CultureChamberB04_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(2,4)==1
    chipdata.ChamberCheck(2,4)=0;
else
    chipdata.ChamberCheck(2,4)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberB05.
function CultureChamberB05_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(2,5)==1
    chipdata.ChamberCheck(2,5)=0;
else
    chipdata.ChamberCheck(2,5)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberB06.
function CultureChamberB06_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(2,6)==1
    chipdata.ChamberCheck(2,6)=0;
else
    chipdata.ChamberCheck(2,6)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberB07.
function CultureChamberB07_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(2,7)==1
    chipdata.ChamberCheck(2,7)=0;
else
    chipdata.ChamberCheck(2,7)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberB08.
function CultureChamberB08_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(2,8)==1
    chipdata.ChamberCheck(2,8)=0;
else
    chipdata.ChamberCheck(2,8)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberB09.
function CultureChamberB09_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(2,9)==1
    chipdata.ChamberCheck(2,9)=0;
else
    chipdata.ChamberCheck(2,9)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberB10.
function CultureChamberB10_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(2,10)==1
    chipdata.ChamberCheck(2,10)=0;
else
    chipdata.ChamberCheck(2,10)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberB11.
function CultureChamberB11_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(2,11)==1
    chipdata.ChamberCheck(2,11)=0;
else
    chipdata.ChamberCheck(2,11)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberB12.
function CultureChamberB12_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(2,12)==1
    chipdata.ChamberCheck(2,12)=0;
else
    chipdata.ChamberCheck(2,12)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberC01.
function CultureChamberC01_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(3,1)==1
    chipdata.ChamberCheck(3,1)=0;
else
    chipdata.ChamberCheck(3,1)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberC02.
function CultureChamberC02_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(3,2)==1
    chipdata.ChamberCheck(3,2)=0;
else
    chipdata.ChamberCheck(3,2)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberC03.
function CultureChamberC03_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(3,3)==1
    chipdata.ChamberCheck(3,3)=0;
else
    chipdata.ChamberCheck(3,3)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberC04.
function CultureChamberC04_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(3,4)==1
    chipdata.ChamberCheck(3,4)=0;
else
    chipdata.ChamberCheck(3,4)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberC05.
function CultureChamberC05_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(3,5)==1
    chipdata.ChamberCheck(3,5)=0;
else
    chipdata.ChamberCheck(3,5)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberC06.
function CultureChamberC06_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(3,6)==1
    chipdata.ChamberCheck(3,6)=0;
else
    chipdata.ChamberCheck(3,6)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberC07.
function CultureChamberC07_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(3,7)==1
    chipdata.ChamberCheck(3,7)=0;
else
    chipdata.ChamberCheck(3,7)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberC08.
function CultureChamberC08_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(3,8)==1
    chipdata.ChamberCheck(3,8)=0;
else
    chipdata.ChamberCheck(3,8)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberC09.
function CultureChamberC09_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(3,9)==1
    chipdata.ChamberCheck(3,9)=0;
else
    chipdata.ChamberCheck(3,9)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberC10.
function CultureChamberC10_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(3,10)==1
    chipdata.ChamberCheck(3,10)=0;
else
    chipdata.ChamberCheck(3,10)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberC11.
function CultureChamberC11_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(3,11)==1
    chipdata.ChamberCheck(3,11)=0;
else
    chipdata.ChamberCheck(3,11)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberC12.
function CultureChamberC12_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(3,12)==1
    chipdata.ChamberCheck(3,12)=0;
else
    chipdata.ChamberCheck(3,12)=1;
end
clear chipdata


% --- Executes on button press in CellCultureD01.
function CellCultureD01_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(4,1)==1
    chipdata.ChamberCheck(4,1)=0;
else
    chipdata.ChamberCheck(4,1)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberD02.
function CultureChamberD02_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(4,2)==1
    chipdata.ChamberCheck(4,2)=0;
else
    chipdata.ChamberCheck(4,2)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberD03.
function CultureChamberD03_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(4,3)==1
    chipdata.ChamberCheck(4,3)=0;
else
    chipdata.ChamberCheck(4,3)=1;
end
clear chipdata

% --- Executes on button press in CultureChamberD04.
function CultureChamberD04_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(4,4)==1
    chipdata.ChamberCheck(4,4)=0;
else
    chipdata.ChamberCheck(4,4)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberD05.
function CultureChamberD05_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(4,5)==1
    chipdata.ChamberCheck(4,5)=0;
else
    chipdata.ChamberCheck(4,5)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberD06.
function CultureChamberD06_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(4,6)==1
    chipdata.ChamberCheck(4,6)=0;
else
    chipdata.ChamberCheck(4,6)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberD07.
function CultureChamberD07_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(4,7)==1
    chipdata.ChamberCheck(4,7)=0;
else
    chipdata.ChamberCheck(4,7)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberD08.
function CultureChamberD08_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(4,8)==1
    chipdata.ChamberCheck(4,8)=0;
else
    chipdata.ChamberCheck(4,8)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberD09.
function CultureChamberD09_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(4,9)==1
    chipdata.ChamberCheck(4,9)=0;
else
    chipdata.ChamberCheck(4,9)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberD10.
function CultureChamberD10_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(4,10)==1
    chipdata.ChamberCheck(4,10)=0;
else
    chipdata.ChamberCheck(4,10)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberD11.
function CultureChamberD11_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(4,11)==1
    chipdata.ChamberCheck(4,11)=0;
else
    chipdata.ChamberCheck(4,11)=1;
end
clear chipdata


% --- Executes on button press in CultureChamberD12.
function CultureChamberD12_Callback(hObject, eventdata, handles)
global chipdata
if chipdata.ChamberCheck(4,12)==1
    chipdata.ChamberCheck(4,12)=0;
else
    chipdata.ChamberCheck(4,12)=1;
end
clear chipdata


% --- Executes on button press in CULTURE_START.
function CULTURE_START_Callback(hObject, eventdata, handles)
global chipdata
set(hObject,'BackgroundColor','yellow');
chipdata.CultureProgram;
set(hObject,'BackgroundColor',chipdata.buttoncolor);
chipdata.CultureStop=FALSE;
clear global


% --- Executes on button press in CULTURE_STOP.
function CULTURE_STOP_Callback(hObject, eventdata, handles)
global chipdata
chipdata.CultureStop=true;
clear global 


% --- Executes on selection change in CULTURE_PROGRAM.
function CULTURE_PROGRAM_Callback(hObject, eventdata, handles)
global chipdata
chipdata.CultureProgram=get('hObject','string');
clear chipdata


% --- Executes during object creation, after setting all properties.
function CULTURE_PROGRAM_CreateFcn(hObject, eventdata, handles)
% hObject    handle to CULTURE_PROGRAM (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function CultureWashTime_Callback(hObject, eventdata, handles)
global chipdata
chipdata.CultureWashTime=string2double(get(hObject,'string'));
clear chipdata


% --- Executes during object creation, after setting all properties.
function CultureWashTime_CreateFcn(hObject, eventdata, handles)
% hObject    handle to CultureWashTime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function CultureRefillCycle_Callback(hObject, eventdata, handles)
global chipdata
chipdata.CultureRefillCycle=string2double(get(hObject,'string'));
clear chipdata


% --- Executes during object creation, after setting all properties.
function CultureRefillCycle_CreateFcn(hObject, eventdata, handles)
% hObject    handle to CultureRefillCycle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in CultureWaste.
function CultureWaste_Callback(hObject, eventdata, handles)
global chipdata
chipdata.CultureWaste=get(hObject,'Value');
clear chipdata


% --- Executes during object creation, after setting all properties.
function CultureWaste_CreateFcn(hObject, eventdata, handles)
% hObject    handle to CultureWaste (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
