%% GUI INITIALIZATION
function varargout = sccctest(varargin)
set(0,'units','pixels')
sspix = get(0,'screensize')
H = figure('Position',[sspix(3)*.05 sspix(4)*.05 (sspix(3)*.8) (sspix(4)*.8)])
global GuIformat vc chipdata



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%DEBUG MODE AND CONTROL BOX%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%INPUT                      %%%%
%Set GuI.DEBUGMODE = 0 to connect to valve controller
GuIformat.DEBUGMODE = 1;
if GuIformat.DEBUGMODE == 0;
    %% Parameters for connecting to two controller boxes
    % Number of boxes
    vc.num = 2;
    
    % Serial number of USB interface in box #1
    vc.info(1).sn = 'ELX04H5S'; % My System - valves 0-23
    vc.info(1).handle = 0;
    vc.info(1).status = 0;
    vc.info(1).polarity = logical([zeros(1, 24)]);
    
    % Serial number of USB interface in box #2
    vc.info(2).sn = 'ELX04H2P'; % My system first valves 24-47
    vc.info(2).handle = 0;
    vc.info(2).status = 0;
    vc.info(2).polarity = logical([zeros(1, 24)]);
    
    %% Open connection to controller boxes
    vc = vc_open_setup(vc);
    % Check status of both connections
    disp(['Status of box#1 = ' num2str(vc.info(1).status)]);
    disp(['Status of box#2 = ' num2str(vc.info(2).status)]);
    
    %%%%END of SPECIFY NEEDED PARAMETERS
    
    %guidata(hObject, handles);
    
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

addpath(fullfile(cd,'Matlab 2008-2012'))
addpath(fullfile(cd,'Suspesion Culture Chip'))
addpath(fullfile(cd,'Matlab 2008-2012\Win64'))

%% Declare Global variables

GuIformat.Vert1 = .96;
GuIformat.Vert2 = .76;
GuIformat.Vert3 = .6;
GuIformat.Vert4 = 0;
GuIformat.color.c = [255/255 190/255 190/255];
GuIformat.color.o = [102/255 1 1];
GuIformat.STOP = 1;
GuIformat.PAUSE = 0;
GuIformat.AdvancedScript = '';
GuIformat.RowS = {'DCBA'};
GuIformat.Experiments = cell(1,3)
GuIformat.Experiments{1,3} = zeros([4,12])
GuIformat.Experiments{1,1} = 'Blank Step'
GuIformat.Treatments = cell(1,13)
GuIformat.Treatments{1,1} = 'Incubate'
GuIformat.Treatments{1,2} = 99;
GuIformat.Treatments{1,3} = 0
GuIformat.Treatments{1,4} = 0
GuIformat.Treatments{1,5} = 0
GuIformat.Treatments{1,6} = 0
GuIformat.Treatments{1,7} = 0
GuIformat.Treatments{1,8} = 0
GuIformat.Treatments{1,9} = 0
GuIformat.Treatments{1,10} = 0
GuIformat.Treatments{1,11} = 0
GuIformat.Treatments{1,12} = 0
GuIformat.Treatments{1,13} = 0
GuIformat.StandardInc = 10
GuIformat.TreatCount = 1
GuIformat.Direction = 1
GuIformat.ScriptDir = cd
GuIformat.LRM = {'L','R','M'}
GuIformat.Rows = {'A','B','C','D'}
GuIformat.CurrentLigand = 0
for count = 1:16
    GuIformat.LigandNames{count} = num2str(count);
end

%% SPECIFY NEEDED PARAMETERS
chipdata.No_Valves = 48; % Specify the number of valves the chip has

chipdata.P01v01=33; %set pump valve #s here
chipdata.P01v02=34; %set pump valve #s here
chipdata.P01v03=35; %set pump valve #s here
chipdata.P01v04=17; %set pump valve #s here
chipdata.P01NoCyc = 100; %should match default values on .fig
chipdata.P01timing = 100/1000; %should match default values on .fig

chipdata.P02v01=33; %set pump valve #s here
chipdata.P02v02=34; %set pump valve #s here
chipdata.P02v03=35; %set pump valve #s here
chipdata.P02NoCyc = 100; %should match default values on .fig
chipdata.P02timing = 100/1000; %should match default values on .fig

chipdata.valve_close_color = [1 0 0];
chipdata.valve_open_color = [0 0.5 0];
chipdata.buttoncolor=[0.91,0.91,0.91];
chipdata.color.c = [1 0 0];
chipdata.color.o = [0 0.5 0];
chipdata.names={'V_00','V_01','V_02','V_03','V_04','V_05','V_06','V_07','V_08',...
    'V_09','V_10','V_11','V_12','V_13','V_14','V_15','V_16','V_17','V_18',...
    'V_19','V_20','V_21','V_22','V_23','V_24','V_25','V_26','V_27','V_28',...
    'V_29','V_30','V_31','V_32','V_33','V_34','V_35','V_36','V_37','V_38',...
    'V_39','V_40','V_41','V_42','V_43','V_44','V_45','V_46','V_47'}; %need to MANUALLY set to # of valves
% MANUALLy specify here so that other commands will update button color
chipdata.All_valves = [00,01,02,03,04,05,06,07,08,09,10,11,12,13,14,15,16,17,...
    18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,...
    42,43,44,45,46,47];%need to MANUALLY set to # of valves

%% Chipdata for automatic program

chipdata.Ligands=zeros(1,16); % Gives if ligand is active or not
chipdata.LigandNames={'Ligand1','Ligand2','Ligand3','Ligand4','Ligand5','Ligand6','Ligand7','Ligand8','Ligand9','Ligand10','Ligand11','Ligand12','Ligand13','Ligand14','Ligand15','Ligand16'};
load('Ligand_Matrix');
chipdata.LigandValueMatrix=Ligand_Matrix;
chipdata.LigandValves=[00 01 02 03 04 05 06 07];

%% Valve Names

chipdata.QuickDamp=[32,16];
chipdata.Waste=[30,44];
chipdata.Pipelette=[15,31];
chipdata.Channel1In=[11 9 36 38];
chipdata.Channel2In=[10 8 37 39];
chipdata.ChannelOut=[42,43];

%% Chamber
chipdata.ChambersA=[0 0 0 0 0 0 0 0 0 0 0 0];
chipdata.ChambersB=[0 0 0 0 0 0 0 0 0 0 0 0];
chipdata.ChambersC=[0 0 0 0 0 0 0 0 0 0 0 0];
chipdata.ChambersD=[0 0 0 0 0 0 0 0 0 0 0 0];
chipdata.Chambers=zeros(4,12);
chipdata.Columns=[18 19 20 21 22 23 24 25 26 27 28 29];
chipdata.ChamberLigands=ones(4,12);
chipdata.ChamberCheck=zeros(4,12);
chipdata.SEED=13;
chipdata.SOURCE=[12,14,13];

chipdata.CultureStop=0;
chipdata.CultureProgram='CULTURE_MODE';
chipdata.CultureWasteTime=0;
chipdata.CultureWashTime=0;
chipdata.CultureRefillCycle=0;
chipdata.CultureWaste=1;
chipdata.PumpMode=0;
chipdata.Break=0;

global vc;
global chipdata;

if GuIformat.DEBUGMODE == 0;
    %% Parameters for connecting to two controller boxes
    % Number of boxes
    vc.num = 2;
    
    % Serial number of USB interface in box #1
    vc.info(1).sn = 'ELX04H5S'; % My System - valves 0-23
    vc.info(1).handle = 0;
    vc.info(1).status = 0;
    vc.info(1).polarity = logical([zeros(1, 24)]);
    
    % Serial number of USB interface in box #2
    vc.info(2).sn = 'ELX04H2P'; % My system first valves 24-47
    vc.info(2).handle = 0;
    vc.info(2).status = 0;
    vc.info(2).polarity = logical([zeros(1, 24)]);
    
    %% Open connection to controller boxes
    vc = vc_open_setup(vc);
    % Check status of both connections
    disp(['Status of box#1 = ' num2str(vc.info(1).status)]);
    disp(['Status of box#2 = ' num2str(vc.info(2).status)]);
    
    %%%%END of SPECIFY NEEDED PARAMETERS
    
    %guidata(hObject, handles);
    
end

%% Control Panels
DirectControlPanel
LigandControlPanel
QWHControlPanel
TBCControlPanel
ChamberControlPanel
%DWCControlPanel
PumpPanel
SchematicPanel
%CommandLinePanel
ScriptingPanel
%TemporaryItems

end

%% PANEL CONTROL

function DirectControlPanel(hObject, eventdata, handles)

global vc chipdata GuIformat;

Control = uibuttongroup('Visible','on',...
    'Position',[0 GuIformat.Vert1 1 .04],...
    'Title','Direct Valve Control');
% Create 48 toggle buttons for direct control.

for i = 1:48;
    GuIformat.DirCon(i) = uicontrol(Control,...
        'Units','normalized',...
        'Style','togglebutton',...
        'String',i-1,...
        'UserData',i-1,...
        'Position',[(1/48)*(i-1) 0 (1/48) 1],...
        'HandleVisibility','off',...
        'BackgroundColor',GuIformat.color.c);
    set(GuIformat.DirCon(i),'callback',@togglebutton_Callback);
end

if GuIformat.DEBUGMODE == 0
    for j = [0:39,42,43,44]
        CLOSE_VALVES(j);
    end
end


end

function LigandControlPanel(hObject,eventdata,handles)

global vc chipdata GuIformat;

Control = uibuttongroup('Visible','on',...
    'Position',[0 GuIformat.Vert2 .3 .2],...
    'Title','Input Control');
count = 0;
for i = 4:-1:1
    for j = 1:4
        count = count + 1;
                GuIformat.LigCon(count,1) = uicontrol(Control,...
            'Units','normalized',...
            'Style','togglebutton',...
            'String',strcat({'Ligand '},GuIformat.LigandNames{count}),...
            'UserData',count,...
            'Position',[(1/4)*(j-1) (1/4)*(i-1/2) (1/4) (1/8)],...
            'HandleVisibility','off',...
            'BackgroundColor',GuIformat.color.c);
        set(GuIformat.LigCon(count,1),'callback',@LigandX_Callback);
        GuIformat.LigCon(count,2) = uicontrol(Control,...
            'Units','normalized',...
            'Style','edit',...
            'String',num2str(count),...
            'UserData',count,...
            'Position',[(1/4)*(j-1) (1/4)*(i-1) (1/4) (1/8)],...
            'HandleVisibility','off');
        set(GuIformat.LigCon(count,2),'callback',@LigEditBox_Callback);
%         GuIformat.LigCon(i,j,1) = uicontrol(Control,...
%             'Units','normalized',...
%             'Style','togglebutton',...
%             'String',strcat({'Ligand '},GuIformat.LigandNames{count}),...
%             'UserData',count,...
%             'Position',[(1/4)*(j-1) (1/4)*(i-1/2) (1/4) (1/8)],...
%             'HandleVisibility','off',...
%             'BackgroundColor',GuIformat.color.c);
%         set(GuIformat.LigCon(i,j,1),'callback',@LigandX_Callback);
%         GuIformat.LigCon(i,j,2) = uicontrol(Control,...
%             'Units','normalized',...
%             'Style','edit',...
%             'String',num2str(count),...
%             'UserData',count,...
%             'Position',[(1/4)*(j-1) (1/4)*(i-1) (1/4) (1/8)],...
%             'HandleVisibility','off');
%         set(GuIformat.LigCon(i,j,2),'callback',@LigEditBox_Callback);
    end
end
    function LigEditBox_Callback(hObject, callbackdata)
        input = get(hObject,'String');
        LigNum = get(hObject,'UserData');
        GuIformat.LigandNames{LigNum} = input;
        display(input);
    end
end

function TBCControlPanel(hObject,eventdata,handles)

global vc chipdata GuIformat;

Control = uibuttongroup('Visible','on',...
    'Position',[.3 GuIformat.Vert2 .05 .2],...
    'Title','Channel Control');

TB = {'Bottom','Top'};
count = 0 ;
for i = 1:4
    for j = 1:2
        count = count + 1;
        
        GuIformat.TBC(i,j) = uicontrol(Control,...
            'Units','normalized',...
            'Style','togglebutton',...
            'String',strcat(GuIformat.RowS{1}(i),{' '},TB{j}),...
            'Position',[0 (1/8)*(count-1) (1) (1/8)],...
            'HandleVisibility','off',...
            'BackgroundColor',GuIformat.color.c);
        set(GuIformat.TBC(i,j),'callback',@togglebutton_Callback);
        if j == 2
            set(GuIformat.TBC(i,j),'UserData',[chipdata.Channel1In(5-i),43]);
        else
            set(GuIformat.TBC(i,j),'UserData',[chipdata.Channel2In(5-i),42]);
        end
        
    end
end
end

function ChamberControlPanel(~,eventdata,handles)

global GuIformat vc chipdata
%% Chamber Control
Control = uibuttongroup('Visible','on',...
    'Position',[.35 GuIformat.Vert2 .45 .2],...
    'Title','Chamber Control');

for i = 1:4
    for j = 1:12
        GuIformat.Cham(j,i) = uicontrol(Control,...
            'Units','normalized',...
            'Style','togglebutton',...
            'String',strcat(GuIformat.RowS{1}(i),num2str(j)),...
            'UserData',[chipdata.Columns(j),chipdata.Channel1In(5-i),chipdata.Channel2In(5-i)],...
            'Position',[(1/14)*(j-1) (1/4)*(i-1) (1/14) (1/4)],...
            'HandleVisibility','off',...
            'BackgroundColor',GuIformat.color.c);
        set(GuIformat.Cham(j,i),'callback',@ChamberAddress_TBCallback);
    end
end
    function ChamberAddress_TBCallback(hObject,callbackdata)
        button_state = get(hObject,'Value');
        valv = get(hObject,'UserData');
        if GuIformat.Direction == 1
            NUMBERS = [valv(1),valv(2),chipdata.ChannelOut(1)];
        else
            NUMBERS = [valv(1),valv(3),chipdata.ChannelOut(2)];
        end
        if button_state == get(hObject,'Max')
            set(GuIformat.Command(3),'String',strcat({'Valve '},num2str(NUMBERS),{' opened'}));
            set(hObject, 'BackgroundColor',GuIformat.color.o);
            for i = NUMBERS
                set(GuIformat.DirCon(i+1), 'BackgroundColor',GuIformat.color.o);
            end
            if GuIformat.DEBUGMODE == 0
                OPEN_VALVES(NUMBERS);
            end
        elseif button_state == get(hObject,'Min')
            set(GuIformat.Command(3),'String',strcat({'Valve '},num2str(NUMBERS),{' closed'}));
            set(hObject, 'BackgroundColor',GuIformat.color.c);
            for i = NUMBERS
                set(GuIformat.DirCon(i+1), 'BackgroundColor',GuIformat.color.c);
            end
            if GuIformat.DEBUGMODE == 0
                CLOSE_VALVES(NUMBERS);
            end
        end
    end

%% Chamber Component Control

directionbttn = uicontrol(Control,...
    'Units','normalized',...
    'Style','popupmenu',...
    'String',{'Top Down','Bottom Up'},...
    'Position',[(1/14)*(12) .85 (2/14) .15],...
    'HandleVisibility','off');
set(directionbttn,'callback',@Direction_PUMCallback)
    function Direction_PUMCallback(hObject,callbackdata)
        selected = get(directionbttn,'Value');
        GuIformat.Direction = selected;
        if GuIformat.DEBUGMODE == 0
            CLOSE_VALVES([42,43]);
        end
    end
GuIformat.ChComp(3) = uicontrol(Control,...
    'Units','normalized',...
    'Style','togglebutton',...
    'String','SEED',...
    'Userdata',[13],...
    'Position',[(1/14)*(12) .5 (2/14) .35],...
    'HandleVisibility','off',...
    'BackgroundColor',GuIformat.color.c);
set(GuIformat.ChComp(3),'callback',@togglebutton_Callback)
GuIformat.ChComp(1) = uicontrol(Control,...
    'Units','normalized',...
    'Style','togglebutton',...
    'String','Side 1',...
    'Userdata',[14],...
    'Position',[(1/14)*(12) 0 (1/14) 1/2],...
    'HandleVisibility','off',...
    'BackgroundColor',GuIformat.color.c);
set(GuIformat.ChComp(1),'callback',@togglebutton_Callback)

GuIformat.ChComp(2) = uicontrol(Control,...
    'Units','normalized',...
    'Style','togglebutton',...
    'String','Side 2',...
    'Userdata',[12],...
    'Position',[(1/14)*(13) 0 (1/14) 1/2],...
    'HandleVisibility','off',...
    'BackgroundColor',GuIformat.color.c);
set(GuIformat.ChComp(2),'callback',@togglebutton_Callback)
end

function QWHControlPanel(hObject,eventdata,handles)

global vc chipdata GuIformat;

Control = uibuttongroup('Visible','on',...
    'Position',[.8 GuIformat.Vert2 .05 .2],...
    'Title','Output Control');
for j = 6:-1:1
    crnt = mod(j-1,2)+1;
    if (j ==5) || (j == 6)
        GuIformat.QWH(j) = uicontrol(Control,...
            'Units','normalized',...
            'Style','togglebutton',...
            'String',strcat({'QuickDump '},num2str(crnt)),...
            'Userdata',chipdata.QuickDamp(crnt),...
            'Position',[0 (1/6)*(j-1) (1) (1/6)],...
            'HandleVisibility','off',...
            'BackgroundColor',GuIformat.color.c);
        set(GuIformat.QWH(j),'callback',@togglebutton_Callback);
    end
    if (j == 3) || (j == 4)
        GuIformat.QWH(j) = uicontrol(Control,...
            'Units','normalized',...
            'Style','togglebutton',...
            'String',strcat({'Waste '},num2str(crnt)),...
            'Userdata',chipdata.Waste(crnt),...
            'Position',[0 (1/6)*(j-1) (1) (1/6)],...
            'HandleVisibility','off',...
            'BackgroundColor',GuIformat.color.c);
        set(GuIformat.QWH(j),'callback',@togglebutton_Callback);
    end
    if (j == 1) || (j == 2)
        GuIformat.QWH(j) = uicontrol(Control,...
            'Units','normalized',...
            'Style','togglebutton',...
            'String',strcat({'Harvest '},num2str(crnt)),...
            'Userdata',chipdata.Pipelette(crnt),...
            'Position',[0 (1/6)*(j-1) (1) (1/6)],...
            'HandleVisibility','off',...
            'BackgroundColor',GuIformat.color.c);
        set(GuIformat.QWH(j),'callback',@togglebutton_Callback);
    end
end
end

function DWCControlPanel(hObject,eventdata,handles)

global vc chipdata GuIformat;

Control = uibuttongroup('Visible','on',...
    'Position',[.85 GuIformat.Vert2 .15 .2],...
    'Title','Chip Initialization');
DWC = {'PBS','Pluronic','solution'};

for j = 1:16
    LigandList(j) = strcat({'Ligand '},num2str(j));
end

preprtry = {'Coat chambers with:','Apply detergent:','Wash with:'};

for i = 1:3
    GuIformat.DWC(i) = uicontrol(Control,...
        'Units','normalized',...
        'Style','popupmenu',...
        'String',GuIformat.LigandNames,...
        'UserData',preprtry{i},...
        'Position',[(0) (1/3)*(i-1)+1/9 (1/2) (1/9)],...
        'HandleVisibility','off');
    set(GuIformat.DWC(i),'callback',@ChipPrepPUM_Callback);
    
    GuIformat.DWC(i) = uicontrol(Control,...
        'Units','normalized',...
        'Style','edit',...
        'String','Time (s)',...
        'UserData',preprtry{i},...
        'Position',[(0) (1/3)*(i-1) (1/2) (1/9)],...
        'HandleVisibility','off');
    set(GuIformat.DWC(i),'callback',@ChipPrepTimeEditBox_Callback);
    
    GuIformat.DWC(i) = uicontrol(Control,...
        'Units','normalized',...
        'Style','checkbox',...
        'String',preprtry{i},...
        'UserData',preprtry{i},...
        'Position',[(0) (1/3)*(i-1)+2/9 (1/2) (1/9)],...
        'HandleVisibility','off');
    set(GuIformat.DWC(i),'callback',@ChipPrepCB_Callback);
    GuIformat.CBs1{i} = preprtry{i};
    GuIformat.CBs2(i) = 0;
    GuIformat.PUMs1{i} = preprtry{i};
    GuIformat.PUMs2(i) = 0;
    GuIformat.PrepTimes1{i} = preprtry{i};
    GuIformat.PrepTimes2(i) = 0;
    
end

GuIformat.DWCButt(1) = uicontrol(Control,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Pause',...
    'UserData',0,...
    'Position',[(1/2) 0 (1/2) (1/3)],...
    'HandleVisibility','off');
set(GuIformat.DWCButt(1),'callback',@DWCPause_PBCallback);

GuIformat.DWCButt(2) = uicontrol(Control,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Stop',...
    'Position',[(1/2) (1/3) (1/2) (1/3)],...
    'HandleVisibility','off');
set(GuIformat.DWCButt(2),'callback',@DWCStop_PBCallback);

GuIformat.DWCButt(3) = uicontrol(Control,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Start From Beginning',...
    'Position',[(1/2) (2/3) (1/2) (1/3)],...
    'HandleVisibility','off');
set(GuIformat.DWCButt(3),'callback',@DWCStart_PBCallback);

end

function SchematicPanel(hObject,eventdata,handles)

global vc chipdata GuIformat;

I = imread('SCCC_Full_cropped.png');
hChipAxes = axes(...    % Axes for plotting the selected plot
    'Units', 'normalized', ...
    'Position',[0 GuIformat.Vert2-.5 0.5 0.5]);
axes(hChipAxes);
imshow(I);
end

function ScriptingPanel(hObject,eventdata,handles)

global vc chipdata GuIformat;

%% Experimental Design Panel

ScriptPanel = uipanel('Visible','on',...
    'Position',[.5 0 .5 GuIformat.Vert2],...
    'Title','Procedure Scripting');

%% Top Bar

TopBar = uipanel(ScriptPanel,'Visible','on',...
    'Position',[0 .95 1 .05],...
    'Title','Top Bar');



GuIformat.ScriptHandling(1) = uicontrol(TopBar,...
    'Units','normalized',...
    'Style','popupmenu',...
    'String','',...
    'Position',[0 0 .4 1],...
    'HandleVisibility','off',...
    'Callback',@BrowseScript_PUMCallback);
rghScriptDir = dir(GuIformat.ScriptDir);
count = 0;
for i = 1:length(rghScriptDir)
    if regexp(rghScriptDir(i).name,'.mat')
        count = count + 1;
        flnms{count} = rghScriptDir(i).name;
    end
end
if count > 0
    set(GuIformat.ScriptHandling(1),'String',flnms);
    GuIformat.slctdScript = flnms{1};
else
    set(GuIformat.ScriptHandling(1),'String',cd);
end
    function BrowseScript_PUMCallback(hObject,callbackdata)
        rghScriptDir = dir(GuIformat.ScriptDir);
        count = 0;
        for i = 1:length(rghScriptDir)
            if regexp(rghScriptDir(i).name,'.mat')
                count = count + 1;
                flnms{count} = rghScriptDir(i).name;
            end
        end
        if count > 0
            set(GuIformat.ScriptHandling(1),'String',flnms);
            GuIformat.slctdScript = flnms{1};
        else
            choice = questdlg('No experiments were detected. Continue?', ...
                'Warning: Experiment Not Found', ...
                'Yes','No','No');
            switch choice
                case 'Yes'
                    set(GuIformat.ScriptHandling(1),'String',GuIformat.ScriptDir);
                case 'No'
                    set(GuIformat.ScriptHandling(1),'String',cd);
            end
        end
    end
GuIformat.ScriptHandling(2) = uicontrol(TopBar,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Browse',...
    'Position',[.4 0 .12 1],...
    'Callback',@BrowseScript_PBCallback);
    function BrowseScript_PBCallback(hObject, callbackdata)
        GuIformat.ScriptDir = uigetdir(cd);
        rghScriptDir = dir(GuIformat.ScriptDir);
        count = 0;
        for i = 1:length(rghScriptDir)
            if regexp(rghScriptDir(i).name,'.mat')
                count = count + 1;
                flnms{count} = rghScriptDir(i).name;
            end
        end
        if count > 0
            set(GuIformat.ScriptHandling(1),'String',flnms);
            GuIformat.slctdScript = flnms{1};
        else
            choice = questdlg('No experiments were detected. Continue?', ...
                'Warning: Experiment Not Found', ...
                'Yes','No','No');
            switch choice
                case 'Yes'
                    set(GuIformat.ScriptHandling(1),'String',GuIformat.ScriptDir);
                case 'No'
                    set(GuIformat.ScriptHandling(1),'String',cd);
            end
        end
    end
GuIformat.ScriptHandling(3) = uicontrol(TopBar,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Load',...
    'Position',[.52 0 .12 1],...
    'Callback',@LoadScript_PBCallback);
    function LoadScript_PBCallback(hObject, callbackdata)
        items = get(GuIformat.ScriptHandling(1),'String');
        index_selected = get(GuIformat.ScriptHandling(1),'Value');
        item_selected = items{index_selected};
        GuIformat.slctdScript = item_selected;
        mFile = '.mat';
        if regexp(GuIformat.slctdScript,mFile)
            Temp = load(fullfile(GuIformat.ScriptDir,GuIformat.slctdScript));
            display(Temp);
            GuIformat.Treatments = Temp.Temp.Treatments;
            GuIformat.Experiments = Temp.Temp.Experiments;
            GuIformat.StandardInc = Temp.Temp.StandardInc
            set(GuIformat.ScriptHandling(5),'String',GuIformat.slctdScript(1:regexp(GuIformat.slctdScript,'.mat')-1));
            
            updatedtreatments = GuIformat.Treatments(:,1);
            updatedexperiments = GuIformat.Experiments(:,1);
            
            set(GuIformat.ExperimentTab(10),'String',updatedexperiments);
            set(GuIformat.ExperimentTab(10),'Value',1);
            set(GuIformat.TreatmentTab(4),'String',updatedtreatments);
            set(GuIformat.TreatmentTab(4),'Value',1);
            set(GuIformat.ExperimentTab(1),'String',updatedtreatments);
            set(GuIformat.ExperimentTab(1),'Value',1);
            selected = 1;
            TreatmentList = cellstr(get(GuIformat.ExperimentTab(1),'String'));
            TreatmentComposure = GuIformat.Experiments{selected,2};
            TreatmentSet = cellstr(TreatmentList(TreatmentComposure));
            set(GuIformat.ExperimentTab(6),'String',TreatmentSet);
            set(GuIformat.ExperimentTab(6),'Value',1);
            set(GuIformat.TreatmentTab(5),'String',GuIformat.Treatments{1,1});
            set(GuIformat.TreatmentTab(7),'Value',GuIformat.Treatments{1,2});
            set(GuIformat.TreatmentTab(8),'Value',GuIformat.Treatments{1,3});
            set(GuIformat.TreatmentTab(9),'Value',GuIformat.Treatments{1,4});
            set(GuIformat.TreatmentTab(10),'String',GuIformat.Treatments{1,5});
            set(GuIformat.TreatmentTab(12),'String',GuIformat.Treatments{1,6});
            set(GuIformat.TreatmentTab(13),'Value',GuIformat.Treatments{1,7});
            set(GuIformat.TreatmentTab(14),'String',GuIformat.Treatments{1,8});
            set(GuIformat.TreatmentTab(16),'Value',GuIformat.Treatments{1,9});
            set(GuIformat.TreatmentTab(18),'String',GuIformat.Treatments{1,10});
            set(GuIformat.TreatmentTab(20),'Value',GuIformat.Treatments{1,11});
            set(GuIformat.TreatmentTab(21),'Value',GuIformat.Treatments{1,12});
            set(GuIformat.TreatmentTab(22),'Value',GuIformat.Treatments{1,13});
            set(GuIformat.TreatmentTab(28),'Value',GuIformat.StandardInc);
            
            for i = 1:4
                for j = 1:12
                    set(GuIformat.ChamberSelect(i,j,1),'String',GuIformat.Experiments(:,1));
                    set(GuIformat.ChamberSelect(i,j,2),'Value',0);
                    set(GuIformat.ChamberSelect(i,j,1),'Value',1);
                    set(GuIformat.ChamberSelect(i,j,1),'Visible','Off');
                end
            end
            
            
            [XX ~] = size(GuIformat.Experiments)
            for i = 1:4
                for j = 1:12
                    for q = 1:XX
                        if GuIformat.Experiments{q,3}(i,13-j) == 1
                            set(GuIformat.ChamberSelect(i,j,2),'Value',1);
                            set(GuIformat.ChamberSelect(i,j,1),'Value',q);
                            set(GuIformat.ChamberSelect(i,j,1),'Visible','On');
                        end
                    end
                end
            end
            
            
            
        else
            msgbox('Not a Recognized File Format');
        end
    end
GuIformat.ScriptHandling(4) = uicontrol(TopBar,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Run',...
    'Position',[.64 0 .12 1],...
    'HandleVisibility','off',...
    'Callback',@RunScript_PBCallback);
    function RunScript_PBCallback(hObject, callbackdata)
        TSMessage(strcat(GuIformat.slctdScript,{':Started:'}),GuIformat.ScriptDir)

        IncuMark = 0
        [XX, YY] = size(GuIformat.Experiments)
        explength = zeros(1,XX)
        for i = 1:XX
            explength(1,i) = length(GuIformat.Experiments{i,2})
        end
        maxexplength = max(explength)
        GuIformat.STOP = 0;
   
        for z = 1:maxexplength
            if GuIformat.STOP == 0

                for i = 1:XX
                    val = GuIformat.Experiments{i,2}(z);
                    if GuIformat.Treatments{val,2} == 99
                        IncuMark = 1
                    else
                        
                        StepName =   GuIformat.Treatments{val,1};  % STEP NAME
                        InputNumber =  GuIformat.Treatments{val,2} ; % INPUT NUMBER
                        QuickDumpState =  GuIformat.Treatments{val,3} ;  % USE QUICKDUMP? YES(1) NO(0)
                        QuickDumpNum =   GuIformat.Treatments{val,4} ;  % WHICH QUICKDUMP? 1 OR 2
                        QuickDumpTime =  GuIformat.Treatments{val,5};  % TIME THROUGH QUICKDUMP? (SECONDS)
                        if GuIformat.Treatments{val,11} == 1
                            UpChannelFlush =  1 ;  % FLUSH UPPER CHANNELS? YES(1) NO(0)
                            DownChannelFlush =  0  ;  % FLUSH LOWER CHANNELS? YES(1) NO(0)
                        else
                            UpChannelFlush =  0 ;  % FLUSH UPPER CHANNELS? YES(1) NO(0)
                            DownChannelFlush =  1  ;  % FLUSH LOWER CHANNELS? YES(1) NO(0)
                        end
                        ChannelFlushTime =    GuIformat.Treatments{val,6} ;   % TIME THROUGH UPPER AND LOWER CHANNELS (SECONDS)
                        PumpState =   GuIformat.Treatments{val,7} ;   % USE PUMP MECHANISM? YES(1) OR NO(0)
                        PumpCycle =   150    % NUMBER OF PUMP CYCLES
                        PumpInt =    GuIformat.Treatments{val,8} ;  % PUMP CYCLE INTERVAL
                        UpDown =    GuIformat.Treatments{val,11} ;  % SEND MEDIA UP THROUGH CHAMBER COMPONENT OR DOWN? DOWN(1) OR UP(0)
                        LeftRight =    GuIformat.Treatments{val,9} ;  % FLUSH THROUGH LEFT OR RIGHT CHAMBER SIDECHANNEL? LEFT(1) RIGHT(2) BOTH([1,2])
                        Address =    GuIformat.Experiments{i,3} ;  % WHICH COLUMN OF CHAMBERS TO ADDRESS? 1,2,3,4,5,6,7,8,9,10,11,12
                        FeedTime =    GuIformat.Treatments{val,10} ;  % TIME TO FLUSH EACH CHAMBER SIDECHANNEL? (SECONDS)
                        WasteState =    GuIformat.Treatments{val,12} ;   % WASTE OPEN OR CLOSED? OPEN(1) CLOSED(0)
                        WasteNum =   GuIformat.Treatments{val,13} ;   % WHICH WASTE TO USE? 1 OR 2
                        RUNTREATMENT(StepName,...
                            InputNumber,...
                            QuickDumpState,...
                            QuickDumpNum,...
                            QuickDumpTime,...
                            UpChannelFlush,...
                            DownChannelFlush,...
                            ChannelFlushTime,...
                            PumpState,...
                            PumpCycle,...
                            PumpInt,...
                            UpDown,...
                            LeftRight,...
                            Address,...
                            FeedTime,...
                            WasteState,...
                            WasteNum)
                    end
                end
                if IncuMark == 1
                    count = 0
                    while count < GuIformat.StandardInc*60 && GuIformat.STOP == 0
                        PAUSEchk
                        pause(.5)
                        count = count + .5
                    end
                    IncuMark = 0
                end
            end
            
        end

        TSMessage(strcat(GuIformat.slctdScript,{':Ended:'}),GuIformat.ScriptDir)
    end

GuIformat.ScriptHandling(7) = uicontrol(TopBar,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Pause',...
    'Position',[.76 0 .12 1],...
'Callback',@ExpPause_PBCallback);
    function ExpPause_PBCallback(hObject,callbackdata)
        if GuIformat.PAUSE == 1
        GuIformat.PAUSE = 0
        set(GuIformat.ScriptHandling(7),'BackgroundColor',[0.9412    0.9412    0.9412])
        set(GuIformat.ScriptHandling(7),'String','Pause')
        elseif GuIformat.PAUSE == 0
            GuIformat.PAUSE = 1
            set(GuIformat.ScriptHandling(7),'BackgroundColor',GuIformat.color.c)
            set(GuIformat.ScriptHandling(7),'String','Resume')
        end
    end
GuIformat.ScriptHandling(8) = uicontrol(TopBar,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Stop',...
    'Position',[.88 0 .12 1],...
    'HandleVisibility','off',...
    'Callback',@DWCStop_PBCallback);

%% Bottom Bar
BottomBar = uipanel(ScriptPanel,'Visible','on',...
    'Position',[0 0 1 .05],...
    'Title','Bottom Bar');

GuIformat.ScriptHandling(5) = uicontrol(BottomBar,...
    'Units','normalized',...
    'Style','Edit',...
    'String','Experiment Name',...
    'Position',[0 0 .35 1],...
    'HandleVisibility','off');
GuIformat.SciptHandling(6) = uicontrol(BottomBar,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Save as',...
    'Position',[.35 0 .05 1],...
    'HandleVisibility','off',...
    'Callback',@SaveExp_PBCallback);
    function SaveExp_PBCallback(hObject,callbackdata)
        Temp.Experiments = GuIformat.Experiments
        Temp.Treatments = GuIformat.Treatments
        Temp.StandardInc = GuIformat.StandardInc
        expnm = horzcat(get(GuIformat.ScriptHandling(5),'String'),'.mat')
        save(fullfile(GuIformat.ScriptDir,expnm),'Temp')
        %if regexp(get(GuIformat.ScriptHandling(5),'String'),'.mat') == 0
        %             expnm = horzcat(get(GuIformat.ScriptHandling(5),'String'),'.mat')
        %             Temp.Experiments = GuIformat.Experiments
        %             Temp.Treatments = GuIformat.Treatments
        %
        %             exist(fullfile(GuIformat.ScriptDir,expnm),'file')
        %             if exist(fullfile(GuIformat.ScriptDir,expnm),'file')
        %                 choice = questdlg('That filename already exists. Overwrite it?', ...
        %                     'Overwrite?', ...
        %                     'Overwrite','Cancel','Cancel');
        %                 switch choice
        %                     case 'Overwrite'
        %                         save(fullfile(GuIformat.ScriptDir,expnm),'Temp')
        %                     case 'Cancel'
        %                 end
        %             else
        %                 save(fullfile(GuIformat.ScriptDir,expnm),'Temp')
        %             end
        %             rghScriptDir = dir(GuIformat.ScriptDir);
        %             count = 0;
        %             for i = 1:length(rghScriptDir)
        %                 if regexp(rghScriptDir(i).name,'.mat')
        %                     count = count + 1;
        %                     flnms{count} = rghScriptDir(i).name;
        %                     if flnms{count} == horzcat(get(GuIformat.ScriptHandling(5),'String'),'.mat')
        %                         set(GuIformat.ScriptHandling(1),'Value',count);
        %                     end
        %                 end
        %             end
        %             if count > 0
        %                 set(GuIformat.ScriptHandling(1),'String',flnms);
        %                 GuIformat.slctdScript = flnms{1};
        %             else
        %                 choice = questdlg('No experiments were detected. Continue?', ...
        %                     'Warning: Experiment Not Found', ...
        %                     'Yes','No','No');
        %                 switch choice
        %                     case 'Yes'
        %                         set(GuIformat.ScriptHandling(1),'String',GuIformat.ScriptDir);
        %                     case 'No'
        %                         set(GuIformat.ScriptHandling(1),'String',cd);
        %                 end
        %             end
        %end
    end

%% Middle Bar

GUITabs = uitabgroup(ScriptPanel,'Position',[0 .05 1 .9],'Units','normalized');

%% Treatment Tab

TreatmentTab = uitab(GUITabs,'Title','Treatments');

TreatmentBox = uipanel(TreatmentTab,...
    'Units','normalized',...
    'Position',[0 0 1 1],...
    'HandleVisibility','off');

GuIformat.TreatmentTab(1) = uicontrol(TreatmentBox,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','+',...
    'Position',[.7 .95 .15 .05],...
    'HandleVisibility','off',...
    'Callback',@TreatmentAdd_PBCallback);
    function TreatmentAdd_PBCallback(hObject,Callbackdata)
        CurrentList = get(GuIformat.TreatmentTab(4),'String');
        display(CurrentList);
        UpDatedList = strvcat(char(CurrentList), 'New Treatment');
        display(UpDatedList);
        GuIformat.Treatments = [GuIformat.Treatments;cell(1,13)];
        [x y] = size(GuIformat.Treatments);
        GuIformat.Treatments{x,1} = 'New Treatment';
        GuIformat.Treatments{x,2} = 1;
        GuIformat.Treatments{x,3} = 1;
        GuIformat.Treatments{x,4} = 1;
        GuIformat.Treatments{x,5} = 5;
        GuIformat.Treatments{x,6} = 10;
        GuIformat.Treatments{x,7} = 0;
        GuIformat.Treatments{x,8} = .01;
        GuIformat.Treatments{x,9} = 3;
        GuIformat.Treatments{x,10} = 5;
        GuIformat.Treatments{x,11} = 1;
        GuIformat.Treatments{x,12} = 1;
        GuIformat.Treatments{x,13} = 1;
        set(GuIformat.TreatmentTab(4),'String',UpDatedList);
        set(GuIformat.ExperimentTab(1),'String',UpDatedList);
        set(GuIformat.ExperimentTab(1),'Value',1);
    end
GuIformat.TreatmentTab(2) = uicontrol(TreatmentBox,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','-',...
    'Position',[.85 .95 .15 .05],...
    'HandleVisibility','off',...
    'callback',@TreatmentSubtract_PBCallback);
    function TreatmentSubtract_PBCallback(hObject,Callbackdata)
        selected = get(GuIformat.TreatmentTab(4),'Value');
        if selected ~= 1
            CurrentList = cellstr(get(GuIformat.TreatmentTab(4),'String'));
            CurrentList(selected) = [];
            UpDatedList = char(CurrentList);
            if selected - 1 <= 1
                selected = 1
                set(GuIformat.TreatmentTab(4),'Value',1);
                for i = 5:26
                    set(GuIformat.TreatmentTab(i),'Visible','Off');
                end
                set(GuIformat.TreatmentTab(27),'Visible','On');
                set(GuIformat.TreatmentTab(28),'Visible','On');
                set(Text,'Visible','Off')
            else
                set(GuIformat.TreatmentTab(4),'Value',selected - 1);
            end
            GuIformat.Treatments(selected,:) = [];
            set(GuIformat.TreatmentTab(4),'String',UpDatedList);
            set(GuIformat.ExperimentTab(1),'String',UpDatedList);
            set(GuIformat.ExperimentTab(1),'Value',1);
            if length(CurrentList) + 1 == selected
                selected = selected - 1
            end
            
            set(GuIformat.TreatmentTab(5),'String',GuIformat.Treatments{selected,1});
            set(GuIformat.TreatmentTab(7),'Value',GuIformat.Treatments{selected,2});
            set(GuIformat.TreatmentTab(8),'Value',GuIformat.Treatments{selected,3});
            set(GuIformat.TreatmentTab(9),'Value',GuIformat.Treatments{selected,4});
            set(GuIformat.TreatmentTab(10),'String',GuIformat.Treatments{selected,5});
            set(GuIformat.TreatmentTab(12),'String',GuIformat.Treatments{selected,6});
            set(GuIformat.TreatmentTab(13),'Value',GuIformat.Treatments{selected,7});
            set(GuIformat.TreatmentTab(14),'String',GuIformat.Treatments{selected,8});
            set(GuIformat.TreatmentTab(16),'Value',GuIformat.Treatments{selected,9});
            set(GuIformat.TreatmentTab(18),'String',GuIformat.Treatments{selected,10});
            set(GuIformat.TreatmentTab(20),'Value',GuIformat.Treatments{selected,11});
            set(GuIformat.TreatmentTab(21),'Value',GuIformat.Treatments{selected,12});
            set(GuIformat.TreatmentTab(22),'Value',GuIformat.Treatments{selected,13});
        end
    end
GuIformat.TreatmentTab(4) = uicontrol(TreatmentBox,...
    'Units','normalized',...
    'Style','listbox',...
    'String','Incubate',...
    'Position',[.7 0 .3 .95],...
    'HandleVisibility','off',...
    'Callback',@UpdateTreatmentVars_LSTCallback);
    function UpdateTreatmentVars_LSTCallback(hObject,callbackdata)
        selected = get(hObject,'Value');
        if selected == 1
            for i = 5:26
                set(GuIformat.TreatmentTab(i),'Visible','Off');
            end
            set(GuIformat.TreatmentTab(27),'Visible','On');
            set(GuIformat.TreatmentTab(28),'Visible','On');
            set(Text,'Visible','Off')
        else
            set(Text,'Visible','On')
            set(GuIformat.TreatmentTab(27),'Visible','Off');
            set(GuIformat.TreatmentTab(28),'Visible','Off');
            for i = 5:26
                set(GuIformat.TreatmentTab(i),'Visible','On');
            end
        end
        set(GuIformat.TreatmentTab(5),'String',GuIformat.Treatments{selected,1});
        set(GuIformat.TreatmentTab(7),'Value',GuIformat.Treatments{selected,2});
        set(GuIformat.TreatmentTab(8),'Value',GuIformat.Treatments{selected,3});
        set(GuIformat.TreatmentTab(9),'Value',GuIformat.Treatments{selected,4});
        set(GuIformat.TreatmentTab(10),'String',GuIformat.Treatments{selected,5});
        set(GuIformat.TreatmentTab(12),'String',GuIformat.Treatments{selected,6});
        set(GuIformat.TreatmentTab(13),'Value',GuIformat.Treatments{selected,7});
        set(GuIformat.TreatmentTab(14),'String',GuIformat.Treatments{selected,8});
        set(GuIformat.TreatmentTab(16),'Value',GuIformat.Treatments{selected,9});
        set(GuIformat.TreatmentTab(18),'String',num2str(GuIformat.Treatments{selected,10}));
        set(GuIformat.TreatmentTab(20),'Value',GuIformat.Treatments{selected,11});
        set(GuIformat.TreatmentTab(21),'Value',GuIformat.Treatments{selected,12});
        set(GuIformat.TreatmentTab(22),'Value',GuIformat.Treatments{selected,13});
    end

EditBox = uipanel(TreatmentBox,...
    'Units','normalized',...
    'Position',[0 0 .7 1],...
    'HandleVisibility','off');
%% Treatment Name
NameBox = uipanel(EditBox,...
    'Units','normalized',...
    'Position',[0 .95 1 .05],...
    'HandleVisibility','off');

Text = uicontrol(NameBox,...
    'Units','normalized',...
    'Style','text',...
    'String','Treatment Name:',...
    'Position',[0 0 .2 1],...
    'HandleVisibility','off',...
    'callback',@TreatmentName_EditCallback);

GuIformat.TreatmentTab(5) = uicontrol(NameBox,...
    'Units','normalized',...
    'Style','edit',...
    'String','',...
    'Position',[.2 0 .8 1],...
    'HandleVisibility','off',...
    'callback',@TreatmentName_EditCallback);
    function TreatmentName_EditCallback(hObject,callbackdata)
        selected = get(GuIformat.TreatmentTab(4),'Value');
        if selected ~= 1
            currentlist = cellstr(get(GuIformat.TreatmentTab(4),'String'));
            display(currentlist);
            input = get(hObject,'String');
            GuIformat.Treatments{selected,1} = input;
            currentlist{selected} = input;
            currentlist = char(currentlist);
            set(GuIformat.TreatmentTab(4),'String',currentlist);
            set(GuIformat.ExperimentTab(1),'String',currentlist);
        end
    end
%% Ligand
LigandBox = uipanel(EditBox,...
    'Units','normalized',...
    'Position',[0 .9 1 .05],...
    'HandleVisibility','off');

GuIformat.TreatmentTab(6) = uicontrol(LigandBox,...
    'Units','normalized',...
    'Style','text',...
    'String','Ligand:',...
    'Position',[0 0 .15 1],...
    'HandleVisibility','off');
GuIformat.TreatmentTab(7) = uicontrol(LigandBox,...
    'Units','normalized',...
    'Style','popupmenu',...
    'String',GuIformat.LigandNames,...
    'Position',[.15 0 .3 1],...
    'HandleVisibility','off',...
    'Callback',@Ligand_PUMCallback);
    function Ligand_PUMCallback(hObject,callbackdata)
        selectedtreatment = get(GuIformat.TreatmentTab(4),'Value');
        if selectedtreatment ~= 1
            selectedligand = get(hObject,'Value');
            GuIformat.Treatments{selectedtreatment,2} = selectedligand;
            display(GuIformat.Treatments{selectedtreatment,2});
        end
    end
GuIformat.TreatmentTab(8) = uicontrol(LigandBox,...
    'Units','normalized',...
    'Style','checkbox',...
    'String','Quickdump:',...
    'Position',[.45 0 .15 1],...
    'HandleVisibility','off',...
    'Callback',@QuickDump_CBCallback);
    function QuickDump_CBCallback(hObject,callbackdata)
        selectedtreatment = get(GuIformat.TreatmentTab(4),'Value');
        if selectedtreatment ~= 1
            selected = get(hObject,'Value');
            GuIformat.Treatments{selectedtreatment,3} = selected;
            display(GuIformat.Treatments{selectedtreatment,3});
        end
    end
GuIformat.TreatmentTab(9) = uicontrol(LigandBox,...
    'Units','normalized',...
    'Style','popupmenu',...
    'String',{'1','2'},...
    'Position',[.6 0 .15 1],...
    'HandleVisibility','off',...
    'Callback',@QuickDump_PUMCallback);
    function QuickDump_PUMCallback(hObject,callbackdata)
        selectedtreatment = get(GuIformat.TreatmentTab(4),'Value');
        if selectedtreatment ~= 1
            selected = get(hObject,'Value');
            GuIformat.Treatments{selectedtreatment,4} = selected;
            display(GuIformat.Treatments{selectedtreatment,4});
        end
    end
GuIformat.TreatmentTab(10) = uicontrol(LigandBox,...
    'Units','normalized',...
    'Style','edit',...
    'String','time (s)',...
    'Position',[.75 0 .25 1],...
    'HandleVisibility','off',...
    'Callback',@QuickDump_EDTCallback);
    function QuickDump_EDTCallback(hObject,callbackdata)
        selectedtreatment = get(GuIformat.TreatmentTab(4),'Value')
        if selectedtreatment ~= 1
            selected = str2num(get(hObject,'String'))
            GuIformat.Treatments{selectedtreatment,5} = selected;
            display(GuIformat.Treatments{selectedtreatment,5});
        end
    end
%% Treatment Condition
CTBox = uipanel(EditBox,...
    'Units','normalized',...
    'Position',[0 0 1 .9],...
    'HandleVisibility','off');

GuIformat.TreatmentTab(11) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','text',...
    'String','Channel Flush Time (s):',...
    'Position',[0 .9 .3 .1],...
    'HandleVisibility','off',...
    'HorizontalAlignment','left');
GuIformat.TreatmentTab(12) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','edit',...
    'String','time (s)',...
    'Position',[.3 .95 .2 .05],...
    'HandleVisibility','off',...
    'HorizontalAlignment','left',...
    'Callback',@ChannelFlush_EDTCallback);
    function ChannelFlush_EDTCallback(hObject,callbackdata)
        selectedtreatment = get(GuIformat.TreatmentTab(4),'Value')
        if selectedtreatment ~= 1
            selected = str2num(get(hObject,'String'))
            GuIformat.Treatments{selectedtreatment,6} = selected;
            display(GuIformat.Treatments{selectedtreatment,6});
        end
    end
%% Chamber Treatment
GuIformat.TreatmentTab(13) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','checkbox',...
    'String','Pump:',...
    'Position',[0 .8 .3 .1],...
    'HandleVisibility','off',...
    'HorizontalAlignment','left',...
    'Callback',@PumpState_CBCallback);
    function PumpState_CBCallback(hObject,callbackdata)
        selectedtreatment = get(GuIformat.TreatmentTab(4),'Value');
        if selectedtreatment ~= 1
            selected = get(hObject,'Value');
            GuIformat.Treatments{selectedtreatment,7} = selected;
            display(GuIformat.Treatments{selectedtreatment,7});
        end
    end
GuIformat.TreatmentTab(14) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','edit',...
    'String','Interval (s)',...
    'Position',[.3 .8 .2 .1],...
    'HandleVisibility','off',...
    'HorizontalAlignment','left',...
    'Callback',@PumpInterval_EDTCallback);
    function PumpInterval_EDTCallback(hObject,callbackdata)
        selectedtreatment = get(GuIformat.TreatmentTab(4),'Value');
        if selectedtreatment ~= 1
            selected = str2num(get(hObject,'String'));
            GuIformat.Treatments{selectedtreatment,8} = selected;
            display(GuIformat.Treatments{selectedtreatment,8});
        end
    end
GuIformat.TreatmentTab(15) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','text',...
    'String','Chamber Component Flush:',...
    'Position',[0 .7 .3 .1],...
    'HandleVisibility','off',...
    'HorizontalAlignment','left');
GuIformat.TreatmentTab(16) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','popupmenu',...
    'String',{'None','Left + Right + Middle','Left + Right','Middle','Left','Right'},...
    'Position',[.3 .7 .2 .1],...
    'HandleVisibility','off',...
    'Callback',@ChamberComponent_PUMCallback);
    function ChamberComponent_PUMCallback(hObject,callbackdata)
        selectedtreatment = get(GuIformat.TreatmentTab(4),'Value');
        selectedcomponent = get(hObject,'Value')
        if selectedtreatment ~= 1
            GuIformat.Treatments{selectedtreatment,9} = selectedcomponent;
            display(GuIformat.Treatments{selectedtreatment,9});
        end
    end
GuIformat.TreatmentTab(17) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','text',...
    'String','Chamber Component Flush Time (s):',...
    'Position',[0 .6 .3 .1],...
    'HandleVisibility','off',...
    'HorizontalAlignment','left');
GuIformat.TreatmentTab(18) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','edit',...
    'String',5,...
    'Position',[.3 .65 .2 .05],...
    'HandleVisibility','off',...
    'HorizontalAlignment','left',...
    'Callback',@ChamberFlushTime_EDTCallback);
    function ChamberFlushTime_EDTCallback(hObject,callbackdata)
        selectedtreatment = get(GuIformat.TreatmentTab(4),'Value');
        if selectedtreatment ~= 1
            selected = str2num(get(hObject,'String'));
            GuIformat.Treatments{selectedtreatment,10} = selected;
            display(GuIformat.Treatments{selectedtreatment,10})
        end
    end
GuIformat.TreatmentTab(19) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','text',...
    'String','Chamber Component Flush Direction:',...
    'Position',[0 .5 .3 .1],...
    'HandleVisibility','off',...
    'HorizontalAlignment','left');
GuIformat.TreatmentTab(20) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','popupmenu',...
    'String',{'Top Down', 'Bottom Up','Asymmetric'},...
    'Position',[.3 .5 .2 .1],...
    'HandleVisibility','off',...
    'HorizontalAlignment','left',...
    'Callback',@ChamberDirection_PUMCallback);
    function ChamberDirection_PUMCallback(hObject,callbackdata)
        selectedtreatment = get(GuIformat.TreatmentTab(4),'Value');
        if selectedtreatment ~= 1
            selected = get(hObject,'Value');
            GuIformat.Treatments{selectedtreatment,11} = selected;
            display(GuIformat.Treatments{selectedtreatment,11});
        end
    end
%% Waste
GuIformat.TreatmentTab(21) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','Checkbox',...
    'String','Waste:',...
    'Position',[0 .4 .3 .1],...
    'HandleVisibility','off',...
    'HorizontalAlignment','left',...
    'Callback',@WasteState_CBCallback);
    function WasteState_CBCallback(hObject,callbackdata)
        selectedtreatment = get(GuIformat.TreatmentTab(4),'Value');
        if selectedtreatment ~= 1
            selected = get(hObject,'Value');
            GuIformat.Treatments{selectedtreatment,12} = selected;
            display(GuIformat.Treatments{selectedtreatment,12});
        end
    end
GuIformat.TreatmentTab(22) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','popupmenu',...
    'String',{'1','2'},...
    'Position',[.3 .4 .2 .1],...
    'HandleVisibility','off',...
    'HorizontalAlignment','left',...
    'Callback',@WasteNum_PUMCallback);
    function WasteNum_PUMCallback(hObject,callbackdata)
        selectedtreatment = get(GuIformat.TreatmentTab(4),'Value');
        if selectedtreatment ~= 1
            selected = get(hObject,'Value');
            GuIformat.Treatments{selectedtreatment,13} = selected;
            display(GuIformat.Treatments{selectedtreatment,13});
        end
    end
%% Harvest
GuIformat.TreatmentTab(25) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','Checkbox',...
    'String','Harvest:',...
    'Position',[.0 .2 .3 .1],...
    'HandleVisibility','off',...
    'HorizontalAlignment','left');
GuIformat.TreatmentTab(26) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','popupmenu',...
    'String',{'1','2'},...
    'Position',[.3 .2 .2 .1],...
    'HandleVisibility','off',...
    'HorizontalAlignment','left');

%% Incubation Setting

GuIformat.TreatmentTab(27) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','text',...
    'String','Incubate (minutes):',...
    'Position',[.0 .1 .3 .1],...
    'HandleVisibility','off',...
    'HorizontalAlignment','left');
GuIformat.TreatmentTab(28) = uicontrol(CTBox,...
    'Units','normalized',...
    'Style','edit',...
    'String',GuIformat.StandardInc,...
    'Position',[.3 .1 .2 .1],...
    'HandleVisibility','off',...
    'HorizontalAlignment','left',...
    'Callback',@SetIncubate_EDTCallback);
    function SetIncubate_EDTCallback(hObject,callbackdata)
        selectedtreatment = get(GuIformat.TreatmentTab(4),'Value');
        if selectedtreatment == 1
            input = str2num(get(hObject,'String'));
            GuIformat.StandardInc = input;
            display(GuIformat.StandardInc);
        end
    end

%% Default Values
set(GuIformat.TreatmentTab(5),'String',GuIformat.Treatments{1,1});
set(GuIformat.TreatmentTab(7),'Value',GuIformat.Treatments{1,2});
set(GuIformat.TreatmentTab(8),'Value',GuIformat.Treatments{1,3});
set(GuIformat.TreatmentTab(9),'Value',GuIformat.Treatments{1,4});
set(GuIformat.TreatmentTab(10),'String',GuIformat.Treatments{1,5});
set(GuIformat.TreatmentTab(12),'String',GuIformat.Treatments{1,6});
set(GuIformat.TreatmentTab(13),'Value',GuIformat.Treatments{1,7});
set(GuIformat.TreatmentTab(14),'String',GuIformat.Treatments{1,8});
set(GuIformat.TreatmentTab(16),'Value',GuIformat.Treatments{1,9});
set(GuIformat.TreatmentTab(18),'String',GuIformat.Treatments{1,10});
set(GuIformat.TreatmentTab(20),'Value',GuIformat.Treatments{1,11});
set(GuIformat.TreatmentTab(21),'Value',GuIformat.Treatments{1,12});
set(GuIformat.TreatmentTab(22),'Value',GuIformat.Treatments{1,13});

for i = 5:26
    set(GuIformat.TreatmentTab(i),'Visible','Off');
end
set(Text,'Visible','Off')

%% Condition Tab
ExperimentTab = uitab(GUITabs,'Title','Conditions');

GuIformat.ExperimentTab(1) = uicontrol(ExperimentTab,...
    'Units','normalized',...
    'Style','listbox',...
    'String',get(GuIformat.TreatmentTab(4),'String'),...
    'Position',[0 0 .24 .95],...
    'HandleVisibility','off');
LoopSelection = uicontrol(ExperimentTab,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Loop Selection',...
    'Position',[.25 .65 .1 .1],...
    'HandleVisibility','off',...
    'Callback',@LoopSelection_PB);
    function LoopSelection_PB(hObject,callbackdata)
        steplist = get(GuIformat.ExperimentTab(6),'String');
        LoopedSelection = get(GuIformat.ExperimentTab(6),'Value')
        LoopedTreatments = steplist(LoopedSelection,:)
        updatedsteplist = steplist
        for i = 1:10000
            updatedsteplist = [updatedsteplist;LoopedTreatments];
        end
        set(GuIformat.ExperimentTab(6),'String',updatedsteplist);
    end
CopySelection = uicontrol(ExperimentTab,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Copy Selection',...
    'Position',[.25 .55 .1 .1],...
    'HandleVisibility','off',...
    'Callback',@CopySelection_PB);
    function CopySelection_PB(hObject,callbackdata)
        steplist = get(GuIformat.ExperimentTab(6),'String');
        CopiedSelection = get(GuIformat.ExperimentTab(6),'Value')
        CopiedTreatments = steplist(CopiedSelection,:)
        updatedsteplist = steplist
            updatedsteplist = [updatedsteplist;CopiedTreatments];
        set(GuIformat.ExperimentTab(6),'String',updatedsteplist);
    end
GuIformat.ExperimentTab(2) = uicontrol(ExperimentTab,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','+',...
    'Position',[.25 .45 .1 .1],...
    'HandleVisibility','off',...
    'Callback',@ExperimentTabMoveRight_PBCallback);
    function ExperimentTabMoveRight_PBCallback(hObject,callbackdata)
        selected = get(GuIformat.ExperimentTab(1),'Value');
        treatlist = cellstr(get(GuIformat.ExperimentTab(1),'String'));
        steplist = cellstr(get(GuIformat.ExperimentTab(6),'String'));
        input = char(treatlist{selected});
        updatedsteplist = strvcat(char(steplist),input);
        set(GuIformat.ExperimentTab(6),'String',updatedsteplist);
    end
GuIformat.ExperimentTab(3) = uicontrol(ExperimentTab,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','-',...
    'Position',[.25 .35 .1 .1],...
    'HandleVisibility','off',...
    'Callback',@ExperimentMoveLeft_PBCallback);
    function ExperimentMoveLeft_PBCallback(hObject,callbackdata)
        %FIXME
        selected = get(GuIformat.ExperimentTab(6),'Value');
        CurrentList = cellstr(get(GuIformat.ExperimentTab(6),'String'));
        CurrentList(selected) = [];
        UpDatedList = char(CurrentList);
        selected
        if selected(1) > 1
            set(GuIformat.ExperimentTab(6),'Value',selected(1) - 1);
        elseif selected(1) <= 1
            set(GuIformat.ExperimentTab(6),'Value',1);
        end
        if isempty(UpDatedList)
            set(GuIformat.ExperimentTab(6),'String','');
        else
            set(GuIformat.ExperimentTab(6),'String',UpDatedList);
        end
    end
ClearList = uicontrol(ExperimentTab,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Clear List',...
    'Position',[.25 .25 .1 .1],...
    'HandleVisibility','off',...
    'Callback',@ClearList_PBCallback);
    function ClearList_PBCallback(hObject,callbackdata)
        set(GuIformat.ExperimentTab(6),'String','')
        set(GuIformat.ExperimentTab(6),'Value',1)
    end
GuIformat.ExperimentTab(4) = uicontrol(ExperimentTab,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Move Up',...
    'Position',[.36 .95 .12 .05],...
    'HandleVisibility','off',...
    'Callback',@ExperimentTabMoveUp_PBCallback);
    function ExperimentTabMoveUp_PBCallback(hObject,CallbackData)
        selected = get(GuIformat.ExperimentTab(6),'Value');
        CurrentList = cellstr(get(GuIformat.ExperimentTab(6),'String'));
        SelectedExperiment = CurrentList(selected);
        NextExperiment = CurrentList(selected - 1);
        CurrentList(selected) = NextExperiment;
        CurrentList(selected - 1) = SelectedExperiment;
        UpDatedList = char(CurrentList);
        set(GuIformat.ExperimentTab(6),'String',UpDatedList);
        set(GuIformat.ExperimentTab(6),'Value',selected - 1);
    end
GuIformat.ExperimentTab(5) = uicontrol(ExperimentTab,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Move Down',...
    'Position',[.48 .95 .12 .05],...
    'HandleVisibility','off',...
    'Callback',@ExperimentTabMoveDown_PBCallback);
    function ExperimentTabMoveDown_PBCallback(hObject,CallbackData)
        selected = get(GuIformat.ExperimentTab(6),'Value');
        CurrentList = cellstr(get(GuIformat.ExperimentTab(6),'String'));
        display(CurrentList);
        SelectedExperiment = CurrentList(selected);
        NextExperiment = CurrentList(selected + 1);
        CurrentList(selected) = NextExperiment;
        CurrentList(selected + 1) = SelectedExperiment;
        UpDatedList = char(CurrentList);
        set(GuIformat.ExperimentTab(6),'String',UpDatedList);
        set(GuIformat.ExperimentTab(6),'Value',selected + 1);
    end
GuIformat.ExperimentTab(6) = uicontrol(ExperimentTab,...
    'Units','normalized',...
    'Style','listbox',...
    'String','',...
    'Position',[.36 0 .24 .95],...
    'Max',20,...
    'Min',1,...
    'HandleVisibility','off');
GuIformat.ExperimentTab(7) = uicontrol(ExperimentTab,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Assign',...
    'Position',[.61 .45 .1 .1],...
    'HandleVisibility','off',...
    'Callback',@ExperimentAssign_PBCallback);
    function ExperimentAssign_PBCallback(hObject,callbackdata)
        % Save Strings from listbox 2 to selected value in listbox 3.
        TreatmentList = cellstr(get(GuIformat.ExperimentTab(1),'String'));
        CurrentList = cellstr(get(GuIformat.ExperimentTab(6),'String'));
        ExperimentList = cellstr(get(GuIformat.ExperimentTab(10),'String'));
        selected = get(GuIformat.ExperimentTab(10),'Value');
        ExperimentName = ExperimentList{selected}
        [loca locb] = ismember(CurrentList,TreatmentList);
        [x,y] = size(CurrentList);
        if any(loca)
            GuIformat.Experiments{selected,1} = ExperimentName;
            GuIformat.Experiments{selected,2} = locb;
            %else
            %warndlg('Assigning a blank treatment list to an experiment is not possible at the moment.')
        end
    end
GuIformat.ExperimentTab(8) = uicontrol(ExperimentTab,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','+',...
    'Position',[.72 .95 .14 .05],...
    'HandleVisibility','off',...
    'Callback',@ExperimentAdd_PBCallback);
    function ExperimentAdd_PBCallback(hObject,Callbackdata)
        CurrentList = get(GuIformat.ExperimentTab(10),'String');
        selected = get(GuIformat.ExperimentTab(10),'Value');
        UpDatedList = strvcat(char(CurrentList), 'New Condition');
        GuIformat.Experiments = [GuIformat.Experiments;{'New Condition',[],zeros(4,12)}];
        set(GuIformat.ExperimentTab(10),'String',UpDatedList);
        set(GuIformat.ExperimentTab(10),'Value',selected + 1);
        set(GuIformat.ChamberSelect(:,:,1),'String',UpDatedList);
        display(GuIformat.Experiments{2,1})
    end
GuIformat.ExperimentTab(9) = uicontrol(ExperimentTab,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','-',...
    'Position',[.86 .95 .14 .05],...
    'HandleVisibility','off',...
    'Callback',@ExperimentSubtract_PBCallback);
    function ExperimentSubtract_PBCallback(hObject,Callbackdata)
        selected = get(GuIformat.ExperimentTab(10),'Value');
        CurrentList = cellstr(get(GuIformat.ExperimentTab(10),'String'));
        display(CurrentList);
        CurrentList(selected) = [];
        UpDatedList = char(CurrentList);
        display(UpDatedList);
        GuIformat.Experiments(selected,:) = [];
        set(GuIformat.ExperimentTab(6),'String','');
        if selected == 1
            set(GuIformat.ExperimentTab(10),'Value',1);
        else
            set(GuIformat.ExperimentTab(10),'Value',selected - 1);
            set(GuIformat.ChamberSelect(:,:,1),'Value',selected - 1);
        end
        if isempty(UpDatedList)
            set(GuIformat.ExperimentTab(10),'String','Blank Experiment');
            set(GuIformat.ChamberSelect(:,:,1),'String','Blank Experiment');
        else
            set(GuIformat.ExperimentTab(10),'String',UpDatedList);
            set(GuIformat.ChamberSelect(:,:,1),'String',UpDatedList);
        end
    end
GuIformat.ExperimentTab(10) = uicontrol(ExperimentTab,...
    'Units','normalized',...
    'Style','listbox',...
    'String','Blank Condition',...
    'Position',[.72 .05 .28 .9],...
    'HandleVisibility','off',...
    'Callback',@ExperimentBox_LBCallback);
    function ExperimentBox_LBCallback(hObject,callbackdata)
        selected = get(hObject,'Value');
        TreatmentList = cellstr(get(GuIformat.ExperimentTab(1),'String'));
        TreatmentComposure = GuIformat.Experiments{selected,2};
        TreatmentSet = cellstr(TreatmentList(TreatmentComposure));
        set(GuIformat.ExperimentTab(6),'String',TreatmentSet);
        set(GuIformat.ExperimentTab(6),'Value',1);
        
    end
GuIformat.ExperimentTab(11) = uicontrol(ExperimentTab,...
    'Units','normalized',...
    'Style','edit',...
    'String','Experiment Name',...
    'Position',[.72 0 .28 .05],...
    'HandleVisibility','off',...
        'Callback',@ExperimentName_EDTCallback);
    function ExperimentName_EDTCallback(hObject,callbackdata)
        selected = get(GuIformat.ExperimentTab(10),'Value');
        currentlist = cellstr(get(GuIformat.ExperimentTab(10),'String'));
        display(currentlist);
        input = get(GuIformat.ExperimentTab(11),'String');
        currentlist{selected} = input;
        currentlist = currentlist;
        GuIformat.Experiments{selected,1} = input;
        set(GuIformat.ExperimentTab(10),'String',currentlist);
        set(GuIformat.ChamberSelect(:,:,1),'String',currentlist);
    end

%% Chamber Selection Tab

ChamberSelectTab = uitab(GUITabs,'Title','Chamber Selection');

ChambersBox = uipanel(ChamberSelectTab,...
    'Units','normalized',...
    'Position',[0 0 1 1],...
    'HandleVisibility','off');

for i = 1:4
    for j = 1:12
        GuIformat.ChamberSelect(i,j,1) = uicontrol(ChambersBox,...
            'Units','normalized',...
            'Style','popupmenu',...
            'UserData',[13-j,i],...
            'String',get(GuIformat.ExperimentTab(10),'String'),...
            'Position',[(1/4)*(i-1) (1/12)*(j-1) (3/16) (1/24)],...
            'HandleVisibility','off',...
            'Visible','Off',...
            'Callback',@ChamberSelect_PUMCallback);
        GuIformat.ChamberSelect(i,j,2) = uicontrol(ChambersBox,...
            'Units','normalized',...
            'Style','checkbox',...
            'UserData',[13-j,i],...
            'String',strcat(GuIformat.RowS{1}(5-i),num2str(13-j)),...
            'Position',[(1/4)*(i-1) (1/12)*(j-1/2) (1/4) (1/36)],...
            'HandleVisibility','off',...
            'Callback',@ChamberSelect_CBCallback);
    end
end

    function ChamberSelect_PUMCallback(hObject,callbackdata)
        selection = get(hObject,'Value');
        Chamber = get(hObject,'Userdata');
        Column = Chamber(1);
        Row = Chamber(2);
        [X Y] = size(GuIformat.Experiments);
        for i = 1:X
            GuIformat.Experiments{i,3}(Row,Column) = 0;
        end
        GuIformat.Experiments{selection,3}(Row,Column) = 1;
        display(GuIformat.Experiments{selection,3});
    end

    function ChamberSelect_CBCallback(hObject,callbackdata)
        Chamber = get(hObject,'Userdata');
        display(Chamber);
        Column = Chamber(1);
        Row = Chamber(2);
        selection = get(GuIformat.ChamberSelect(Row,Column,1),'Value');
        if (get(hObject,'Value') == get(hObject,'Max'))
            set(GuIformat.ChamberSelect(Row,13-Column,1),'Visible','On');
            GuIformat.Experiments{1,3}(Row,Column) = 1;
            display(GuIformat.Experiments{selection,3});
        else
            set(GuIformat.ChamberSelect(Row,13-Column,1),'Visible','Off');
            [X Y] = size(GuIformat.Experiments);
            for i = 1:X
                GuIformat.Experiments{i,3}(Row,Column) = 0;
            end
            display(GuIformat.Experiments{selection,3});
        end
    end

%% Matrix Tab

% MatrixTab = uitab(GUITabs,'Title','Matrix View');
% 
% t = uitable(MatrixTab,'Data',zeros(20),...
%     'Units','normalized',...
%     'Position',[0 0 1 1]);

%% Advanced Tab
% AdvancedTab = uitab(GUITabs,'Title','Advanced');
% 
% AdvancedWarning = uipanel(AdvancedTab,...
%     'Visible','on',...
%     'Position',[0 .95 1 .04]);
% 
% AdvancedWarn = uicontrol(AdvancedWarning,...
%     'Units','normalized',...
%     'Style','text',...
%     'String','DO NOT USE ADVANCED SCRIPT EDITOR WITHOUT EXTENSIVE TRAINING.',...
%     'FontWeight','bold',...
%     'ForegroundColor','red',...
%     'Position',[0 0 1 1],...
%     'HandleVisibility','off');
% 
% AdvancedBox = uipanel(AdvancedTab,...
%     'Visible','on',...
%     'Position',[0 0 1 .96]);
% 
% GuIformat.ScriptHandling(7) = uicontrol(AdvancedBox,...
%     'Units','normalized',...
%     'Style','edit',...
%     'String',GuIformat.AdvancedScript,...
%     'HorizontalAlignment','left',...
%     'Position',[0 0 1 1],...
%     'HandleVisibility','off',...
%     'Callback',@AdvancedTab_EDITCallback);
% set(GuIformat.ScriptHandling(7),'Max',1000000);
end

function PumpPanel(hObject,eventdata,handles)

global vc chipdata GuIformat;

PumpPanel = uipanel('Visible','on',...
    'Position',[.85 GuIformat.Vert2 .15 .2],...
    'Title','Pump Control');

%% Basic Pump Button Group
pumpcolumns = 4
pumprows = 4

GuIformat.Pump(1) = uicontrol(PumpPanel,...
    'Units','normalized',...
    'Style','togglebutton',...
    'String','Open',...
    'BackgroundColor',GuIformat.color.c,...
    'Position',[0/pumpcolumns 2/pumprows 1/pumpcolumns 2/pumprows],...
    'Callback',@TogglePump_PBCallback);
    function TogglePump_PBCallback(hObject,callbackdata)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            set(hObject,'String','Open')
            CLOSE_VALVES([17,33,34,35])
            set(hObject, 'BackgroundColor',GuIformat.color.c);
        end
        if button_state == get(hObject,'Min')
            set(hObject,'String','Close')
            OPEN_VALVES([17,33,34,35])
            set(hObject, 'BackgroundColor',GuIformat.color.o);
        end
    end
GuIformat.Pump(2) = uicontrol(PumpPanel,...
    'Units','normalized',...
    'Style','togglebutton',...
    'String','Run',...
    'BackgroundColor',GuIformat.color.c,...
    'Position',[1/pumpcolumns 2/pumprows 1/pumpcolumns 2/pumprows],...
    'Callback',@RunPump_PBCallback);
    function RunPump_PBCallback(hObject,callbackdata)
        Interval = str2num(get(GuIformat.Pump(4),'String'))
        Cycles = str2num(get(GuIformat.Pump(6),'String'))
        button_state = get(hObject,'Value')
        display(get(hObject,'Max'))
        if button_state == get(hObject,'Min')
            set(hObject,'String','Run')
            set(hObject,'Value',get(hObject,'Max'))
            set(hObject, 'BackgroundColor',GuIformat.color.c);
            GuIformat.STOP = 1;
        end
        if button_state == get(hObject,'Max')
            set(hObject,'String','Stop')
            valvesnum = str2num(get(GuIformat.Pump(8),'String'))
            for i = 10:2:14
                valvesnum = [valvesnum, str2num(get(GuIformat.Pump(i),'String'))]
            end
            GuIformat.STOP = 0;
            set(hObject, 'BackgroundColor',GuIformat.color.o);
            Pump(Cycles,Interval,valvesnum)
            set(hObject,'Value',get(hObject,'Min'))
            set(hObject,'String','Run')
            set(hObject, 'BackgroundColor',GuIformat.color.c);
        end
    end
GuIformat.Pump(3) = uicontrol(PumpPanel,...
    'Units','normalized',...
    'Style','togglebutton',...
    'String','Reverse',...
    'BackgroundColor',GuIformat.color.c,...
    'Position',[2/pumpcolumns 2/pumprows 1/pumpcolumns 2/pumprows],...
    'Callback',@Reverse_PumpPBCallback);
    function Reverse_PumpPBCallback(hObject,callbackdata)
        Interval = str2num(get(GuIformat.Pump(4),'String'))
        Cycles = str2num(get(GuIformat.Pump(6),'String'))
        button_state = get(hObject,'Value')
        display(get(hObject,'Max'))
        if button_state == get(hObject,'Min')
            if GuIformat.CurrentLigand ~= 0;
                LIGAND_Callback(GuIformat.CurrentLigand);
            end
            CLOSE_VALVES([17,33,34,35,16,32])
            set(GuIformat.QWH(1+4), 'BackgroundColor',GuIformat.color.c);
            set(GuIformat.QWH(2+4), 'BackgroundColor',GuIformat.color.c);
            set(hObject,'String','Reverse')
            set(hObject,'Value',get(hObject,'Max'))
            set(hObject, 'BackgroundColor',GuIformat.color.c);
            GuIformat.STOP = 1;
        end
        if button_state == get(hObject,'Max')
            set(hObject,'String','Stop')
            valvesnum = str2num(get(GuIformat.Pump(8),'String'))
            for i = 10:2:14
                valvesnum = [str2num(get(GuIformat.Pump(i),'String')), valvesnum]
            end
            if valvesnum == [17,35,34,33]
                if GuIformat.CurrentLigand ~= 0;
                    LIGAND_Callback(GuIformat.CurrentLigand);
                end
                OPEN_VALVES([17,33,34,35,16,32])
                set(GuIformat.QWH(1+4), 'BackgroundColor',GuIformat.color.o);
                set(GuIformat.QWH(2+4), 'BackgroundColor',GuIformat.color.o);
            end
            GuIformat.STOP = 0;
            set(hObject, 'BackgroundColor',GuIformat.color.o);
            Pump(Cycles,Interval,valvesnum)
            set(hObject,'Value',get(hObject,'Min'))
            set(hObject,'String','Reverse')
            set(hObject, 'BackgroundColor',GuIformat.color.c);
            if GuIformat.CurrentLigand ~= 0 && GuIformat.STOP == 0;
                LIGAND_Callback(GuIformat.CurrentLigand);
            end
            CLOSE_VALVES([17,33,34,35,16,32])
            set(GuIformat.QWH(1+4), 'BackgroundColor',GuIformat.color.c);
            set(GuIformat.QWH(2+4), 'BackgroundColor',GuIformat.color.c);
        end
    end
GuIformat.Pump(4) = uicontrol(PumpPanel,...
    'Units','normalized',...
    'Style','edit',...
    'String','.05',...
    'Tag','CommandLine',...
    'Position',[3/pumpcolumns 3/pumprows 1/pumpcolumns 1/pumprows],...
    'HandleVisibility','off');
GuIformat.Pump(6) = uicontrol(PumpPanel,...
    'Units','normalized',...
    'Style','edit',...
    'String','50',...
    'Tag','CommandLine',...
    'Position',[3/pumpcolumns 2/pumprows 1/pumpcolumns 1/pumprows],...
    'HandleVisibility','off');

%% Advanced Pump Button Group

GuIformat.Pump(7) = uicontrol(PumpPanel,...
    'Units','normalized',...
    'Style','Text',...
    'String','Valve 1',...
    'Value',1,...
    'Tag','CommandLine',...
    'Position',[0/pumpcolumns 1/pumprows 1/pumpcolumns 1/pumprows],...
    'HandleVisibility','off');
GuIformat.Pump(8) = uicontrol(PumpPanel,...
    'Units','normalized',...
    'Style','edit',...
    'String','33',...
    'Tag','CommandLine',...
    'Position',[0/pumpcolumns 0/pumprows 1/pumpcolumns 1/pumprows],...
    'HandleVisibility','off');
GuIformat.Pump(9) = uicontrol(PumpPanel,...
    'Units','normalized',...
    'Style','Text',...
    'String','Valve 2',...
    'Value',1,...
    'Tag','CommandLine',...
    'Position',[1/pumpcolumns 1/pumprows 1/pumpcolumns 1/pumprows],...
    'HandleVisibility','off');
GuIformat.Pump(10) = uicontrol(PumpPanel,...
    'Units','normalized',...
    'Style','edit',...
    'String','34',...
    'Tag','CommandLine',...
    'Position',[1/pumpcolumns 0/pumprows 1/pumpcolumns 1/pumprows],...
    'HandleVisibility','off');
GuIformat.Pump(11) = uicontrol(PumpPanel,...
    'Units','normalized',...
    'Style','Text',...
    'String','Valve 3',...
    'Value',1,...
    'Tag','CommandLine',...
    'Position',[2/pumpcolumns 1/pumprows 1/pumpcolumns 1/pumprows],...
    'HandleVisibility','off');
GuIformat.Pump(12) = uicontrol(PumpPanel,...
    'Units','normalized',...
    'Style','edit',...
    'String','35',...
    'Tag','CommandLine',...
    'Position',[2/pumpcolumns 0/pumprows 1/pumpcolumns 1/pumprows],...
    'HandleVisibility','off');
GuIformat.Pump(13) = uicontrol(PumpPanel,...
    'Units','normalized',...
    'Style','checkbox',...
    'String','Valve 4',...
    'Value',1,...
    'Tag','CommandLine',...
    'Position',[3/pumpcolumns 1/pumprows 1/pumpcolumns 1/pumprows],...
    'HandleVisibility','off');
GuIformat.Pump(14) = uicontrol(PumpPanel,...
    'Units','normalized',...
    'Style','edit',...
    'String','17',...
    'Tag','CommandLine',...
    'Position',[3/pumpcolumns 0/pumprows 1/pumpcolumns 1/pumprows],...
    'HandleVisibility','off');

end

function CommandLinePanel(hObject,eventdata,handles)

global vc chipdata GuIformat;

Control = uibuttongroup('Visible','on',...
    'Position',[0 0 .5 .05],...
    'Title','Coding Control');

%% Button Group

GuIformat.Command(1) = uicontrol(Control,...
    'Units','normalized',...
    'Style','edit',...
    'String','Command Line',...
    'Tag','CommandLine',...
    'Position',[0 1/2 3/4 1/2],...
    'HandleVisibility','off');
GuIformat.Command(2) = uicontrol(Control,...
    'Units','normalized',...
    'Style','pushbutton',...
    'String','Execute Command',...
    'Position',[3/4 1/2 1/4 1/2],...
    'HandleVisibility','off');
GuIformat.Command(3) = uicontrol(Control,...
    'Units','normalized',...
    'Style','text',...
    'String','',...
    'Position',[0 0 1 1/2],...
    'HandleVisibility','off');

end

%% TOGGLE BUTTON FUNCTIONALITY

function CLOSE_VALVES(NUMBERS)% ***MANUALLY*** % ***MANUALLY*** % ***MANUALLY***
global vc chipdata GuIformat;
for i = NUMBERS
    set(GuIformat.DirCon(i+1), 'BackgroundColor',GuIformat.color.c);
end

if GuIformat.DEBUGMODE == 0
    values =  zeros(1,length(NUMBERS));
    b=size(NUMBERS,2);
    vc = vc_set_bits_ac(vc, NUMBERS, values);
    clear vc chipdata
end
end

function OPEN_VALVES(NUMBERS)% ***MANUALLY*** % ***MANUALLY*** % ***MANUALLY***
global vc chipdata GuIformat;
values =  ones(1,length(NUMBERS));
for i = NUMBERS
    set(GuIformat.DirCon(i+1), 'BackgroundColor',GuIformat.color.o);
end

if GuIformat.DEBUGMODE == 0
    b=size(NUMBERS,2);
    vc = vc_set_bits_ac(vc, NUMBERS, values);
    clear vc chipdata
end
end

function togglebutton_Callback(hObject,callbackdata)
% hObject    handle to togglebutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of togglebutton1
global vc chipdata GuIformat;

button_state = get(hObject,'Value');
NUMBERS = get(hObject,'UserData');
if button_state == get(hObject,'Max')
    set(GuIformat.Command(3),'String',strcat({'Valve '},num2str(NUMBERS),{' opened'}));
    set(hObject, 'BackgroundColor',GuIformat.color.o);
    for i = NUMBERS
        set(GuIformat.DirCon(i+1), 'BackgroundColor',GuIformat.color.o);
    end
    OPEN_VALVES(NUMBERS);
elseif button_state == get(hObject,'Min')
    set(GuIformat.Command(3),'String',strcat({'Valve '},num2str(NUMBERS),{' closed'}));
    set(hObject, 'BackgroundColor',GuIformat.color.c);
    for i = NUMBERS
        set(GuIformat.DirCon(i+1), 'BackgroundColor',GuIformat.color.c);
    end
    CLOSE_VALVES(NUMBERS);
end
end

%% LIGAND RECORDING FUNCTIONS

function LigandX_Callback(hObject,callbackdata)
global vc chipdata GuIformat
NUMBER = get(hObject,'UserData');


if chipdata.Ligands(NUMBER)== 0
    GuIformat.CurrentLigand = NUMBER;
    set(hObject, 'BackgroundColor',GuIformat.color.o);
    chipdata.Ligands(NUMBER) = 1;
    values =  chipdata.LigandValueMatrix(NUMBER,:);
    b=size(chipdata.LigandValves,2);
    if GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, chipdata.LigandValves, values);
    end
    for i = 1:8
        if values(i) == 0
            set(GuIformat.DirCon(i), 'BackgroundColor',GuIformat.color.c);
        else
            set(GuIformat.DirCon(i), 'BackgroundColor',GuIformat.color.o);
        end
    end
else
    GuIformat.CurrentLigand = 0;
    set(hObject, 'BackgroundColor',GuIformat.color.c);
    chipdata.Ligands(NUMBER) = 0;
    values= [0 0 0 0 0 0 0 0];
    b=size(chipdata.LigandValves,2);
    if GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, chipdata.LigandValves, values);
    end
    for i = 1:8
        if values(i) == 0
            set(GuIformat.DirCon(i), 'BackgroundColor',GuIformat.color.c);
        else
            set(GuIformat.DirCon(i), 'BackgroundColor',GuIformat.color.o);
        end
    end
end
end

function LIGAND_Callback(NUMBER)
global vc chipdata GuIformat

    if chipdata.Ligands(NUMBER)== 0
        chipdata.Ligands(NUMBER) = 1;
            set(GuIformat.LigCon(NUMBER,1), 'BackgroundColor',GuIformat.color.o);
        values =  chipdata.LigandValueMatrix(NUMBER,:);
        b=size(chipdata.LigandValves,2);
        if GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, chipdata.LigandValves, values);
        end
    else
        chipdata.Ligands(NUMBER) = 0;
            set(GuIformat.LigCon(NUMBER,1), 'BackgroundColor',GuIformat.color.c);
        values= [0 0 0 0 0 0 0 0];
        b=size(chipdata.LigandValves,2);
        if GuIformat.DEBUGMODE == 0
        vc = vc_set_bits_ac(vc, chipdata.LigandValves, values);
        end
    end

        for i = 1:8
        if values(i) == 0
            set(GuIformat.DirCon(i), 'BackgroundColor',GuIformat.color.c);
        else
            set(GuIformat.DirCon(i), 'BackgroundColor',GuIformat.color.o);
        end
        end
end

%% CHIP PREP INPUT MANAGEMENT

function ChipPrepCB_Callback(hObject, callbackdata)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1
global vc chipdata GuIformat

cmpnnt = get(hObject,'String');
ind = find(ismember(GuIformat.CBs1,cmpnnt));

if (get(hObject,'Value') == get(hObject,'Max'))
    GuIformat.CBs2(ind) = 1;
    display(strcat(cmpnnt,{' on'}));
else
    GuIformat.CBs2(ind) = 0;
    display(strcat(cmpnnt,{' off'}));
end

end

function ChipPrepPUM_Callback(hObject, callbackdata)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns contents...
%        contents{get(hObject,'Value')} returns selected item...

global vc chipdata GuIformat

set(hObject,'String',GuIformat.LigandNames);
cmpnnt = get(hObject,'UserData');
items = get(hObject,'String');
index_selected = get(hObject,'Value');
item_selected = items{index_selected};

ind = find(ismember(GuIformat.PUMs1,cmpnnt));

GuIformat.PUMs2(ind) = index_selected;

end

function ChipPrepTimeEditBox_Callback(hObject, callbackdata)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents as double

global vc chipdata GuIformat

cmpnnt = get(hObject,'UserData');
ind = find(ismember(GuIformat.PrepTimes1,cmpnnt));
Time = str2double(get(hObject,'String'));

GuIformat.PrepTimes2(ind) = Time;

end

%% CHIP PREP HANDLING

function DWCStart_PBCallback(hObject, callbackdata)

global vc chipdata GuIformat

WashSTT = GuIformat.CBs2(3);
SoapSTT = GuIformat.CBs2(2);
CoatSTT = GuIformat.CBs2(1);
WashTM = GuIformat.PrepTimes2(3);
SoapTM = GuIformat.PrepTimes2(2);
CoatTM = GuIformat.PrepTimes2(1);
WashSRC = GuIformat.PUMs2(3);
SoapSRC = GuIformat.PUMs2(2);
CoatSRC = GuIformat.PUMs2(1);
SRCS = [WashSRC, SoapSRC, CoatSRC];

GuIformat.STOP = 0;
GuIformat.PAUSE = 0;
if GuIformat.DEBUGMODE == 0
    if WashSTT == 1 && GuIformat.STOP == 0
        liganddegas(WashSRC,32,60,180);
        for i = [chipdata.Channel1In,chipdata.Channel2In]
            channeltreat(WashSRC,[i,42],30,WashTM);
        end
        degascomponent(WashSRC,[chipdata.Channel1In,chipdata.Channel2In,42],600);
    end
    
    if SoapSTT == 1 && GuIformat.STOP == 0
        liganddegas(SoapSRC,32,60,180);
        for i = [chipdata.Channel1In,chipdata.Channel2In]
            channeltreat(SoapSRC,[i,42],30,SoapTM/8);
        end
    end
    
    if WashSTT == 1 && GuIformat.STOP == 0
        for i = [chipdata.Channel1In,chipdata.Channel2In]
            channeltreat(WashSRC,[i,42],30,WashTM);
        end
    end
    
    if CoatSTT == 1 && GuIformat.STOP == 0
        liganddegas(CoatSRC,32,60,180);
        for i = [chipdata.Channel1In]
            channeltreat(CoatSRC,[i,42],30,60);
            for j = [18:29]
                for q = [12:14]
                    chambertreat(CoatSRC,i,j,q,30,10);
                end
            end
        end
        degascomponent(CoatSRC,[chipdata.Channel1In,chipdata.Channel2In,18:29,42],600);
    end
    
    if WashSTT == 1 && GuIformat.STOP == 0
        for i = [chipdata.Channel1In,chipdata.Channel2In]
            channeltreat(WashSRC,[i,42],30,WashTM);
        end
    end
    
    if CoatSTT == 1 && GuIformat.STOP == 0
        count = 0;
        while count <= CoatTM && GuIformat.STOP == 0
            PAUSEchk;
            pause(.5)
            count = count + .5;
        end
    end
    
    if WashSTT == 1 && GuIformat.STOP == 0
        for i = [chipdata.Channel1In]
            channeltreat(WashSRC,[i,42],30,WashTM);
            for j = [18:29]
                for q = [12:14]
                    chambertreat(WashSRC,i,j,q,30,15);
                end
            end
        end
    end
    
else
    for i = 1:20
        if GuIformat.STOP == 0
            pause(.5)
            display('Prep Cycle Running');
            PAUSEchk;
        end
    end
end
GuIformat.STOP = 1;
GuIformat.PAUSE = 0;
end

function DWCStop_PBCallback(hObject, callbackdata)

global vc chipdata GuIformat
GuIformat.STOP = 1;
display('Prep Cycle Stopped');

end

function DWCPause_PBCallback(hObject, callbackdata)

global vc chipdata GuIformat

if GuIformat.STOP == 0
    if GuIformat.PAUSE == 1
        GuIformat.PAUSE = 0;
        display('Prep Cycle started again');
    elseif GuIformat.PAUSE == 0
        GuIformat.PAUSE = 1;
        display('Prep Cycle paused');
    end
end

end

function PAUSEchk()

global vc chipdata GuIformat

while GuIformat.PAUSE == 1
    pause(.5);
end

end

function chambertreat(LIGAND,ROW,COLUMN,COMPONENT,WASTE,CHTIME)
global vc chipdata GuIformat
PAUSEchk;
LIGAND_Callback(LIGAND);
if GuIformat.STOP == 0
    OPEN_VALVES([17,33,34,35,WASTE]);
    pause(.5);
end
if GuIformat.STOP == 0
    count = 0;
    OPEN_VALVES([ROW,COLUMN,COMPONENT]);
    while count <= CHTIME && GuIformat.STOP == 0
        PAUSEchk;
        pause(.5);
        count = count + .5;
    end
    CLOSE_VALVES([ROW,COLUMN,COMPONENT]);
end
CLOSE_VALVES(8:47);
LIGAND_Callback(LIGAND);
end

function degascomponent(LIGAND,VALVES,DGTIME)
global vc chipdata GuIformat
PAUSEchk;
LIGAND_Callback(LIGAND);
OPEN_VALVES([17,33,34,35,VALVES]);
count = 0;
while GuIformat.STOP == 0 && count <= DGTIME
    PAUSEchk;
    pause(.5)
    count = count + .5;
end
PAUSEchk;
CLOSE_VALVES([17,33,34,35,VALVES]);
LIGAND_Callback(LIGAND);
end

function channeltreat(LIGAND,CHANNEL,WASTE,CHTIME)
global vc chipdata GuIformat
PAUSEchk;
LIGAND_Callback(LIGAND);
OPEN_VALVES([17,33,34,35,42,WASTE]);
count = 0;
OPEN_VALVES(CHANNEL);
while GuIformat.STOP == 0 && count <= CHTIME
    PAUSEchk;
    pause(.5)
    count = count + .5;
end
PAUSEchk;
CLOSE_VALVES(CHANNEL);
CLOSE_VALVES([17,33,34,35,42,WASTE]);
LIGAND_Callback(LIGAND);
end

function liganddegas(LIGAND,QDUMP,FLTIME,DGTIME)
global vc chipdata GuIformat
PAUSEchk;
LIGAND_Callback(LIGAND);
PAUSEchk;
OPEN_VALVES(QDUMP);
count = 0;
while GuIformat.STOP == 0 && count <= FLTIME
    PAUSEchk;
    pause(.5)
    count = count + .5;
end
PAUSEchk;
CLOSE_VALVES(QDUMP);
count = 0;
while GuIformat.STOP == 0 && count <= DGTIME
    PAUSEchk;
    pause(.5)
    count = count + .5;
end
PAUSEchk;
LIGAND_Callback(LIGAND);
end

%% SCRIPTING TOP BAR CALLBACKS

function ScriptFileInterpret()

global vc chipdata GuIformat;


%% Retrieve Vars
StepName =     GuIformat.ScriptData.StepName; % STEP NAME
InputNumber =   GuIformat.ScriptData.InputNumber; % INPUT NUMBER
QuickDumpState =    GuIformat.ScriptData.QuickDumpState; % USE QUICKDUMP? YES(1) NO(0)
QuickDumpNum =     GuIformat.ScriptData.QuickDumpNum; % WHICH QUICKDUMP? 1 OR 2
QuickDumpTime =   GuIformat.ScriptData.QuickDumpTime; % TIME THROUGH QUICKDUMP? (SECONDS)
UpChannelFlush =       GuIformat.ScriptData.UpChannelFlush; % FLUSH UPPER CHANNELS? YES(1) NO(0)
DownChannelFlush =     GuIformat.ScriptData.DownChannelFlush; % FLUSH LOWER CHANNELS? YES(1) NO(0)
PumpState =      GuIformat.ScriptData.PumpState; % USE PUMP? YES(1) NO(0)
ChannelFlushTime =     GuIformat.ScriptData.ChannelFlush; % TIME THROUGH UPPER AND LOWER CHANNELS (SECONDS)
LeftRight =    GuIformat.ScriptData.LeftRight; % FLUSH THROUGH LEFT OR RIGHT CHAMBER SIDECHANNEL? LEFT(1) RIGHT(2) BOTH([1,2])
ChamberRow =    GuIformat.ScriptData.ChamberRow; % WHICH ROW OF CHAMBERS TO ADDRESS? 1,2,3,4
ChamberColumn =    GuIformat.ScriptData.ChamberColumn; % WHICH COLUMN OF CHAMBERS TO ADDRESS? 1,2,3,4,5,6,7,8,9,10,11,12
FeedTime =    GuIformat.ScriptData.FeedTime; % TIME TO FLUSH EACH CHAMBER SIDECHANNEL? (SECONDS)
WasteState =     GuIformat.ScriptData.WasteState; % WASTE OPEN OR CLOSED? OPEN(1) CLOSED(0)
WasteNum =    GuIformat.ScriptData.WasteNum; % WHICH WASTE TO USE? 1 OR 2
RepIncTime =    GuIformat.ScriptData.RepIncTime; % DURATION TO WAIT AFTER REPETITION COMPLETION? (SECONDS)
Repetitions = GuIformat.ScriptData.Repetitions; % TOTAL STEP REPETITIONS?
StepIncTime = GuIformat.ScriptData.StepIncTime; % DURATION TO WAIT AFTER STEP COMPLETION? (SECONDS)
vals = GuIformat.ScriptData.vals;


%% Run script using variables
for i = vals
    for z = 1:Repetitions{i}
        if chipdata.CultureStop == 1;
            CLOSE_VALVES(0:47,hObject, eventdata,handles)
            LigandX_Callback(InputNumber{i},hObject, eventdata, handles)
            %%%%%%%%%%%%%%%%% QUICKDUMP STEP
            if chipdata.CultureStop == 1;
                if QuickDumpState{i} == 1
                    if QuickDumpNum{i} == 1
                        OPEN_VALVES(32,hObject, eventdata, handles)
                    elseif QuickDumpNum{i} == 2
                        OPEN_VALVES(16,hObject, eventdata, handles)
                    end
                    count = 0
                    while count < QuickDumpTime{i} && chipdata.CultureStop == 1
                        pause(.1)
                        count = count + .1
                    end
                    CLOSE_VALVES([16,32],hObject,eventdata,handles)
                else
                    CLOSE_VALVES([16,32],hObject,eventdata,handles)
                end
                %%%%%%%%%%%%%%%%% CHANNEL FLUSH STEP
                if chipdata.CultureStop == 1;
                    OPEN_VALVES([17,33:35],hObject, eventdata, handles)
                    if UpChannelFlush{i} == 1
                        OPEN_VALVES([chipdata.Channel1In(ChamberRow{i}),42],hObject, eventdata, handles)
                    end
                    if DownChannelFlush{i} == 1
                        OPEN_VALVES(chipdata.Channel2In(ChamberRow{i}),hObject, eventdata, handles)
                    end
                    if WasteState{i} == 1
                        OPEN_VALVES(chipdata.Waste(WasteState{i}),hObject, eventdata, handles)
                    end
                    count = 0
                    while count < ChannelFlushTime{i} && chipdata.CultureStop == 1
                        pause(.1)
                        count = count + .1
                    end
                    CLOSE_VALVES([8:29,31:42],hObject,eventdata,handles)
                    %%%%%%%%%%%%%% CHAMBER FLUSH
                    
                    
                    for k = ChamberColumn{i}
                        for q = ChamberRow{i}
                            for h = 1:length(LeftRight{i})
                                if chipdata.CultureStop == 1;
                                    OPEN_VALVES(chipdata.Columns(k),hObject, eventdata, handles)
                                    OPEN_VALVES(chipdata.Channel1In(q),hObject, eventdata, handles)
                                    OPEN_VALVES(chipdata.SOURCE(LeftRight{i}(h)),hObject, eventdata, handles)
                                    OPEN_VALVES([17,33:35],hObject, eventdata, handles)
                                    count = 0
                                    while count <= FeedTime{i} && chipdata.CultureStop == 1
                                        pause(.1)
                                        count = count + .1
                                    end
                                    CLOSE_VALVES(chipdata.Columns(k),hObject, eventdata, handles)
                                    CLOSE_VALVES(chipdata.Channel1In(q),hObject, eventdata, handles)
                                    CLOSE_VALVES(chipdata.SOURCE(LeftRight{i}(h)),hObject, eventdata, handles)
                                    CLOSE_VALVES([17,33:35],hObject, eventdata, handles)
                                end
                            end
                        end
                    end
                    %%%%%%%%%%%%%%% INCUBATE
                    CLOSE_VALVES([0:47],hObject, eventdata, handles)
                    if chipdata.CultureStop == 1;
                        count = 0
                        while count < RepIncTime{i} && chipdata.CultureStop == 1
                            pause(.1)
                            count = count + .1
                        end
                    end
                end
            end
        end
        CLOSE_VALVES([0:47],hObject, eventdata, handles)
    end
    CLOSE_VALVES(0:47,hObject, eventdata,handles)
    count = 0
    while count < StepIncTime{i} && chipdata.CultureStop  == 1
        pause(.1)
        count = count + .1
    end
end


end

%% ADVANCED SCRIPTING CALLBACKS

function AdvancedTab_EDITCallback(hObject,callbackdata)

global vc chipdata GuIformat;

GuIformat.AdvancedScript = get(hObject,'String');

display(GuIformat.AdvancedScript);

end

function SaveExp_EditCallback(hObject,callbackdata)

global vc chipdata GuIformat;

GuIformat.NewScriptName = get(hObject,'UserData');

end

function SaveExp_PBCallback(hObject,callbackdata)

%Write values to structured file

end

%% COMMAND LINE FUNCTIONALITY

function UserCommand_Callback(hObject,handles)
UserCommand = get(hObject.Tag,'String');
assignin('base','UserCommand',UserCommand)
end

function ExecuteCommand_Callback(hObject,handles)
set(handles.CommandOut, 'String', UserCommand);
end

% --- Executes during object creation, after setting all properties.

function UserCommand_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
end

%% SCRIPT INTERPRETER

function RUNTREATMENTVectorFormat(StepName,InputNumber,QuickDumpState,QuickDumpNum,QuickDumpTime,UpChannelFlush,DownChannelFlush,ChannelFlushTime,PumpState,PumpCycle,PumpInt,UpDown,LeftRight,ChamberRow,ChamberColumn,FeedTime,WasteState,WasteNum)
global GuIformat chipdata vc
%%%%%%%%%%%%%%%%% QUICKDUMP STEP

LIGAND_Callback(InputNumber);

if WasteState == 1 && GuIformat.STOP == 0
    OPEN_VALVES(chipdata.Waste(WasteNum));
end

if QuickDumpState == 1 && GuIformat.STOP == 0
    OPEN_VALVES(chipdata.QuickDamp(QuickDumpNum));
    count = 0;
    while count < QuickDumpTime && GuIformat.STOP == 0
        PAUSEchk
        pause(.5)
        count = count + .5
    end
    CLOSE_VALVES(chipdata.QuickDamp(QuickDumpNum))
end

%%%%%%%%%%%%%%%%% CHANNEL FLUSH STEP

for q = ChamberRow
    if GuIformat.STOP == 0;
        OPEN_VALVES([17,33:35]);
        if UpChannelFlush == 1 && GuIformat.STOP == 0
            OPEN_VALVES([chipdata.Channel1In(q),43]);
        end
        if DownChannelFlush == 1 && GuIformat.STOP == 0
            OPEN_VALVES([chipdata.Channel2In(q),42]);
        end
        count = 0
        while count < ChannelFlushTime && GuIformat.STOP == 0
            PAUSEchk
            pause(.5)
            count = count + .5
        end
        if UpChannelFlush == 1
            CLOSE_VALVES([chipdata.Channel1In(q),43])
        end
        if DownChannelFlush == 1
            CLOSE_VALVES([chipdata.Channel2In(q),42])
        end
        CLOSE_VALVES([17,33:35])
    end
end

%%%%%%%%%%%%%% CHAMBER FLUSH
for q = ChamberRow
    if GuIformat.STOP == 0;
        if UpDown == 1
            OPEN_VALVES([chipdata.Channel1In(q),42])
        else
            OPEN_VALVES([chipdata.Channel2In(q),43])
        end
        for h = LeftRight
            OPEN_VALVES(chipdata.SOURCE(h))
            for k = ChamberColumn
                if GuIformat.STOP == 0;
                    OPEN_VALVES(chipdata.Columns(k))
                    set(GuIformat.Cham(k,5-q),'BackgroundColor',GuIformat.color.o)
                    if PumpState == 1 && GuIformat.STOP == 0
                        Pump(PumpCycle,PumpInt)
                    else
                        OPEN_VALVES([17,33:35])
                        count = 0
                        while count <= FeedTime && GuIformat.STOP == 0
                            PAUSEchk
                            pause(.5)
                            count = count + .5
                        end
                        CLOSE_VALVES([17,33:35])
                    end
                    CLOSE_VALVES(chipdata.Columns(k))
                    set(GuIformat.Cham(k,5-q),'BackgroundColor',GuIformat.color.c)
                end
            end
            CLOSE_VALVES(chipdata.SOURCE(h))
        end
        if UpDown == 1
            CLOSE_VALVES([chipdata.Channel1In(q),42])
        else
            CLOSE_VALVES([chipdata.Channel2In(q),43])
        end
    end
end

if WasteState == 1 && GuIformat.STOP == 0
    OPEN_VALVES(chipdata.Waste(WasteNum))
end

LIGAND_Callback(InputNumber)
end

function RUNTREATMENT(StepName,InputNumber,QuickDumpState,QuickDumpNum,QuickDumpTime,UpChannelFlush,DownChannelFlush,ChannelFlushTime,PumpState,PumpCycle,PumpInt,UpDown,LeftRight,Address,FeedTime,WasteState,WasteNum)
global GuIformat chipdata vc

TSMessage(strcat({':Experiment:'},GuIformat.slctdScript,{':Step:'},StepName,{':Started:'}),GuIformat.ScriptDir)

            if LeftRight == 1
                LeftRight = 0
            end
            if LeftRight == 2
                LeftRight = [1,2,3]
            end
            if LeftRight == 3
                LeftRight = [1,2]
            end
            if LeftRight == 4
                LeftRight = [3]
            end
            if LeftRight == 5
                LeftRight = [1]
            end
            if LeftRight == 6
                LeftRight = [2]
            end
%%%%%%%%%%%%%%%%% QUICKDUMP STEP


temprows = any(Address,2)
if sum(temprows) > 0
    TSMessage(strcat({':Experiment:'},GuIformat.slctdScript,{':Step:'},StepName,':Ligand:',num2str(InputNumber),{':Started:'}),GuIformat.ScriptDir)
LIGAND_Callback(InputNumber);
PAUSEchk
if WasteState == 1 && GuIformat.STOP == 0
    OPEN_VALVES(chipdata.Waste(WasteNum));
        set(GuIformat.QWH(WasteNum+2), 'BackgroundColor',GuIformat.color.o);
end

if QuickDumpState == 1 && GuIformat.STOP == 0
    OPEN_VALVES(chipdata.QuickDamp(QuickDumpNum));
    set(GuIformat.QWH(QuickDumpNum+4), 'BackgroundColor',GuIformat.color.o);
    count = 0;
    while count < QuickDumpTime && GuIformat.STOP == 0
        PAUSEchk
        pause(.5)
        count = count + .5
    end
    CLOSE_VALVES(chipdata.QuickDamp(QuickDumpNum))
        set(GuIformat.QWH(QuickDumpNum+4), 'BackgroundColor',GuIformat.color.c);
end




for q = 1:4
    PAUSEchk
    %%%%%%%%%%%%%%%%% CHANNEL FLUSH STEP


    if temprows(q) == 1 && GuIformat.STOP == 0;
            if temprows(q) == 1 && GuIformat.STOP == 0;
        OPEN_VALVES([17,33:35]);
        if UpChannelFlush == 1 && GuIformat.STOP == 0
            OPEN_VALVES([chipdata.Channel1In(q),43]);
            set(GuIformat.TBC(5-q,1), 'BackgroundColor',GuIformat.color.o);
        end
        if DownChannelFlush == 1 && GuIformat.STOP == 0
            OPEN_VALVES([chipdata.Channel2In(q),42]);
            set(GuIformat.TBC(5-q,2), 'BackgroundColor',GuIformat.color.o);
        end
        count = 0
        while count < ChannelFlushTime && GuIformat.STOP == 0
            PAUSEchk
            pause(.5)
            count = count + .5
        end
        if UpChannelFlush == 1
            CLOSE_VALVES([chipdata.Channel1In(q),43])
            set(GuIformat.TBC(5-q,1), 'BackgroundColor',GuIformat.color.c);
        end
        if DownChannelFlush == 1
            CLOSE_VALVES([chipdata.Channel2In(q),42])
            set(GuIformat.TBC(5-q,2), 'BackgroundColor',GuIformat.color.c);
        end
        CLOSE_VALVES([17,33:35])
        PAUSEchk
    end
    if UpDown == 1
        OPEN_VALVES([chipdata.Channel1In(q),42])
    else
        OPEN_VALVES([chipdata.Channel2In(q),43])
    end
    %%%%%%%%%%%%%% CHAMBER FLUSH
    for h = LeftRight
        if LeftRight ~= 0;
            if GuIformat.STOP == 0;
            LIGAND_Callback(InputNumber)
            OPEN_VALVES([42,16,32,17,33,34,35,chipdata.Channel2In(q)])
            set(GuIformat.Pump(1), 'BackgroundColor',GuIformat.color.o);
            set(GuIformat.TBC(5-q,1), 'BackgroundColor',GuIformat.color.o);
            set(GuIformat.QWH(5),'BackgroundColor',GuIformat.color.o);
            set(GuIformat.QWH(6),'BackgroundColor',GuIformat.color.o);
            pause(1)
            OPEN_VALVES(chipdata.SOURCE(h))
            set(GuIformat.ChComp(h), 'BackgroundColor',GuIformat.color.o);
            pause(1)
            CLOSE_VALVES([42,16,32,17,33,34,35,chipdata.Channel2In(q)])
            set(GuIformat.TBC(5-q,1), 'BackgroundColor',GuIformat.color.c);
            set(GuIformat.Pump(1), 'BackgroundColor',GuIformat.color.c);
            set(GuIformat.QWH(5),'BackgroundColor',GuIformat.color.c);
            set(GuIformat.QWH(6),'BackgroundColor',GuIformat.color.c);
            LIGAND_Callback(InputNumber)
            pause(1)
            end
            for k = 1:12
                if Address(q,k) == 1 && GuIformat.STOP == 0;
                    OPEN_VALVES(chipdata.Columns(k))
                    set(GuIformat.Cham(k,5-q),'BackgroundColor',GuIformat.color.o)
                    if PumpState == 1 && GuIformat.STOP == 0
                        TSMessage(strcat({':Experiment:'},GuIformat.slctdScript,{':Step:'},StepName,{':Side:'},num2str(chipdata.SOURCE(h)),{':Pump:'},num2str(GuIformat.Rows{q}),num2str(k),{':Started:'}),GuIformat.ScriptDir)
                        set(GuIformat.Pump(2),'BackgroundColor',GuIformat.color.o)
                        set(GuIformat.Pump(2),'String','Running')
                        Pump(PumpCycle,PumpInt,[33,34,35,17])
                        set(GuIformat.Pump(2),'BackgroundColor',GuIformat.color.c)
                        set(GuIformat.Pump(2),'String','Run')
                       TSMessage(strcat({':Experiment:'},GuIformat.slctdScript,{':Step:'},StepName,{':Side:'},num2str(chipdata.SOURCE(h)),{':Pump:'},num2str(GuIformat.Rows{q}),num2str(k),{':Ended:'}),GuIformat.ScriptDir)
                    else
                        chipdata.SOURCE(h)
                        GuIformat.Rows{q}
                        TSMessage(strcat({':Experiment:'},GuIformat.slctdScript,{':Step:'},StepName,{':Side:'},num2str(chipdata.SOURCE(h)),{':Flow:'},num2str(GuIformat.Rows{q}),num2str(k),{':Started:'}),GuIformat.ScriptDir)
                        OPEN_VALVES([17,33:35])
                        set(GuIformat.Pump(1),'BackgroundColor',GuIformat.color.o)
                        count = 0
                        while count <= FeedTime && GuIformat.STOP == 0
                            pause(.5)
                            count = count + .5
                        end
                        CLOSE_VALVES([17,33,34,35])
                        TSMessage(strcat({':Experiment:'},GuIformat.slctdScript,{':Step:'},StepName,{':Side:'},num2str(chipdata.SOURCE(h)),{':Flow:'},num2str(GuIformat.Rows{q}),num2str(k),{':Ended:'}),GuIformat.ScriptDir)
                        PAUSEchk
                        set(GuIformat.Pump(1),'BackgroundColor',GuIformat.color.c)
                    end
                    CLOSE_VALVES(chipdata.Columns(k))
                    set(GuIformat.Cham(k,5-q),'BackgroundColor',GuIformat.color.c)
                end
                
            end
        end
        CLOSE_VALVES(chipdata.SOURCE(h))
        set(GuIformat.ChComp(h), 'BackgroundColor',GuIformat.color.c);
    end
        if UpDown == 1
            CLOSE_VALVES([chipdata.Channel1In(q),42])
        else
            CLOSE_VALVES([chipdata.Channel2In(q),43])
        end
    end
end

    CLOSE_VALVES(chipdata.Waste(WasteNum))
    PAUSEchk
            set(GuIformat.QWH(WasteNum+2), 'BackgroundColor',GuIformat.color.c);

LIGAND_Callback(InputNumber)
TSMessage(strcat({':Experiment:'},GuIformat.slctdScript,{':Step:'},StepName,':Ligand:',num2str(InputNumber),{':Ended:'}),GuIformat.ScriptDir)
PAUSEchk
end
end

%% PUMP FUNCTION

function Pump(CYCLES,INTERVAL,VALVES)
% Left to Right 0100	0110	0010	0011	0001	1001
global vc chipdata GuIformat;
NUMVALVES = length(VALVES);
GuIformat.STOP = 0;
numbers = VALVES;
if NUMVALVES == 4
    i=0;
    while i < CYCLES && GuIformat.STOP == 0
        i=i+1;
        values =  [0, 1, 0, 0];
        if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
            vc = vc_set_bits_ac(vc, numbers, values);
        end
        pause(INTERVAL);
        pumpvis(numbers,values,4)
        % State 2
        values =  [0, 1, 1, 0];
        if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
            vc = vc_set_bits_ac(vc, numbers, values);
        end
        pause(INTERVAL);
        pumpvis(numbers,values,4)
        % State 3
        values =  [0, 0, 1, 0];
        if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
            vc = vc_set_bits_ac(vc, numbers, values);
        end
        pause(INTERVAL);
        pumpvis(numbers,values,4)
        % State 4
        values =  [0, 0, 1, 1];
        if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
            vc = vc_set_bits_ac(vc, numbers, values);
        end
        pause(INTERVAL);
        pumpvis(numbers,values,4)
        % State 5
        values =  [0, 0, 0, 1];
        if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
            vc = vc_set_bits_ac(vc, numbers, values);
            
            pause(INTERVAL);
        end
        pumpvis(numbers,values,4)
        % State 6
        values =  [1, 0, 0, 1];
        if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
            vc = vc_set_bits_ac(vc, numbers, values);
        end
        pause(INTERVAL);
        pumpvis(numbers,values,4)
        % State 7
        values =  [1, 0, 0, 0];
        if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
            vc = vc_set_bits_ac(vc, numbers, values);
        end
        pause(INTERVAL);
        pumpvis(numbers,values,4)
        % State 8
        values =  [1, 1, 0, 0];
        if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
            vc = vc_set_bits_ac(vc, numbers, values);
        end
        pause(INTERVAL);
        pumpvis(numbers,values,4)
    end
    CLOSE_VALVES(numbers)
elseif NUMVALVES == 3
    i=0;
    while i < CYCLES && GuIformat.STOP == 0
        i=i+1;
        values =  [1, 0, 0];
        if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
            vc = vc_set_bits_ac(vc, numbers, values);
            
            pause(INTERVAL);
        end
        pumpvis(numbers,values,4)
        % State 2
        values =  [1, 1, 0];
        if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
            vc = vc_set_bits_ac(vc, numbers, values);
            
            pause(INTERVAL);
        end
        pumpvis(numbers,values,4)
        % State 3
        values =  [0, 1, 0];
        if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
            vc = vc_set_bits_ac(vc, numbers, values);
            
            pause(INTERVAL);
        end
        pumpvis(numbers,values,4)
        % State 3
        values =  [0, 1, 1];
        if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
            vc = vc_set_bits_ac(vc, numbers, values);
            
            pause(INTERVAL);
        end
        pumpvis(numbers,values,4)
        % State 3
        values =  [0, 0, 1];
        if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
            vc = vc_set_bits_ac(vc, numbers, values);
            
            pause(INTERVAL);
        end
        pumpvis(numbers,values,4)
        % State 3
        values =  [1, 0, 1];
        if GuIformat.STOP == 0 && GuIformat.DEBUGMODE == 0
            vc = vc_set_bits_ac(vc, numbers, values);
            
            pause(INTERVAL);
        end
        pumpvis(numbers,values,4)
    end
    CLOSE_VALVES(numbers)
end
end

function pumpvis(numbers,values,count)
global GuIformat
for q = 1:count
    if values(q) == 1
        set(GuIformat.DirCon(numbers(q)+1),'BackgroundColor',GuIformat.color.o)
    else
        set(GuIformat.DirCon(numbers(q)+1),'BackgroundColor',GuIformat.color.c)
    end
end
end

%% LOGGING TOOL
function M = TSMessage(string,directory)
f = strcat(date,'.txt')
mkdir(directory,'logs')
message = strcat(datestr(now), string)
dlmwrite(fullfile(directory,'logs',f),message,'delimiter','','-append')
end
